//
// cmmi :: Cmm interpreter
//					(c) Nj
//
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <cmm/cmm.h>
#include <cmm/iopack.h>
#include <cmm/xpack.h>
#include <cmm/cmmmath.h>
#include <cmm/lex.h>

#include "load_path.h"

int InputReal (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    char buf[30] ;

    if (args == 0) {
	printf ("Input>> ") ;
    } else {
	printf ("%s", argp[0].sptr) ;
    }
    fgets (buf, 30, stdin) ;
    retval->type = V_REAL ;
    sscanf (buf, "%lf", &retval->value) ;
    return 0 ;
}

int _ICall (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    return 0 ;
}

int ICallTest (CmmInterp *cenv)
{
    cenv->AddBuiltin ("ICall", _ICall) ;
    return 0 ;
}

extern int __DUMP ;
extern int ___DUMP ;
extern int bcOn ;
extern int _GC1 ;
extern int _AR1 ;

main (int ac, char **av)
{
    FILE *fp ;
//  DynaCalc calc (8192, 256, 20) ;
    char *bp ;
    char *s ;
    char *buffer ;
    int c ;
    int show_source = 0 ;
    int install_libs = 1 ;
    int install_fio = 1 ;
    int interactive = 0 ;
    int i ;
    int bitest = 0 ;
    int cstart = 0 ;
    int stack_size = 32 ;
    int heap_size  = 64 ;
    int ac_on = 0 ;
    
    for (i = 1 ; i < ac ; i++) {
	s = av[i] ;
	if (*s != '-')
	    break ;
	if (!strcmp (s, "-i")) {
	    interactive = 1 ;
	} else if (!strncmp (s, "-dump", strlen(s))) {
	    __DUMP = 1 ;
	} else if (!strncmp (s, "-DUMP", strlen(s))) {
	    ___DUMP = 1 ;
	} else if (!strncmp (s, "-verbose", strlen(s))) {
	    show_source = 1 ;
	} else if (!strncmp (s, "-noinstall", strlen(s))) {
	    install_libs = 0 ;
	} else if (!strncmp (s, "-nofio", strlen(s))) {
	    install_fio = 0 ;
	} else if (!strncmp (s, "-bi", strlen(s))) {
	    bitest = 1 ;
	} else if (!strncmp (s, "-ac", strlen(s))) {
	    ac_on = 1 ;
	} else if (!strncmp (s, "-cs", strlen(s))) {
	    cstart = 1 ;
	} else if (!strncmp (s, "-gc0", strlen(s))) {
	    _GC1 = 0 ;
	} else if (!strncmp (s, "-ar0", strlen(s))) {
	    _AR1 = 0 ;
	} else if (!strncmp (s, "-heap", strlen(s))) {
	    i++ ;
	    if (i >= ac) {
		fprintf (stderr, "-heap option requires a heap size(Kbytes) as a next argument\n") ;
		exit (1) ;
	    }
	    heap_size = atoi(av[i]) ;
	} else if (!strncmp (s, "-stack", strlen(s))) {
	    i++ ;
	    if (i >= ac) {
		fprintf (stderr, "-stack option requires a heap size(Kbytes) as a next argument\n") ;
		exit (1) ;
	    }
	    stack_size = atoi(av[i]) ;
	}
    }
    if (!interactive && i >= ac) {
	fprintf (stderr, "usage: %s file\n", av[0]) ;
	exit (1) ;
    }
    CmmInterp calc (stack_size * 1024, heap_size * 1024) ;
    calc.Execute (PATHCONF) ;
    if (interactive) {
	buffer = new char[134] ;
	
	while (1) {
	    printf ("input expression >> ") ;
	    fgets (buffer, 134, stdin) ;
	    calc.Execute (buffer) ;
	    if (feof(stdin))
		break ;
	}
	exit (0) ;
    } else {
	struct stat st ;
	
	calc.AddBuiltin ("input", InputReal) ;
	if (install_libs || install_fio) {
	    InstallIOPack (&calc) ;
	}
	if (install_libs) {
	    InstallLex (&calc) ;
#ifndef MSVC_2
	    InstallX (&calc) ;
#endif
	    InstallMath(&calc) ;
	}
	calc.CommandArg (ac - i, av + i) ;
	
	fp = fopen (av[i], "r");
	if (!fp) {
	    fprintf (stderr, "Cannot read file %s\n", av[i]) ;
	    exit (1) ;
	}
	fstat ((int)fileno(fp), &st) ;
	
	buffer = new char [st.st_size + 1] ;
	
	for (bp = buffer ; (c = getc(fp)) != EOF ; bp++) {
	    if (show_source)
		putchar (c) ;
	    *bp = c ;
	}
	*bp = 0 ;
	calc.Execute (buffer) ;
	// calc.ShowWorkVars () ;
	if (cstart) {
	    Value ret ;
	    calc.Call ("main", NULL, NULL, NULL, 0, &ret) ;
	}
    }
}


