//----------------------------------------------------------------
// cmmint.cc : AvP[Vgݍݗp Cmm C^[v^ 
//					(c) Nj 
//----------------------------------------------------------------
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/param.h>

#ifdef sony_news
#include <sys/file.h>
#endif

#ifdef linux
#include <sys/file.h>
#endif

#include <sys/stat.h>
#include <ctype.h>

#ifdef MSVC_2
#include <io.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <dlfcn.h>

#define CMM_INTERNAL
#include <cmm/symbol.h>
#include <cmm/class.h>
#include <cmm/cmm.h>

// In linux standard ctype macros do not work correctly.
// if a value of char is lager than or equal to 0x80. 
#undef isspace
#undef isdigit

#define isspace(c) (((c) == ' ')||((c) == '\t')||((c) == '\n')||((c)=='\r'))
#define isdigit(c) (((c)>='0') && ((c)<='9'))

#ifndef EUC
#define iskanji(c)      ((unsigned char)(c) >= 0x80 && (unsigned char)(c) <= 0x9f ||\
			 (unsigned char)(c) >= 0xe0 && (unsigned char)(c) <= 0xef)
#else
#define iskanji(c)	((unsigned char)c & 0x80)
#endif

#define isoctdigit(c) (((c)>='0') && ((c)<='7'))

#define ishexdigit(c) ((((c)>='0') && ((c)<='9'))\
		       ||((c)>='a' && ((c)<='f'))\
		       ||((c)>='A' && ((c)<='F')))

//---------------------------------------------------------------- 
// G[bZ[W 
//---------------------------------------------------------------- 
char *CmmInterp::errorMes[] = {
    "No error",
    "Lex error",
    "Syntax error",
    "Divison by 0",
    "Invalid work variable",
    "External variable error",
    "No external parser",
    "Already defined",
    "Too many funcs",
    "Undefined identifier",
    "Stack overflcow",
    "Invalid string",
    "Not enough memory",
    "Invalid expression",
    "Invalid string operation",
    "Cannot load file",
    "undefined class",
    "undefined method",
    "undefined member",
    "invalid array index",
    "invalid object",
    "cannot access private member",
    "bad function or method",
    "invalid member",
    "Compiler not installed",
    "invalid new",
    "invalid super class",
    "function call error",
    "method call error",
    "cannot load package",
    "too many creator",
} ;

//----------------------------------------------------------------
// \e[u 
//----------------------------------------------------------------
CmmInterp::ResWordTable CmmInterp::reservedWords[] = {
	{ "break",    T_Break    },
        { "catch",    T_Catch	 },
	{ "class",    T_Class    },
	{ "continue", T_Continue },
	{ "else",     T_Else     },
	{ "eval",     T_Eval     },
	{ "exit",     T_Exit	 },
	{ "finally",  T_Finally  },
	{ "for",      T_For      },
	{ "func",     T_Func     },
	{ "hidden",   T_Hiden	 },
	{ "hiden",    T_Hiden	 },
	{ "if",       T_If       },
	{ "load",     T_Load     },
	{ "macro",    T_Macro    },
	{ "method",   T_Method   },
	{ "new",      T_New      },
	{ "package",  T_Package  },
	{ "pause",    T_Pause	 },
	{ "private",  T_Private  },
	{ "public",   T_Public   },
	{ "return",   T_Return   },
	{ "self",     T_Self     },
	{ "static",   T_Static   },
	{ "this",     T_This	 },	
    	{ "throw",    T_Throw	 },
	{ "try",      T_Try	 },
	{ "var",      T_Vardef   },
	{ "void",     T_Void     },
	{ "while",    T_While    },
} ;

#ifndef MSVC_2
extern "C" {
    int close (int) ;
} ;
#endif

int CmmInterp::CommandArg (int ac, char **av)
{
    Value *vp ;
    Value x ;
    int i ;

    AddGlobalVar ("argc", ac) ;
    if (heap_area.AllocArray (ac, &varstack, &vp) < 0) {
	return -1 ;
    }
    for (i = 0 ; i < ac ; i++) {
	vp[i] = av[i] ;
    }
    x.InitArr (vp, ac) ;
    AddGlobalVar ("argv", x) ;
    return 0 ;
}

//----------------------------------------------------------------
// gݍ݊֐ 
// Cmm Builtin Functions
//	currently available
//		print,	is_array, is_string, is_number, is_real,
//		is_integer, is_instance, is_class, is_function,
//		is_void, to_int, to_real, to_string, length,
//		system, mkarray, substr, feval, car, cdr,
//		show_class_spec, show_instance, char, getenv,
//		assoc, assocv, boundp, perror, configure
//	     <for debugging>	
//		stack_dump, heap_dump
//----------------------------------------------------------------
static int _Print (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    int i ;

    for (i = 0 ; i < args ; i++) {
	argp[i].Print() ;
    }
    if (args == 0)
	retval->Init() ;
    else
	*retval = argp[args-1] ;
    return NORMAL ;
}

static int _PrintLn (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    _Print (cenv, args, argp, retval) ;
    printf ("\n") ;
    return NORMAL ;
}

// gݍ݊֐ is_array:  z̏ꍇu^v 
static int _IsArray (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    *retval = argp[0].IsArray() ? I_TRUE : I_FALSE ;
    return NORMAL ;
}

// gݍ݊֐ is_string:  ̏ꍇu^v 
static int _IsString (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    *retval = argp[0].IsString() ? I_TRUE : I_FALSE ;
    return NORMAL ;
}

// gݍ݊֐ is_number:  l( or )̏ꍇu^v 
static int _IsNumber (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    *retval = argp[0].IsNumber() ? I_TRUE : I_FALSE ;
    return NORMAL ;
}

// gݍ݊֐ is_real: ̏ꍇu^v 
static int _IsReal (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    *retval = (argp[0].IsReal()) ? I_TRUE : I_FALSE ;
    return NORMAL ;
}

// gݍ݊֐ is_integer: ̏ꍇu^v 
static int _IsInteger (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    *retval = (argp[0].IsInteger()) ? I_TRUE : I_FALSE ;
    return NORMAL ;
}

// gݍ݊֐ is_instance: CX^X̏ꍇu^v 
static int _IsInstance (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    *retval = (argp[0].IsInstance()) ? I_TRUE : I_FALSE ;
    return NORMAL ;
}

// gݍ݊֐ is_class: NX̏ꍇu^v 
static int _IsClass (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    *retval = (argp[0].IsClass()) ? I_TRUE : I_FALSE ;
    return NORMAL ;
}

// gݍ݊֐ is_function: ֐̏ꍇu^v 
static int _IsFunction (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    *retval = (argp[0].IsContext() || argp[0].IsBuiltin()) ? I_TRUE : I_FALSE ;
    return NORMAL ;
}

// gݍ݊֐ is_void: void ̏ꍇu^v 
static int _IsVoid (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    *retval = argp[0].IsVoid() ? I_TRUE : I_FALSE ;
    return NORMAL ;
}

// gݍ݊֐ is_void: V{̏ꍇu^v 
static int _IsSymbol (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    *retval = argp[0].IsSymbol() ? I_TRUE : I_FALSE ;
    return NORMAL ;
}

// gݍ݊֐ to_int: ւ̃f[^ϊ 
static int _ToInt (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    *retval = argp[0].ForceInt() ;
    return NORMAL ;
}

// gݍ݊֐ to_real: ւ̃f[^ϊ 
static int _ToReal (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    *retval = argp[0].ForceReal() ;
    return NORMAL ;
}

// gݍ݊֐ to_string: ւ̃f[^ϊ 
static int _ToString (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    char *ss ;

    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    if (argp[0].IsSymbol()) {
	ss = cenv->heap_area.AllocString (argp[0].symbol->symbol, &cenv->varstack) ;
	*retval = ss ;
    } else if (argp[0].IsString()) {
	ss = cenv->heap_area.AllocString (argp[0].sptr, &cenv->varstack) ;
	*retval = ss ;
    } else {
	char *s = argp[0].ForceString () ;
	ss = cenv->heap_area.AllocString (s, &cenv->varstack) ;
	if (!ss) {
	    return -1 ;
	}
	*retval = ss ;
    }
    return NORMAL ;
}

// gݍ݊֐ to_symbol: Symbol ւ̃f[^ϊ
static int _ToSymbol (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    Symbol *sym ;
    
    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    if (argp[0].IsString()) {
	sym = cenv->symbolTable->GetSymbol (argp[0].sptr) ;
    } else if (argp[0].IsSymbol()) {
	sym = argp[0].symbol ;
    } else {
	return cenv->ThrowSystemException (cenv->typeMismatchException) ;
    }
    *retval = sym ;
    return NORMAL ;
}

// gݍ݊֐ length: ̕A܂́Az̗vfԂ 
static int _Length (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    int st ;

    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    if (argp[0].IsString()) {
	*retval = (int)strlen (argp[0].sptr) ;
    } else if (argp[0].IsArray()) {
	*retval = argp[0].arr.numelems ;
    } else {
	return cenv->ThrowSystemException (cenv->typeMismatchException) ;
    }
    return NORMAL ;
}

// gݍ݊֐ system : OR}h̎s 
static int _System (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    int i ;
    int len ;
    
    if (args < 1)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    for (len = i = 0 ; i < args ; i++) {
	int slen = strlen (argp[i].ForceString()) ;
	if (slen == 0)
	    continue ;
	len += (slen + 1) ;
    }
    char *ss = cenv->heap_area.AllocSegment (len, &cenv->varstack) ;
    if (!ss)
	return -1 ;
    ss[0] = '\0' ;
    for (i = 0 ; i < args ; i++) {
	char *s = argp[i].ForceString() ;
	if (strlen (s) == 0)
	    continue ;
	if (i > 0)
	    strcat (ss, " ") ;
	strcat (ss, s) ;
    }
    Value r ;
    r = (int)system (ss) ;
    *retval = r ;
    return NORMAL ;
}

static int _MkArray (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    Value *ap ;
    Value xx ;
    Value x ;
    int nelems ;
    int resv ;

    if (args == 1 && argp[0].IsNumber()) {
	nelems = argp[0].ForceInt() ;
	if (cenv->heap_area.AllocArray (nelems, &cenv->varstack, &ap) < 0) {
	    return -1 ;
	}
	x.InitArr (ap, nelems) ;
    } else if (args == 2 && argp[0].IsNumber() && argp[1].IsNumber()) {
	nelems = argp[0].ForceInt () ;
	resv   = argp[1].ForceInt () ;
	x = cenv->heap_area.AllocArray (nelems, resv, &cenv->varstack) ;
	if (x.IsVoid())
	    return -1 ;
    } else {
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    }
    *retval = x ;
    return NORMAL ;
}

static int _SubStr (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    int from, len ;
    Value xx ;
    int i ;

    if (!argp[0].IsString())
	return cenv->ThrowSystemException (cenv->typeMismatchException) ;
    if (!argp[1].IsNumber())
	return cenv->ThrowSystemException (cenv->typeMismatchException) ;
    if (!argp[2].IsNumber())
	return cenv->ThrowSystemException (cenv->typeMismatchException) ;

    from = argp[1].ForceInt() ;
    len  = argp[2].ForceInt() ;

    if (from >= strlen (argp[0].sptr)) {
	retval->Init () ;
	return NORMAL ;
    }
    if (strlen (argp[0].sptr + from) < len) {
	len = strlen (argp[0].sptr + from) ;
	if (len <= 0) {
	    retval->Init () ;
	    return NORMAL ;
	}
    }
    if (!(xx = cenv->heap_area.AllocSegment (len+1, &cenv->varstack)))
	return -1 ;
    for (i = 0 ; i < len && argp[0].sptr[from] ; from++, i++)
	xx.sptr[i] = argp[0].sptr[from] ;
    xx.sptr[i] = '\0' ;
    *retval = xx ;
    return NORMAL ;
}

static int _Eval (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    int st ;

    if (argp[0].IsString()) {
	st = cenv->EvalString (argp[0].sptr) ;
    } else if (argp[0].IsSymbol()) {
	st = cenv->EvalString (argp[0].symbol->symbol) ;
    } else {
	return cenv->ThrowSystemException (cenv->typeMismatchException) ;
    }
    *retval = cenv->varstack.Pop() ;
    return st ;
}

static int _Car (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args <= 0) {
	retval->Init() ;
	return NORMAL ;
    }
    if (!argp[0].IsArray())
	retval->Init() ;
    cenv->heap_area.CopyValue (&argp[0].arr.arrp[0], &cenv->varstack, retval) ;
    return NORMAL ;
}

static int _Cdr (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    int arrp = 0 ;
    int nelems ;
    int n = 1 ;

    if (args <= 0) {
	retval->Init () ;
	return NORMAL ;
    }
    if (argp[0].IsNumber() || argp[0].IsString()) {
	n = argp[0].ForceInt() ;
	if (n < 1)
	    n = 1 ;
	arrp = 1 ;
    } else {
	n = 1 ;
    }
    if (!argp[arrp].IsArray()) {
	retval->Init () ;
    } else {
	int i, j ;
	Value *vp ;
	
	nelems = argp[arrp].arr.numelems - n ;
	if (nelems < 0)
	    nelems = 0 ;
	if (cenv->heap_area.AllocArray (nelems, &cenv->varstack, &vp) < 0) {
	    return -1 ;
	}
	for (i = 0, j = n ; i < nelems ; i++, j++) {
	    cenv->heap_area.CopyValue (&argp[arrp].arr.arrp[j], &cenv->varstack, &vp[i]) ;
	}
	retval->InitArr (vp, nelems) ;
    }
    return NORMAL ;
}

static int _ShowClassSpec (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    int i ;

    for (i = 0 ; i < args ; i++) {
	if (argp[i].IsClass()) {
	    argp[i].classp->ShowSpec () ;
	} else if (argp[i].IsInstance()) {
	    argp[i].instance->ShowValue () ;
	} else {
	    Value *classp ;
	    classp = cenv->FixSpecialClass (&argp[i]) ;
	    if (!classp) {
		printf ("Not a class\n") ;
	    } else {
		classp->classp->ShowSpec () ;
	    }
	}
    }
    return NORMAL ;
}

static int _ShowInstance (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    int i ;

    for (i = 0 ; i < args ; i++) {
	if (argp[i].IsInstance()) {
	    argp[i].instance->ShowValue () ;
	}
    }
    *retval = 0 ;
    return NORMAL ;
}

static int _CharValue (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args < 2) {
	retval->Init () ;
	return NORMAL ;
    }
    if (!argp[0].IsString () || !argp[1].IsNumber ()) {
	retval->Init () ;
	return NORMAL ;
    }
    int slen = strlen (argp[0].sptr) ;
    int index = argp[1].ForceInt () ;
    if (index < 0 || index >= slen) {
	retval->Init () ;
	return NORMAL ;
    }
    *retval = (int)argp[0].sptr[index] ;
    return NORMAL ;
}

extern char **environ ;

static int _GetEnv (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args <= 0) {
	Value envarr ;
	Value *envp ;
	int   i, j ;
	int   nenvs ;

	for (nenvs = 0 ; environ[nenvs] ; nenvs++)
	    ;
	envarr = cenv->heap_area.NewArray (nenvs, &cenv->varstack) ;
	if (envarr.IsVoid()) {
	    retval->Init () ;
	    return NORMAL ;
	}
	envp = cenv->varstack.TmPush (envarr) ;

	for (i = 0 ; i < nenvs ; i++) {
	    char *s = environ[i] ;
	    char *sp = strchr (s, '=') ;
	    char *ename ;
	    Value aenv ;
	    Value *aenvp ;
	    char *envval ;

	    if (!sp)
		continue ;
	    aenv = cenv->heap_area.NewArray (2, &cenv->varstack) ;
	    if (aenv.IsVoid()) {
		cenv->varstack.Pop () ;
		retval->Init () ;
		return NORMAL ;
	    }
	    aenvp = cenv->varstack.TmPush (aenv) ;
	    ename = cenv->heap_area.AllocSegment (sp - s + 1, &cenv->varstack) ;
	    for (j = 0 ; s[j] != '=' ; j++) {
		ename[j] = s[j] ;
	    }
	    ename[j] = '\0' ;
	    aenvp->arr.arrp[0] = ename ;
	    envval = cenv->heap_area.AllocString (sp+1, &cenv->varstack) ;
	    aenvp->arr.arrp[1] = envval ;

	    envp->arr.arrp[i] = aenvp->arr ;
	    cenv->varstack.Pop () ;
	}
	*retval = cenv->varstack.Pop () ;
	return NORMAL ;
    } else if (!argp[0].IsString()) {
	retval->Init () ;
    } else {
	char *eval ;
	if (!(eval = getenv (argp[0].sptr))) {
	    retval->Init () ;
	} else {
	    *retval = cenv->heap_area.AllocString (eval, &cenv->varstack) ;
	}
    }
    return NORMAL ;
}

static int _Assoc (CmmInterp *cenv, int nargs, Variable *argp, Value *retp)
{
    if (nargs != 2 || !argp[1].IsArray()) {
	return cenv->ThrowSystemException (cenv->typeMismatchException) ;
    }
    int i ;
    Value *alist = &argp[1] ;
    for (i = 0 ; i < alist->arr.numelems ; i++) {
	Value *ap = &alist->arr.arrp[i] ;
	if (!ap->IsArray()) {
	    continue ;
	}
	if (ap->arr.arrp[0] == argp[0]) {
	    *retp = ap->arr ;
	    return NORMAL ;
	}
    }
    retp->Init () ;
    return NORMAL ;
}

static int _Assocv (CmmInterp *cenv, int nargs, Variable *argp, Value *retp)
{
    if (nargs != 2 || !argp[1].IsArray()) {
	return cenv->ThrowSystemException (cenv->typeMismatchException) ;
    }
    int i ;
    Value *alist = &argp[1] ;
    for (i = 0 ; i < alist->arr.numelems ; i++) {
	Value *ap = &alist->arr.arrp[i] ;
	if (!ap->IsArray()) {
	    continue ;
	}
	if (ap->arr.arrp[0] == argp[0]) {
	    *retp = ap->arr.arrp[1] ;
	    return NORMAL ;
	}
    }
    retp->Init () ;
    return NORMAL ;
}

static int _Boundp (CmmInterp *cenv, int nargs, Variable *argp, Value *retp)
{
    Symbol *sym ;

    if (nargs != 1) {
	retp->Init () ;
	return NORMAL ;
    }
    retp->Init () ;
    if (argp[0].IsString()) {
	sym = cenv->symbolTable->GetSymbol(argp[0].sptr) ;
    } else if (argp[0].IsSymbol()) {
	sym = argp[0].symbol ;
    } else {
	return cenv->ThrowSystemException (cenv->typeMismatchException) ;
    }
    if (cenv->varstack.LookupVar (sym)) {
	*retp = 1 ;
    }
    return NORMAL ;
}

static int _BoundpInFrame (CmmInterp *cenv, int nargs, Variable *argp, Value *retp)
{
    if (nargs != 1) {
	retp->Init () ;
	return NORMAL ;
    }
    if (!argp[0].IsString()) {
	retp->Init () ;
	return NORMAL ;
    }
    if (cenv->varstack.LookupVarInFrame (cenv->symbolTable->GetSymbol(argp[0].sptr))) {
	*retp =1 ;
    }
    return NORMAL ;
}

static int _Perror (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args == 1 && argp[0].IsString()) {
	perror (argp[0].sptr) ;
    } else {
	perror ("") ;
    }
    *retval = 0 ;
    return NORMAL ;
}

static int _Configure (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args < 2 || !argp[0].IsSymbol())
	return NORMAL ;

    if (argp[0].symbol == cenv->symbolTable->GetSymbol ("heap")) {
	int kbytes = argp[1].ForceInt () ;
	cenv->heap_area.Resize (kbytes * 1024, &cenv->varstack) ;
	return NORMAL ;
    }
    return NORMAL ;
}

static int _GarbageCollect (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args == 0) {
	cenv->heap_area.GarbageCollect (&cenv->varstack) ;
    } else {
	cenv->heap_area.GarbageCollect ( &cenv->varstack, argp[0].ForceInt ()) ;
    }
    return NORMAL ;
}

static int _GCSweep (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    cenv->heap_area.GCSweep (&cenv->varstack) ;
    return NORMAL ;
}

static int _MarkStack (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    cenv->heap_area.DoMark (&cenv->varstack, 1) ;
    return NORMAL ;
}

//----------------------------------------------------------------
// built in functions for system maintainance and debugging
//----------------------------------------------------------------
static int _StackDump (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args >= 1) {
	int bottom = argp[0].ForceInt () ;
	cenv->varstack.Dump  ("DUMP:: varstack", bottom) ;
    } else {
	cenv->varstack.Dump  ("DUMP:: varstack") ;
    }
    retval->Void() ;
    return NORMAL ;
}

static int _SymbolDump (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    cenv->symbolTable->Dump () ;
    retval->Void() ;
    return NORMAL ;
}

static int _HeapDump (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    if (args >= 1) {
	cenv->heap_area.BinDump() ;
    } else {
	printf ("DUMP HEAP") ;
	cenv->heap_area.Dump () ;
    }
    return NORMAL ;
}

static int _HeapInfo (CmmInterp *cenv, int args, Variable *argp, Value *retval)
{
    printf ("DUMP HEAP") ;
    cenv->heap_area.Info () ;
    return NORMAL ;
}

//----------------------------------------------------------------
// BuiltIn method for Object class
//----------------------------------------------------------------
int _IsInstanceOf (CmmInterp *cenv, Value *thisp, int nargs, Variable *argp, Value *retp)
{
    if (nargs != 2 || !argp[1].IsClass())
	return cenv->ThrowSystemException (cenv->typeMismatchException) ;

    Value *classvp ;
    if (thisp->IsInstance()) {
	if (thisp->instance->FindClass (NULL,
					argp[1].classp->classnamep->sym,
					&classvp))
	    *retp = *classvp ;
	else
	    retp->Init () ;
    } else if (thisp->IsClass()) {
	retp->Init () ;
    } else {
	Value *classp = cenv->FixSpecialClass (thisp) ;
	if (classp->classp->FindClass (argp[1].classp->classnamep->sym,
				       &classvp))
	    *retp = *classvp ;
	else
	    retp->Init () ;
    }
    return NORMAL ;
}

int _Class (CmmInterp *cenv, Value *thisp, int nargs, Variable *argp, Value *retp)
{
    Value *classp ;

    if (thisp->IsInstance()) {
	classp = thisp->instance->classp->classnamep ;
    } else if (thisp->IsClass()) {
	classp = thisp ;
    } else {
	classp = cenv->FixSpecialClass (thisp) ;
    }
    *retp = *classp ;
    return NORMAL ;
}

int _HasMember (CmmInterp *cenv, Value *thisp, int nargs, Variable *argp, Value *retp)
{
    Value *varp ;
    Value *classvp ;
    VarType vtype ;
    int   index ;
    Symbol *member_sym ;

    if (nargs != 2)
	return cenv->ThrowSystemException (cenv->argNumberException) ;
    if (argp[1].IsString()) {
	member_sym = cenv->symbolTable->GetSymbol (argp[1].sptr) ;
    } else if (argp[1].IsSymbol()) {
	member_sym = argp[1].symbol ;
    } else {
	return cenv->ThrowSystemException (cenv->typeMismatchException) ;
    }

    if (thisp->IsInstance()) {
	varp = thisp->instance->FindMember (NULL, member_sym, &classvp, &vtype, &index) ;
    } else if (thisp->IsClass()) {
	varp = thisp->classp->FindMethodOrStatic (member_sym, &vtype) ;
    } else {
	Value *classp = cenv->FixSpecialClass (thisp) ;
	varp = thisp->classp->FindMethodOrStatic (member_sym, &vtype) ;
    }
    if (varp) {
	switch (vtype) {
	  case VT_Public:
	    *retp = cenv->symbolTable->GetSymbol ("public") ; break ;
	  case VT_Private:
	    *retp = cenv->symbolTable->GetSymbol ("private") ; break ;
	  case VT_ClassVar:
	    *retp = cenv->symbolTable->GetSymbol ("static") ; break ;
	  case VT_Method:
	    *retp = cenv->symbolTable->GetSymbol ("method") ; break ;
	  case VT_Hiden:
	    *retp = cenv->symbolTable->GetSymbol ("hiden") ; break ;
	  case VT_BiMethod:
	    *retp = cenv->symbolTable->GetSymbol ("builtin_method") ; break ;
	  case VT_BiHiden:
	    *retp = cenv->symbolTable->GetSymbol ("builtin_hiden") ; break ;
	}
    } else {
	retp->Init () ;
    }
    return NORMAL ;
}

int _ShowPosition (CmmInterp *cenv, Value *thisp, int nargs, Variable *argp, Value *retp)
{
    char *mes = NULL ;
    if (nargs == 2) {
	if (!argp[1].IsString())
	    return cenv->ThrowSystemException (cenv->typeMismatchException) ;
	mes = argp[1].sptr ;
    }
    thisp->context.PrintError (mes) ;
    return NORMAL ;
}

static char **GetArgv (char *str, int *argcp)
{
    char **argv ;
    char *s ;
    char *se ;
    char *sp ;
    int argc ;
    int ac ;
    
    for (argc = 0, s = str ; *s ; ) {
	while (*s && isspace (*s))
	    s++ ;
	if (!*s)
	    break ;
	argc++ ;
	while (*s && !isspace (*s))
	    s++ ;
    }
    if (argc == 0)
	return NULL ;
    argv = new char *[argc+1] ;
    argv[argc] = NULL ;
    for (ac = 0, s = str ; *s ; s = se) {
	while (*s && isspace (*s))
	    s++ ;
	for (se = s ; *se && !isspace (*se) ; se++)
	    ;
	argv[ac] = new char [se-s+1] ;
	sp = argv[ac] ;

	while (s < se)
	    *sp++ = *s++ ;
	*sp = '\0' ;
	ac++ ;
    }
    *argcp = argc ;
    return argv ;
}

static void RemoveArgv (char **argv, int argc)
{
    int i ;
    for (i = 0 ; i < argc ; i++)
	delete argv[i] ;
    delete argv ;
}

int CmmInterp::Debug ()
{
    char comm[128] ;
    char line[1024] ;
    char **argv = NULL ;
    int argc = 0 ;
    int i ;
    int slen ;

    while (1) {
	printf ("command (type 'c' to Continue) >> ") ;
	fgets (comm, 1024, stdin) ;
	slen = strlen (comm) ;
	if (comm[slen-1] == '\n')
	    comm[slen-1] = '\n' ;
	if (argv)
	    RemoveArgv (argv, argc) ;
	argv = GetArgv (comm, &argc) ;
	if (!argv)
	    continue ;
#define EQ(s) !strncmp(argv[0], s, strlen(argv[0]))
	if (EQ ("println")) {
	    for (i = 1 ; i < argc ; i++) {
		sprintf (line, "println ('%s = ', %s); ", argv[i], argv[i]) ;
		EvalString (line) ;
		varstack.VPop() ;
	    }
	} else if (EQ("continue")) {
	    printf ("continue program\n") ;
	    break ;
	} else if (EQ("do")) {
	    int slen = strlen (comm) ;

	    for (i = 0 ; i < slen && isspace (comm[i]) ; i++)
		;
	    if (i + 2 >= slen)
		continue ;
	    EvalString (comm + i + 2) ;
	    varstack.VPop () ;
	}
    }
    varstack.TmPush (0) ;
    return NORMAL ;
}

void CmmInterp::AddBuiltin (char *name, BuiltinFunc entry)
{
    Symbol *sym = symbolTable->GetSymbol(name) ;
    varstack.Push (sym, entry) ;
}

int CmmInterp::AddBiMethod (char *classname, char *method, BuiltinMethod entry)
{
    Value *vp ;
    Symbol *method_sym ;
    VarType vtype ;
    int slot ;
    
    vp = varstack.LookupVar (classname) ;
    if (!vp || !vp->IsClass()) {
	return -1 ;
    }
    method_sym = symbolTable->GetSymbol (method) ;
    if ((slot = vp->classp->FindMyEntry (method_sym, &vtype)) < 0) {
	vtype = VT_Method ;
	if ((slot = AllocMethodSlot (vp, method_sym, vtype)) < 0)
	    return -1 ;
    }
    if (vtype != VT_Method && vtype != VT_Hiden
	&& vtype != VT_BiMethod && vtype != VT_BiHiden)
    {
	return -1 ;
    }
    vp->classp->SetBuiltinMethod (slot, entry) ;
    return 0 ;
}

int CmmInterp::SetStaticMember (Symbol *class_sym, Symbol *member_sym, Value& v)
{
    Value *vp ;

    vp = varstack.LookupVar (class_sym) ;
    if (!vp || !vp->IsClass()) {
	return -1 ;
    }
    
    VarType vtype ;
    int slot ;
    if ((slot = vp->classp->FindMyEntry (member_sym, &vtype)) < 0) {
	return -1 ;
    }
    if (vtype != VT_ClassVar) {
	return -1 ;
    }
    vp->classp->SetStaticMember (slot, v) ;
    return 0 ;
}

Value *CmmInterp::AddGlobalVar (char *name)
{
    Value x ;

    x.Init() ;
    return AddGlobalVar (name, x) ;
}

Value *CmmInterp::AddGlobalVar (char *name, double val)
{
    return varstack.Push (symbolTable->GetSymbol(name), val) ;
}

Value *CmmInterp::AddGlobalVar (char *name, Value &v)
{
    return varstack.Push (symbolTable->GetSymbol(name), v) ;
}

Value *CmmInterp::AddGlobalVar (char *name, int iv)
{
    return varstack.Push (symbolTable->GetSymbol(name), iv) ;
}

char CmmInterp::builtInSources[] = "var __loadedModules = [] ;
var __loadedSources = [] ;
var __loadedPackages = [] ;
class Void : Object {
	method IsVoid () 1 ;
}
class Context : Object {
	method ShowPosition ;
	method IsContext () 1 ;
}
class Class : Object {
	method IsClass () is_class(this) ;
	method IsInstance () is_instance(this) ;
}
class Exception : Class {
	public message ;
	public pos ;
	method New (mes, pos) {
		if ($# == 1) {
			message = 'Exception' ;
			->pos = void ;
		} else if ($# == 2) {
			message = mes ;
			->pos = void ;
		} else {
			message = mes ;
			->pos = pos ;
		}
	}
}
class SystemException : Exception {
	method New (mes) : (mes) ;
}
class ArrayOutOfBoundsException : SystemException {
	method New (mes) : (mes) ;
}
class DivisionByZeroException : SystemException {
	method New (mes) : (mes) ;
}
class TypeMismatchException : SystemException {
	method New (mes) : (mes) ;
}
class ArgNumberException: SystemException {
	method New (mes) : (mes) ;
}
class PackageLoadException: SystemException {
	method New (mes) : (mes) ;
}
class FileLoadException: SystemException {
	method New (mes) : (mes) ;
}
class String : Object {
	method Length () length(this);
	method Concat (s) this + s ;
	method Format (wid, align) {
		var len = ->Length() ;
		if (len >= wid || $# == 2)
			return this ;
		var s = this ;
		var i ;
		var rest = wid - len ;
		if (align == `left) {
			return s + ' ' * rest ;
		} else if (align == `right) {
			return ' ' * rest + s ;
		} else if (align == `center) {
			var lrest = rest/2 ;
			var rrest = rest - lrest ;
			return ' ' * lrest
				+ s + ' ' * rrest ;
		}
		return s ;
	} ;
	method SubStr (from, len)
	{
	    var s ;
	    if ($# == 2)
		var len = this->Length () - from ;
	    s = substr (this, from, len) ;
	    if (!s)
		return '' ;
	    s ;
	}
	method ToInteger () to_int (this) ;
	method ToReal    () to_real (this) ;
	method ToSymbol () to_symbol (this) ;
	method ToString  () this ;
	method IsString  () 1 ;
}
class Array : Object {
	method Length () length(this) ;
	method Index (n) this[n] ;
	method Create (n1, n2) {
		if ($# == 1) {
			mkarray(0) ;
		} else if ($# == 2) {
			if (n1 < 0) return mkarray(0) ;
			return mkarray(n1) ;
		} else {
			if (n1 < 0) n1 = 0 ;
			if (n2 < n1) n2 = n1 ;
 			return mkarray(n1, n2) ;
		}
	}
	method ToArray () this ;
	method IsArray () 1 ;
}
class Integer : Object {
	method IsInteger () 1 ;
	method IsNumber  () 1 ;
	method Format (width, align, base)
	{
	    if ($# == 2) {{
		var align = `right ;
		var base = 10 ;
	    }} else if ($# == 3) {{
		var base = 10 ;
	    }} else if (base->IsString()) {
		base = if (base == `binary) 2
		else if (base == `octal) 8
		else if (base == `decimal) 10
		else if (base == `hexadecimal) 16
	        else 10 ;
	    }
	    if (base == 10) {
		ToString()->Format (width, align) ;
	    } else if (base == 16) {
		var xnum = '0123456789ABCDEF' ;
		var n = this ;
		var s = '' ;
		for ( ; n > 0; n /= base)
		    s = xnum->SubStr (n % base, 1) + s ;
		s->Format (width, align) ;
	    } else if (1 < base < 10) {
		var s = '' ;
		var n = this ;
		for ( ; n > 0 ; n /= base) {
		    s = (n % base)->ToString() + s ;
		}
		s->Format (width, align) ;
	    }
	}
	method ToString () to_string (this) ;
	method ToInteger () this ;
	method ToReal   () to_real   (this) ;
}
class Real : Object {
	method IsReal   () 1 ;
	method IsNumber () 1 ;
	method Format (width, prec, align)
	{
	    var intpart, realpart ;
	    if ($# == 3)
		var align = `right ;
	    intpart = ->ToInteger() ;
	    if (prec == 0)
		return intpart->ToString()
			->Format (width, align) ;
	    realpart = ((this - intpart)->ToString()
			+ '0' * width)
				->SubStr(0, prec + 2) ;
	    realpart = realpart->SubStr (2) ;
	    (intpart->ToString()+'.'+realpart)
			->Format (width, align) ;
	}
	method ToString () to_string(this);
	method ToInteger() to_int(this);
	method ToReal ()   this ;
}
class Symbol : Object {
	method IsSymbol () 1 ;
	method ToSymbol () this ;
	method ToString () to_string(this) ;
}
var arrayOutOfBoundsException = ArrayOutOfBoundsException->New ('Array index out of bounds') ;
var divisionByZeroException = DivisionByZeroException->New ('Division by 0') ;
var typeMismatchException = TypeMismatchException->New('Type mismatch') ;
var argNumberException    = ArgNumberException->New('Invalit Number of Arguments'); 
var fileLoadException	  = FileLoadException->New ('cannot load file') ;
var packageLoadException  = PackageLoadException->New ('cannot load package') ;
" ;

char CmmInterp::creatorName[] = "New" ;
char CmmInterp::nullCreator[] = "() {}" ;
char CmmInterp::disposerName[] = "Dispose" ;
char CmmInterp::exceptionClassName[] = "Exception" ;

void CmmInterp::InitEnv ()
{
    static char *initial_class = "class Object {
	method IsInstanceOf ;
        method HasMember ;
	method Class ;	
	method IsArray   () void ;
	method IsInteger () void ;
	method IsReal    () void ;
	method IsNumber  () void ;
	method IsString  () void ;
	method IsVoid    () void ;
	method IsInstance() void ;
	method IsClass   () void ;
	method IsContext () void ;
	method IsSymbol  () void ;
}
" ;

    argcnt = 0 ;
    argindex = -1 ;
    thisptr = NULL ;
    classptr = NULL ;
    errorCtx.text = NULL ;
    errorCtx.PC = 0 ;
    
    creatorSym	      = symbolTable->GetSymbol (creatorName) ;
    disposerSym       = symbolTable->GetSymbol (disposerName) ;
    exceptionClassSym = symbolTable->GetSymbol (exceptionClassName) ;

    varstack.Push ("print",      _Print) ;
    varstack.Push ("println",	 _PrintLn) ;
    varstack.Push ("is_array",   _IsArray) ;
    varstack.Push ("is_string",  _IsString) ;
    varstack.Push ("is_void",    _IsVoid) ;
    varstack.Push ("is_number",  _IsNumber) ;
    varstack.Push ("is_real",	 _IsReal) ;
    varstack.Push ("is_integer", _IsInteger) ;
    varstack.Push ("is_instance", _IsInstance) ;
    varstack.Push ("is_function", _IsFunction) ;
    varstack.Push ("is_class",    _IsClass) ;
    varstack.Push ("is_symbol",   _IsSymbol) ;
    varstack.Push ("to_int",	  _ToInt) ;
    varstack.Push ("to_integer",  _ToInt) ;
    varstack.Push ("to_real",	  _ToReal) ;
    varstack.Push ("to_string",	  _ToString) ;
    varstack.Push ("to_symbol",   _ToSymbol) ; 
    varstack.Push ("substr",     _SubStr) ;
    varstack.Push ("length",     _Length) ;
    varstack.Push ("mkarray",    _MkArray) ;
    varstack.Push ("feval",	 _Eval) ;
    varstack.Push ("car",	 _Car) ;
    varstack.Push ("cdr",	 _Cdr) ;
    varstack.Push ("show_class_spec", _ShowClassSpec) ;
    varstack.Push ("show_instance", _ShowInstance) ;
    varstack.Push ("system", _System) ;
    varstack.Push ("getenv", _GetEnv) ;
    varstack.Push ("char",   _CharValue) ;
    varstack.Push ("assoc",  _Assoc) ;
    varstack.Push ("assocv", _Assocv) ;
    varstack.Push ("boundp", _Boundp) ;
    varstack.Push ("perror", _Perror) ;
    varstack.Push ("configure", _Configure) ;

    varstack.Push ("gc", _GarbageCollect) ;
    varstack.Push ("sweep", _GCSweep) ;
    varstack.Push ("mark_stack", _MarkStack) ;

    varstack.Push ("heap_dump",  _HeapDump) ;
    varstack.Push ("heap_info",  _HeapInfo) ;
    varstack.Push ("stack_dump", _StackDump) ;
    varstack.Push ("symbol_dump",  _SymbolDump) ;

    max_namelen = 20 ;
    Value x ;
    x = heap_area.AllocString (max_namelen, &varstack) ;
    if (!x.sptr) {
	SetErrorCode (NOT_ENOUGH_MEMORY) ;
	return ;
    }
    namep = varstack.TmPush (x) ;
#if 0
    max_strlen = 128 ;
    x = heap_area.AllocString (max_strlen, &varstack) ;
    if (!x.sptr) {
	SetErrorCode (NOT_ENOUGH_MEMORY) ;
	return ;
    }
    stringp = varstack.TmPush (x) ;
#endif
    classRoot = NULL ;
    classClass = NULL ;
    // Initialize Object Class
    // ܂AׂẴNX̃[gƂȂ Object class 
    // C^[v^Ɏ
    Execute (initial_class) ;
    classRoot = varstack.LookupVar ("Object") ;
    classRoot->classp->superclass = NULL ; // No super class for Object class
    classRoot->classp->offset = 0 ;

    exec_mode = ExAcInterp ;
    InitBuiltinSource () ;
#ifdef LOAD_PATH
    Execute (LOAD_PATH) ;
#endif

    AddBiMethod ("Object", "IsInstanceOf", _IsInstanceOf) ;
    AddBiMethod ("Object", "HasMember",	   _HasMember) ;
    AddBiMethod ("Object", "Class",	   _Class) ;	
    AddBiMethod ("Context", "ShowPosition", _ShowPosition) ;
    // Setup Special Class 
    classClass     = varstack.LookupVar ("Class") ;
    intClass       = varstack.LookupVar ("Integer") ;
    realClass      = varstack.LookupVar ("Real") ;
    arrayClass     = varstack.LookupVar ("Array") ;
    stringClass    = varstack.LookupVar ("String") ;
    voidClass      = varstack.LookupVar ("Void") ;
    exceptionClass = varstack.LookupVar ("Exception") ;
    contextClass   = varstack.LookupVar ("Context") ;
    symbolClass    = varstack.LookupVar ("Symbol") ;
    arrayOutOfBoundsException = varstack.LookupVar ("arrayOutOfBoundsException") ;
    divisionByZeroException   = varstack.LookupVar ("divisionByZeroException") ;
    typeMismatchException     = varstack.LookupVar ("typeMismatchException") ;
    argNumberException	      = varstack.LookupVar ("argNumberException") ;  
    packageLoadException      = varstack.LookupVar ("packageLoadException") ;
    fileLoadException	      = varstack.LookupVar ("fileLoadException") ;	
    globalLim = varstack.Top () ;
}

void CmmInterp::InitBuiltinSource ()
{
    Execute (builtInSources) ;
}

int CmmInterp::SetSource (char *buf)
{
    prog = SetContext (buf, 0) ;
    lastPC = 0 ;
    max_namelen = 20 ;
    Value x ;
    x = heap_area.AllocString (max_namelen, &varstack) ;
    if (!x.sptr) {
	return SetErrorCode (NOT_ENOUGH_MEMORY) ;
    }
    namep = varstack.TmPush (x) ;
    varstack.SetFramePtr (varstack.StackPtr()) ;
    errorCode = NO_ERROR ;
    return 0 ;
}

int CmmInterp::Execute (char *buf)
{
    int status ;
    Value retval ;

    prog = SetContext (buf, 0) ;
    lastPC = 0 ;
    errorCode = NO_ERROR ;
    status = Program (&retval);
    if ((status < 0 && status != EXIT) || errorCode) {
	if (errorCtx.text) {
	    errorCtx.PrintError (errorMes[errorCode]) ;
	} else {
	    prog->PrintError (errorMes[errorCode]) ;
	}
    } else if (status == THROW) {
	PrintException (varstack.Top ()) ;
    }
    return status ;
}

void CmmInterp::PrintException (Value *exception)
{
    Value *mes ;
    Value *pos ;
    if (!exception->IsInstance()) {
	printf ("Internal error on Exception handling\n") ;
    } else {
	printf ("Terminated by %s::\n",
		exception->instance->classp->classnamep->sym->symbol) ;
	mes = exception->instance->FindMember (symbolTable->GetSymbol("message")) ;
	pos = exception->instance->FindMember (symbolTable->GetSymbol("pos")) ;
	if (pos && pos->IsContext() && pos->context.text)
	    pos->context.PrintError (mes->sptr) ;
	else
	    printf ("%s\n", mes->sptr) ;
    }
}

int CmmInterp::EvalString (char *string)
{
    Value xx ;
    Context *lastProgContext = prog ;
    int oldPC     = prog->GetPC() ;
    int oldLastPC = lastPC ;
    int oldSP     = varstack.StackPtr () ;
    int oldFP     = varstack.FramePtr () ;
    int status ;

    prog = SetContext (string, 0) ;
    lastPC = 0 ;

    varstack.SetFramePtr (varstack.StackPtr()) ;
    status = Program (&xx) ;
    if (status < 0 && status != EXIT) {
	prog->PrintError (errorMes[errorCode]) ;
    }
    SetErrorCode (0) ;
    varstack.SetStackPtr (oldSP) ;
    varstack.SetFramePtr (oldFP) ;
    if (status >= 0) {
	varstack.TmPush (xx) ;
    } else {
	varstack.TmPush () ;
    }
    prog  = lastProgContext ;
    prog->Set (oldPC) ;
    lastPC = oldLastPC ;
    return 0 ;
}

//----------------------------------------------------------------
// CmmInterp::Call 
//	AvP[V Cmm ֐/\bhĂяo߂̃T[ 
//	rX֐ 
//---------------------------------------------------------------- 
int CmmInterp::Call (char *func_or_method, char *instance, char *classname,
		    Value *args, int narg,
		    Value *ret)
{
    int i ;
    int st ;
    int framepsave = varstack.FramePtr () ;
    int stackpsave = varstack.StackPtr () ;
    Context *calladr       = NULL ;
    Value   *instancep     = NULL ;
    Class   *classp        = NULL ;
    Value   *entp 	   = NULL ;
    VarType vtype ;
    BuiltinFunc   builtin  = NULL ;
    BuiltinMethod bimethod = NULL ;
    Value	  *acfuncp = NULL ;
    int method = 0 ;
    Value *classnamep = NULL ;
    Value *thisp ;
    LocInfo loc ;
    int numargs = 0 ;
    Symbol *func_or_method_sym = symbolTable->GetSymbol (func_or_method) ;
    Symbol *instance_sym ; 

    if (instance) {
	Symbol *instance_sym = symbolTable->GetSymbol (instance) ; 
	instancep = varstack.LookupVar (instance_sym) ;
	if (!instancep->IsInstance() && !instancep->IsClass())
	    return SetErrorCode (INVALID_OBJECT) ;
	if (classname) {
	    if (!(classp = instancep->instance->FindClass
		  	     (NULL, symbolTable->GetSymbol(classname), &classnamep)))
		return SetErrorCode (INVALID_OBJECT) ;
	} else {
	    classp = instancep->instance->classp ;
	}
	if (!(entp = instancep->instance->FindMember (classp, func_or_method_sym, &vtype))) {
	    return SetErrorCode (UNDEFINED_MEMBER) ;
	}
	if (entp->IsBiMethod()) {
	    method++ ;
	    bimethod = entp->bimethod ;
	} else if (entp->IsContext()) {
	    if (entp->subtype == CTX_METHOD) {
		varstack.TmPush (entp->context) ;
		calladr = &(varstack.Top()->context) ;
	    } else {
		return SetErrorCode (INVALID_MEMBER) ;
	    }
	} else if (entp->IsArray()) {
	    if (vtype == VT_Method || vtype == VT_Hiden) {
		method++ ;
	    }
	    acfuncp = varstack.TmPush (entp->arr) ;
	} else {
	    return SetErrorCode (INVALID_MEMBER) ;
	}
	method++ ;
    } else {
	entp = varstack.LookupVar (func_or_method) ;
	if (entp->IsContext()) {
	    if (entp->subtype == CTX_FUNCTION) {
		varstack.TmPush (entp->context) ;
		calladr = &(varstack.Top()->context) ;
	    } else {
		return SetErrorCode (BAD_FUNCTION_OR_METHOD) ;
	    }
	} else if (entp->IsBuiltin()) {
	    builtin = entp->entry ;
	} else if (entp->IsArray()) {
	    acfuncp = varstack.TmPush (entp->arr) ;
	} else {
	    return SetErrorCode (BAD_FUNCTION_OR_METHOD) ;
	}
    }
    varstack.SetFramePtr (varstack.StackPtr()) ;
    if (method) {
	thisp = varstack.TmPush (instancep->instance) ;
    } else {
	thisp = NULL ;
    }
    for (i = 0 ; i < narg ; i++) {
	varstack.TmPush (args[i]) ;
    }
    numargs = narg + ((method) ? 1 : 0) ;
    Value x ;
    if (builtin) {
	st = (*builtin) (this, varstack.FrameSize(), varstack.GetFrame(), &x) ;
	if (st < 0)
	    return SetErrorCode (FUNCALL_ERROR) ;
    } else if (bimethod) {
	st = (*bimethod) (this, thisp, varstack.FrameSize(), varstack.GetFrame(), &x) ;
	if (st < 0)
	    return SetErrorCode (BUILTIN_CALL_ERROR) ;
    } else if (acfuncp) {
	if (!has_compiler) {
	    return SetErrorCode (COMPILER_NOT_INSTALLED) ;
	}
	st = AcCallForm (acfuncp, numargs, instancep, classnamep, &loc) ;
	x = varstack.VPop () ;
    } else {
	st = CallContext (calladr, numargs, instancep, classnamep, &loc) ;
	x = varstack.VPop () ;
    }
    if (st != EXIT && st != THROW) {
	// t[|C^AX^bN|C^̕A 
	varstack.SetFramePtr (framepsave) ;
	varstack.SetStackPtr (stackpsave) ;
	// ^[lZbg 
	*ret = x ;
    }
    return st ;
}

int CmmInterp::Call (Value *entp, Value *instancep,
		     Value *args, int narg, Value *ret)
{
    int i ;
    int st ;
    int framepsave = varstack.FramePtr () ;
    int stackpsave = varstack.StackPtr () ;
    Context *calladr       = NULL ;
    // Value   *instancep     = NULL ;
    VarType vtype ;
    BuiltinFunc   builtin  = NULL ;
    BuiltinMethod bimethod = NULL ;
    Value	  *acfuncp = NULL ;
    Value	  *classnamep = NULL ;
    int method = 0 ;
    Value *thisp ;
    LocInfo loc ;
    int numargs = 0 ;

    if (instancep) {
	classnamep = instancep->instance->classp->classnamep ;
	if (entp->IsBiMethod()) {
	    method++ ;
	    bimethod = entp->bimethod ;
	} else if (entp->IsContext()) {
	    if (entp->subtype == CTX_METHOD /* entp->context.IsMethod() */) {
		varstack.TmPush (entp->context) ;
		calladr = &(varstack.Top()->context) ;
	    } else {
		return SetErrorCode (INVALID_MEMBER) ;
	    }
	} else if (entp->IsArray()) {
	    if (vtype == VT_Method || vtype == VT_Hiden) {
		method++ ;
	    }
	    acfuncp = varstack.TmPush (entp->arr) ;
	} else {
	    return SetErrorCode (INVALID_MEMBER) ;
	}
	method++ ;
    } else {
	if (entp->IsContext()) {
	    if (entp->subtype == CTX_FUNCTION /* entp->context.IsFunction() */) {
		varstack.TmPush (entp->context) ;
		calladr = &(varstack.Top()->context) ;
	    } else {
		return SetErrorCode (BAD_FUNCTION_OR_METHOD) ;
	    }
	} else if (entp->IsBuiltin()) {
	    builtin = entp->entry ;
	} else if (entp->IsArray()) {
	    acfuncp = varstack.TmPush (entp->arr) ;
	} else {
	    return SetErrorCode (BAD_FUNCTION_OR_METHOD) ;
	}
    }
    varstack.SetFramePtr (varstack.StackPtr()) ;
    if (method) {
	thisp = varstack.TmPush (instancep->instance) ;
	numargs++ ;
    } else {
	    thisp = NULL ;
    }
    for (i = 0 ; i < narg ; i++) {
	varstack.TmPush (args[i]) ;
    }
    numargs = narg + ((method) ? 1 : 0) ;
    Value x ;
    if (builtin) {
	st = (*builtin) (this, varstack.FrameSize(), varstack.GetFrame(), &x) ;
	if (st < 0)
	    return SetErrorCode (FUNCALL_ERROR) ;
    } else if (bimethod) {
	st = (*bimethod) (this, thisp, varstack.FrameSize(), varstack.GetFrame(), &x) ;
	if (st < 0)
	    return SetErrorCode (METHODCALL_ERROR) ;
    } else if (acfuncp) {
	if (!has_compiler) {
	    return SetErrorCode (COMPILER_NOT_INSTALLED) ;
	}
	st = AcCallForm (acfuncp, numargs, instancep, classnamep, &loc) ;
	x = varstack.VPop () ;
    } else {
	st = CallContext (calladr, numargs, instancep, classnamep, &loc) ;
	x = varstack.VPop () ;
    }
    if (st != EXIT && st != THROW) {
	// t[|C^AX^bN|C^̕A 
	varstack.SetFramePtr (framepsave) ;
	varstack.SetStackPtr (stackpsave) ;
	// ^[lZbg 
	*ret = x ;
    }
    return st ;
}

int CmmInterp::CallMethod (Value *classp, Value *instancep, Value *entry,
			   Value *args,  int nargs, Value *retv)
{
    int i ;
    int st ;
    int framepsave = varstack.FramePtr () ;
    int stackpsave = varstack.StackPtr () ;
    Context *calladr       = NULL ;
    BuiltinMethod bimethod = NULL ;
    Value	  *acfuncp = NULL ;
    Value *thisp ;
    LocInfo loc ;
    int numargs = 0 ;

    if (entry->IsBiMethod()) {
	bimethod = entry->bimethod ;
    } else if (entry->IsContext()) {
	if (entry->subtype == CTX_METHOD /* entry->context.IsMethod() */) {
	    varstack.TmPush (entry->context) ;
	    calladr = &(varstack.Top()->context) ;
	} else {
	    return SetErrorCode (INVALID_MEMBER) ;
	}
    } else if (entry->IsArray()) {
	acfuncp = varstack.TmPush (entry->arr) ;
    } else {
	return SetErrorCode (INVALID_MEMBER) ;
    }

    varstack.SetFramePtr (varstack.StackPtr()) ;
    thisp = varstack.TmPush (instancep->instance) ;

    numargs = 1 + nargs ;
    for (i = 0 ; i < nargs ; i++) {
	varstack.TmPush (args[i]) ;
    }
    Value x ;
    if (bimethod) {
	st = (*bimethod) (this, thisp, varstack.FrameSize(), varstack.GetFrame(), &x) ;
	if (st < 0)
	    return SetErrorCode (METHODCALL_ERROR) ; 
    } else if (acfuncp) {
	if (!has_compiler) {
	    return SetErrorCode (COMPILER_NOT_INSTALLED) ;
	}
	st = AcCallForm (acfuncp, numargs, thisp, classp->classp->classnamep, &loc) ;
	x = varstack.VPop () ;
    } else {
	st = CallContext (calladr, numargs, thisp, classp->classp->classnamep, &loc) ;
	x = varstack.VPop () ;
    }
    if (st < 0) {
	if (errorCtx.text) {
	    errorCtx.PrintError (errorMes[errorCode]) ;
	} else {
	    prog->PrintError (errorMes[errorCode]) ;
	}
    }
    if (st != EXIT && st != THROW) {
	// t[|C^AX^bN|C^̕A 
	varstack.SetFramePtr (framepsave) ;
	varstack.SetStackPtr (stackpsave) ;
	// ^[lZbg 
	*retv = x ;
    }
    return st ;
}

#define ARRSIZE(arr) ((sizeof (arr))/(sizeof (arr[0])))

CmmInterp::CmmInterp (Variable *stack, int stacksize, char *heap, int heapsize,
		      StaticSymbolTable *symtbl = NULL)
{
    InitStorage (stack, stacksize, heap, heapsize, symtbl) ;
    Init () ;
    InitEnv () ;
}

CmmInterp::CmmInterp (int stacksize, int heapsize)
{
    InitStorage (stacksize, heapsize) ;
    Init () ;
    InitEnv () ;
}

void CmmInterp::InitStorage (int stacksize, int heapsize)
{
    globalLim = NULL ;
    symbolTable = new DynamicSymbolTable () ;
    varstack.Init (stacksize) ;
    heap_area.Init (heapsize) ;
}

void CmmInterp::InitStorage (Variable *stack, int stacksize, char *heap, int heapsize,
			     StaticSymbolTable *symtbl = NULL)
{
    globalLim = NULL ;
    if (symtbl)
	symbolTable = symtbl ;
    else
	symbolTable = new DynamicSymbolTable () ;
    varstack.Init (stack, stacksize) ;
    heap_area.Init (heap, heapsize) ;
}

void CmmInterp::Init ()
{
    int i ;
    Symbol *sym ;

    exec_mode = ExInterp ;
    max_namelen = 0 ;
    has_compiler = 0 ;

    for (i = 0 ; i < ARRSIZE (reservedWords) ; i++) {
	sym = symbolTable->GetSymbol (reservedWords[i].name) ;
	sym->SetAttr (SYM_RESERVED_WORD, (void *)reservedWords[i].token) ;
    }
    varstack.NotifySymbolTable (symbolTable) ;
    heap_area.NotifyCmmEnv (this) ;
}

int CmmInterp::SetErrorCode (int no)
{
    errorCode = no;
    return -1 ;
}

int CmmInterp::SetErrorCode (int no, Context& ctx)
{
    errorCode = no ;
    errorCtx  = ctx ;
    return -1 ;
}

int CmmInterp::AddStr (Value *vs, char *s)
{
    return AddStr (vs, s, strlen(s)) ;
}

int CmmInterp::Grow (Value *s, int len, int addlen)
{
    int newlen = len + addlen ;
    char *news ;
    int i ;

    news = heap_area.AllocString (newlen, &varstack) ;
    if (!news)
	return -1 ;
    for (i = 0 ; i < len ; i++) {
	news[i] = s->sptr[i] ;
    }
    news[i] = '\0' ;
    *s = news ;
    return 0 ;
}

int CmmInterp::CheckAndGrow (Value *vs, int numgrow)
{
    int segsize = heap_area.SegmentSize (vs) ;
    int i ;
    int newsize = strlen (vs->sptr) + numgrow + 1 ;
    char *news ;

    if (newsize < segsize)
	return 0 ;
    news = heap_area.AllocString (newsize + 30, &varstack) ;
    if (!news)
	return -1 ;
    for (i = 0 ; i < segsize ; i++)
	news[i] = vs->sptr[i] ;
    news[i] = '\0' ;
    *vs = news ;
    return 0 ;
}

int CmmInterp::AddStr (Value *vs, char *s, int addlen)
{
    int i, j ;

    if (CheckAndGrow (vs, addlen) < 0)
	return -1 ;
    for (i = strlen(vs->sptr), j = 0 ; j < addlen ; i++, j++) {
	vs->sptr[i] = s[j] ;
    }
    vs->sptr[i] = '\0' ;
    return 0 ;
}

int CmmInterp::AddStr (Value *vs, Context *ctx, int start, int end)
{
    int i, j ;
    int addlen = end - start ;

    if (CheckAndGrow (vs, addlen) < 0)
	return -1 ;
    for (i = strlen (vs->sptr), j = start ; j < end ; i++, j++) {
	vs->sptr[i] = ctx->text[j] ;
    }
    vs->sptr[i] = '\0' ;
    return 0 ;
}

int CmmInterp::AddStr (Value *vs, Value *sp)
{
    int addlen = strlen (sp->sptr) + 1 ;
    int i, j ;

    if (CheckAndGrow (vs, addlen) < 0)
	return -1 ;
    for (i = strlen (vs->sptr), j = 0 ; j < addlen ; i++, j++) {
	vs->sptr[i] = sp->sptr[j] ;
    }
    vs->sptr[i] = '\0' ;
    return 0 ;
}

int CmmInterp::AddStrQuoted (Value *vs, Value *sp)
{
    int i, j ;
    int slen = strlen(sp->sptr) + 1 ;
    int quotedlen = slen ;

    for (i = 0 ; i < slen ; i++) {
	if (sp->sptr[i] == '"')
	    quotedlen++ ;
    }
    if (CheckAndGrow (vs, quotedlen) < 0)
	return -1 ;
    for (i = strlen(vs->sptr), j = 0 ; j < slen ; j++, i++) {
	if (sp->sptr[j] == '"')
	    vs->sptr[i++] = '\\' ;
	vs->sptr[i] = sp->sptr[j] ;
    }
    vs->sptr[i] = '\0' ;
    return 0 ;
}

#define HEXVAL(c) ((('0'<=(c))&&((c)<='9')) ? ((c)-'0')\
		   :(('a'<=(c))&&((c)<='f')) ? ((c)-'a'+10)\
		   : ((c)-'A'+10))

//----------------------------------------------------------------
// CmmInterp::Lex --  
//----------------------------------------------------------------
CmmInterp::Token CmmInterp::Lex (LexInfo *lp)
{
    int c ;
    int c2 ;
    int is_symbol = 0 ;

    lastPC = prog->GetPC() ;
  again:
    while ((c = prog->GetC()) && isspace(c))
	;
    if (!c) {
	prog->Back(1) ;
	return T_Eof ;
    }
    c2 = prog->PeekC () ;
    if (c == '#' || c == '/' && c2 == '/') {
	// Rg shell  '#' ܂́Ac++  '//' 
	// # ́An߂͂Ȃ̂ǁAUNIX ŁA#! g悤ɂ邽߂ɒǉ 
	while ((c = prog->GetC()) && c != '\n')
	    ;
	if (c == '\n')
	    goto again ;
    }
#define CHKADV(c,c2,iftrue,iffalse) ((c != c2) ? iffalse : (prog->Adv(), iftrue))
    switch (c) {
      case '+':
	if (c2 == '+') { prog->Adv() ; return T_PP ; }
	if (c2 == '=') { prog->Adv() ; return T_AddAssign ; }
	return T_Plus ;
      case '-':
	if (c2 == '-') { prog->Adv() ; return T_MM ; }
	if (c2 == '>') { prog->Adv() ; return T_PointTo ; }
	if (c2 == '=') { prog->Adv() ; return T_SubAssign ; }
	return T_Minus ;
      case '*':
	return CHKADV (c2, '=', T_MultAssign, T_Mult) ;
      case '/':
	return CHKADV (c2, '=', T_DivAssign,  T_Div ) ;
      case '=':
	return CHKADV (c2, '=', T_Eq, T_Assign) ;
      case '!':
	return CHKADV (c2, '=', T_Neq, T_Not) ;
      case '^':
	return CHKADV (c2, '=', T_XorAssign, T_Xor) ;
      case '~':
	return T_BitRev ;
      case '<':
	if (c2 == '=') { prog->Adv() ; return T_Le ; }
	if (c2 == '<') { prog->Adv() ; c2 = prog->PeekC() ;
			 if (c2 == '=') { prog->Adv() ; return T_LshAssign ; }
			 return T_Lsh ; }
	return T_Lt ;
      case '>':
	if (c2 == '=') { prog->Adv() ; return  T_Ge ; }
	if (c2 == '>') { prog->Adv() ; c2 = prog->PeekC() ;
			 if (c2 == '=') { prog->Adv() ; return T_RshAssign ; }
			 return T_Rsh ; }
	return T_Gt ;
      case '|':
	if (c2 == '|') { prog->Adv() ; return T_Or ; }
	if (c2 == '=') { prog->Adv() ; return T_OrAssign ; }
	return T_Bor ;
      case '&':
        if (c2 == '&') { prog->Adv() ; return T_And ; }
        if (c2 == '=') { prog->Adv() ; return T_AndAssign ; }
	return T_Band ;
      case '$':
	if      (c2 == '#') { prog->Adv() ; return T_ArgCnt  ; }
	else if (c2 == '*') { prog->Adv() ; return T_ArgList ; }
	else if (c2 == '?') { prog->Adv() ; return T_BoundArg ; }
	else if (c2 == '$') { prog->Adv() ; return T_Position ; } 
	else                           { return T_ArgPrefix ; }
      case '%':
	return CHKADV (c2, '=', T_ModAssign, T_Mod) ;
      case '(':
	return T_Lpar ;
      case ')':
	return T_Rpar ;
      case '?':
	return T_Question ;
      case ':':
	if (c2 == ':') { prog->Adv() ; return T_ColonColon ; }
	if (c2 == '=') { prog->Adv() ; return T_RefAssign ; }
	return T_Colon ;
      case '{':
	if (c2 == '{') { prog->Adv() ; return T_LLbr ; }
	return T_Lbr ;
      case '}':
	if (c2 == '}') { prog->Adv() ; return T_RRbr ; }
	return T_Rbr ;
      case '[':
	return T_Lbl ;
      case ']':
	return T_Rbl ;
      case ',':
	return T_Comma ;
      case '"':
      case '\'':
	{
	    //  
	    int delim = c ;
	    char *heapp ;
	    char *s0 ;
	    int  len ;
	    int strstart = prog->GetPC() ;

	    for (len = 0, prog->Set (strstart) ; (c = prog->PeekC()) != delim ; ) {
		if (!c /* || c == '\n'*/) {
		    SetErrorCode (INVALID_STRING) ;
		    return T_Err ;
		}
		if (iskanji (c)) {
		    len += 2 ;
		    prog->Adv(2) ;
		} else if (c == '\\') {
		    len++ ;
		    prog->Adv(2) ;
		} else {
		    len++ ;
		    prog->Adv() ;
		}
	    }
	    if (!(heapp = heap_area.AllocString (len+1, &varstack))) {
		SetErrorCode (NOT_ENOUGH_MEMORY) ;
		return T_Err ;
	    }
	    for (s0 = heapp, prog->Set(strstart) ;  (c = prog->GetC()) != delim ; ) {
		if (iskanji (c)) {
		    *s0++ = c ;
		    *s0++ = prog->GetC() ;
		} else if (c == '\\') {
		    c = prog->GetC() ;
		    switch (c) {
		      case 'n':
			*s0++ = '\n' ; break ;
		      case 'r':
			*s0++ = '\r' ; break ;
		      case 'b':
			*s0++ = '\b' ; break ;
		      case 'f':
			*s0++ = '\f' ; break ;
		      case 't':
			*s0++ = '\t' ; break ;
		      default:
			*s0++ = c    ; break ;
		    }
		} else {
		    *s0++ = c ;
		}
	    }
	    *s0 =  '\0' ;
	    lp->sval = heapp ;
	    return T_String ;
	}
      case '.':
	c2 = prog->PeekC() ;
	if (isdigit(c2)) {
	    double dval = 0.0 ;
	    double base = 0.1 ;
	    for (c = prog->GetC() ;
		 c && isdigit(c) ;
		 c = prog->GetC(), base *= 0.1)
	    {
		dval += base * (c - '0') ;
	    }
	    prog->Back(1) ;
	    lp->value = dval ;
	    return T_Number ;
	}
	return T_PointTo ;
	break ;
      case '0': case '1':
      case '2': case '3':
      case '4': case '5':
      case '6': case '7':
      case '8': case '9':
    	{
	    // 萔 
	    int ival = 0 ;
	    double dval ;

	    c2 = prog->PeekC() ;
	    if (c == '0' && (c2 == 'x' || c2 == 'X')) {
		prog->GetC() ;
		c = prog->GetC () ;
		for (; ishexdigit(c) ; c = prog->GetC()) {
		    ival = 16 * ival + HEXVAL(c) ;
		}
		prog->Back(1) ;
		lp->ival = ival ;
		return T_IntNumber ;
	    } else if (c == '0' && (c2 == 'b' || c2 == 'B')) {
		prog->GetC() ;
		c = prog->GetC () ;
		for (; c == '0' || c == '1'; c = prog->GetC()) {
		    ival = 2 * ival + c - '0' ;
		}
		prog->Back(1) ;
		lp->ival = ival ;
		return T_IntNumber ;
	    } else if (c == '0' && isoctdigit(c2)) {
		c = prog->GetC() ;
		for (; ishexdigit(c) ; c = prog->GetC()) {
		    ival = 8 * ival + c - '0' ;
		}
		prog->Back(1) ;
		lp->ival = ival ;
		return T_IntNumber ;
	    } else {
		for ( ; isdigit (c) ; c = prog->GetC()) {
		    ival = 10 * ival + c - '0' ;
		}
		if (c != '.') {
		    lp->ival = ival ;
		    prog->Back(1) ;
		    return T_IntNumber ;
		}
		dval = (double)ival ;
		double base = 0.1 ;
		for (c = prog->GetC() ;
		     c && isdigit(c) ;
		     c = prog->GetC(), base *= 0.1)
		{
		    dval += base * (c - '0') ;
		}
		prog->Back(1) ;
		lp->value = dval ;
		return T_Number ;
	    }
	}
      case EXPR_DELIM:
	return T_Eos ;
      case '@':
	c2 = prog->GetC() ;
	if (c2 == '\\') {
	    c2 = prog->GetC () ;
	    switch (c2) {
	      case 'n': lp->ival = (int)'\n' ; break ;
	      case 'r': lp->ival = (int)'\r' ; break ;
	      case 'b': lp->ival = (int)'\b' ; break ;
	      case 'f':	lp->ival = (int)'\f' ; break ;
	      case 't': lp->ival = (int)'\t' ; break ;
	      default:  lp->ival = (int)c2   ; break ;
	    }
	} else if (iskanji (c2)) {
	    int c3 ;
	    c3 = prog->GetC () ;
	    lp->ival = ((c2&0xff)<<8)|(c3&0xff) ;
	} else {
	    lp->ival = (int)c2 ;
	}
	return T_IntNumber ;
      case '`':
	is_symbol = 1 ;
	c = prog->GetC() ;
	/* falling down */
      default:
	if (isalpha(c) || c == '_' || iskanji(c)) {
	    // O 
	    int i ;

	    for (i = 0 ; isalnum(c) || c == '_' || iskanji(c) ; c = prog->GetC()) {
		if (i + 1 >= max_namelen) {
		    if (Grow (namep, max_namelen + 1, 30) < 0) {
			fprintf (stderr, "Fatal, Cannot Allocate Memory\n") ;
			exit (1) ;
		    }
		    max_namelen += 30 ;
		}
		if (iskanji (c)) {
		    namep->sptr[i++] = c ;
		    namep->sptr[i++] = prog->GetC() ;
		} else {
		    namep->sptr[i++] = c ;
		}
	    }
	    namep->sptr[i] = '\0' ;
	    prog->Back(1) ;
	    lp->symbol = symbolTable->GetSymbol (namep->sptr) ;
	    if (is_symbol) {
		return T_Symbol ;
	    } else {
		varsymbol = lp->symbol ;
		varname = varsymbol->symbol ;
		if (varsymbol->GetFlag() == SYM_RESERVED_WORD)
		    return (Token)varsymbol->GetValue() ;
	    }
	    return T_Word ;
	}
	return T_Err ;
    }
    /*NOT REACHED*/
}

//  
int CmmInterp::Term (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    LexInfo li ;
    Value x ;
    int st = 0 ;
    int unaryop = 0 ;
#define PRE_INC  0x01
#define PRE_DEC  0x02
#define UMINUS   0x04
#define UNOT     0x08
#define UREV	 0x10
#define PREOPR   (PRE_INC|PRE_DEC)

    // check unary operator
    if (t == T_PP) {
	unaryop |= PRE_INC ;
    } else if (t == T_MM) {
	unaryop |= PRE_DEC ;
    } else if (t == T_Minus) {
	unaryop |= UMINUS ;
    } else if (t == T_Not) {
	unaryop |= UNOT ;
    } else if (t == T_BitRev) {
	unaryop |= UREV ;
    } else if (t == T_Plus) {
	// igonre unary plus
	t = Lex (lip) ;
    }
    if (unaryop) // PZqꍇ́Aǂ 
	t = Lex (lip) ;
    st = VarValue (t, lip, skip, locp) ; CHECKST_EX(st) ;
    if (!skip) {
	x = varstack.VPop () ;
	if (unaryop & PRE_INC) {
	    if (!locp->varp)
		return SetErrorCode (INVALID_EXPRESSION) ;
	    if (locp->varp->IsInteger ()) {
		x = ++locp->varp->intval ;
	    } else if (locp->varp->IsReal()) {
		x = ++locp->varp->value ;
	    } else
		return SetErrorCode (INVALID_EXPRESSION) ;
	} else if (unaryop & PRE_DEC) {
	    if (!locp->varp)
		return SetErrorCode (INVALID_EXPRESSION) ;
	    if (locp->varp->IsInteger ()) {
		x = --locp->varp->intval ;
	    } else if (locp->varp->IsReal()) {
		x = --locp->varp->value ;
	    } else
		return SetErrorCode (INVALID_EXPRESSION) ;
	}
    }
    t = Lex (&li) ;
    if (t == T_PP || t == T_MM) {
	if (!skip) {
	    if (!locp->varp) {
		return SetErrorCode (INVALID_EXPRESSION) ;
	    }
	    if (t == T_PP) {
		if (locp->varp->IsInteger()) {
		    locp->varp->intval++ ;
		} else if (locp->varp->IsReal()) {
		    locp->varp->value++ ;
		} else {
		    return SetErrorCode (INVALID_EXPRESSION) ;
		}
	    } else if (t == T_MM) {
		if (locp->varp->IsInteger()) {
		    locp->varp->intval-- ;
		} else if (locp->varp->IsReal()) {
		    locp->varp->value-- ;
		} else {
		    return SetErrorCode (INVALID_EXPRESSION) ;
		}
	    }
	}
    } else {
	PutBack () ;
    }
    if (skip)
	return st ;
  fix_unary_op:
    if (unaryop & UNOT) {
	locp->Reset () ;
	x = (x.True()) ? I_FALSE : I_TRUE ;
    } else if (unaryop & UMINUS) {
	locp->Reset () ;
	if (x.IsInteger())
	    x.intval = -1 * x.intval ;
	else if (x.IsReal())
	    x.value = -1.0 * x.value ;
	else
	    return SetErrorCode (INVALID_EXPRESSION) ;
    } else if (unaryop & UREV) {
	locp->Reset () ;
	x.intval = ~(x.ForceInt()) ;
    }
    varstack.TmPush (x) ;
    return st ;
}

// |ZAZ 
int CmmInterp::Factor(Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    int st ;
    Value *x1, *x2 ;
    Value xx ;
    Token opr ;
    LexInfo li ;
    LocInfo loc ;

    st = Term (t, lip, locp, skip) ;
    CHECKST_EX(st) ;

    for (;;) {
	opr = Lex (&li) ;
	if (opr != T_Mult && opr != T_Div && opr != T_Mod && opr != T_Band) {
	    PutBack () ;
	    return st ;
	}
	t = Lex (&li) ;
	locp->Reset () ;
	loc.Reset () ;
	st = Term (t, &li, &loc, skip) ;
	CHECKST_EX(st) ;
	if (skip)
	    continue ;
	x1 = varstack.Top2 () ;
	x2 = varstack.Top () ;
	if (x1->IsReal()) {
	    if (opr == T_Mult) {
		xx = x1->value * x2->ForceReal() ;
	    } else if (opr == T_Div) {
		if (x2->ForceReal() == 0.0) {
		    return ThrowSystemException (divisionByZeroException) ;
		}
		xx = x1->value / x2->ForceReal() ;
	    } else {
		return SetErrorCode (INVALID_EXPRESSION) ;
	    }
	} else if (x1->IsInteger()) {
	    if (opr == T_Mult) {
		xx = x1->intval * x2->ForceInt() ;
	    } else if (opr == T_Band) {
		if (!x2->IsInteger ())
		    return SetErrorCode (INVALID_EXPRESSION) ;
		xx = (x1->intval & x2->intval) ;
	    } else {
		if (x2->ForceInt() == 0)
		    return ThrowSystemException (divisionByZeroException) ;
		if (opr == T_Div)
		    xx = x1->intval / x2->ForceInt() ;
		else
		    xx = x1->intval % x2->ForceInt() ;
	    }
	} else if (x1->IsString () && opr == T_Mult) {
	    char *ss ;
	    int slen = strlen (x1->sptr) ;
	    int nums = x2->ForceInt () ;
	    ss = heap_area.AllocString (slen * nums + 1, &varstack) ;
	    if (!ss)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	    int i, j ;
	    for (i = j = 0 ; i < nums ; i++, j += slen) {
		strcpy (ss + j, x1->sptr) ;
	    }
	    ss[j] = '\0' ;
	    xx = ss ;
	} else if (x1->IsArray() && opr == T_Div) {
	    int idx ;

	    idx = x2->ForceInt() ;
	    if (idx < 0 || idx >= x1->arr.numelems) {
		return ThrowSystemException (arrayOutOfBoundsException) ;
	    }
	    if (heap_area.RemoveArray (x1, idx, &varstack, &xx) < 0)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	} else {
	    return SetErrorCode (INVALID_EXPRESSION) ;
	}
	varstack.TmPop (2) ;
	varstack.TmPush (xx) ;
    }
    /*NOTREACHED*/
}

// ZAZ 
int CmmInterp::Expression(Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    int st ;
    Value *x1, *x2 ;
    Value xx ;
    Token opr ;
    LexInfo li ;
    LocInfo loc ;

    st = Factor (t, lip, locp, skip) ;
    CHECKST_EX(st) ;
    for ( ;; ) {
	opr = Lex (&li) ;
	if (opr != T_Plus   && opr != T_Minus
	    && opr != T_Rsh && opr != T_Lsh
	    && opr != T_Bor && opr != T_Xor)
	{
	    PutBack () ;
	    return st ;
	}
	t = Lex (&li) ;
	locp->Reset () ;
	loc.Reset () ;
	st = Factor (t, &li, &loc, skip) ;
	CHECKST_EX(st) ;
	if (skip)
	    continue ;
	x1 = varstack.Top2 () ;
	x2 = varstack.Top  () ;
	if (x1->IsReal()) {
	    if      (opr == T_Plus )  xx = x1->value + x2->ForceReal() ;
	    else if (opr == T_Minus)  xx = x1->value - x2->ForceReal() ;
	    else
		return SetErrorCode (INVALID_EXPRESSION) ;
	} else if (x1->IsInteger()) {
	    if      (opr == T_Plus ) xx = x1->intval + x2->ForceInt() ;
	    else if (opr == T_Minus) xx = x1->intval - x2->ForceInt() ;
	    else if (opr == T_Lsh  ) xx = x1->intval << x2->ForceInt () ;
	    else if (opr == T_Rsh  ) xx = x1->intval >> x2->ForceInt () ;
	    else if (opr == T_Bor && x2->IsInteger())
		xx = (x1->intval | x2->intval) ;
	    else if (opr == T_Xor && x2->IsInteger())
		xx = (x1->intval ^ x2->intval) ;
	    else
		return SetErrorCode (INVALID_EXPRESSION) ;
	} else if (x1->IsString()) {
	    int len1 = strlen(x1->sval()) ;
	    int len2 = strlen(x2->ForceString()) ;
	    char *snew ;

	    if (opr != T_Plus) {
		return SetErrorCode (INVALID_STRING_OPERATION) ;
	    }
	    snew = heap_area.AllocString (len1 + len2 + 1, &varstack) ;
	    if (!snew)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	    strcpy (snew, x1->sptr) ;
	    strcat (snew, x2->ForceString()) ;
	    xx = snew ;
	} else if (x1->IsArray() && x2->IsArray() && opr == T_Plus) {
	    if (heap_area.ConsArray (x1, x2, &varstack, &xx) < 0)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	} else if (x1->IsArray() && opr == T_Minus) {
	    if (heap_area.RemoveArray (x1, x2, &varstack, &xx) < 0)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	} else if (x1->IsArray() && opr == T_Lsh) {
	    if (heap_area.AppendArray (x1, x2, &varstack, &xx) < 0)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	} else if (x1->IsArray() && (x2->IsNumber() || x2->IsString()) && opr == T_Rsh) {
	    if (heap_area.PopArray (x1, x2->ForceInt(), &varstack, &xx) < 0)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	} else {
	    return SetErrorCode (INVALID_EXPRESSION) ;
	}
	varstack.TmPop(2) ;
	varstack.TmPush(xx) ;
    }
    /*NOTREACHED*/
}

// 召r 
int CmmInterp::Condition2 (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    LexInfo li ;
    int st ;
    Value x ;
    Value *x1, *x2, *x3 ;
    Token opr ;
    Token opr2 ;
    LocInfo loc ;
    int tri_term = 0 ;
    int popcnt ;

    st = Expression (t, lip, locp, skip) ;
    CHECKST_EX(st) ;
    for (;;) {
	opr = Lex (&li) ;
	if (   opr != T_Lt && opr != T_Le
	    && opr != T_Ge && opr != T_Gt
	    && opr != T_Eq && opr != T_Neq)
	{
	    PutBack () ;
	    return st ;
	}
	t = Lex (&li) ;
	loc.Reset () ;
	locp->Reset () ;
	st = Expression (t, &li, &loc, skip) ;
	tri_term = 0 ;
	CHECKST_EX(st) ;
	if (!skip) {
	    x1 = varstack.Top2 () ;
	    x2 = varstack.Top  () ;
	}
	if (opr == T_Lt || opr == T_Le || opr == T_Gt || opr == T_Ge) {
	    // 3rZq̃`FbN
	    opr2 = Lex (&li) ;
	    if ((opr == T_Lt || opr == T_Le) && (opr2 == T_Lt || opr2 == T_Le))
		tri_term++ ;
	    else if ((opr == T_Gt || opr == T_Ge) && (opr2 == T_Gt || opr2 == T_Ge))
		tri_term++ ;
	    else
		PutBack () ;
	}
	if (tri_term) {
	    if (skip) {
		t = Lex (&li) ;
		st = Expression (t, &li, &loc, skip) ;
		CHECKST_EX(st) ;
		continue ;
	    }
	    int tf1, tf2 ;
	    switch (opr) {
	      case T_Lt: tf1 = (int)(*x1 <  *x2) ; break ;
	      case T_Gt: tf1 = (int)(*x1 >  *x2) ; break ;
	      case T_Le: tf1 = (int)(*x1 <= *x2) ; break ;
	      case T_Ge: tf1 = (int)(*x1 >= *x2) ; break ;
	      default: ;
	    }
	    if (!tf1) {
		t = Lex (&li) ;
		loc.Reset () ;
		st = Expression (t, &li, &loc, 1) ;
		CHECKST_EX(st) ;
		x = tf1 ;
		popcnt = 2 ;
	    } else {
		t = Lex (&li) ;
		loc.Reset () ;
		st = Expression (t, &li, &loc, 0) ;
		CHECKST_EX(st) ;
		x3 = varstack.Top () ;
		switch (opr2) {
		  case T_Lt: tf2 = (int)(*x2 <  *x3) ; break ;
		  case T_Gt: tf2 = (int)(*x2 >  *x3) ; break ;
		  case T_Le: tf2 = (int)(*x2 <= *x3) ; break ;
		  case T_Ge: tf2 = (int)(*x2 >= *x3) ; break ;
		  default: ;
		}
		popcnt = 3 ;
		x = tf2 ;
	    }
	} else {
	    if (skip)
		continue ;
	    switch (opr) {
	      case T_Lt:  x = (int) (*x1 <  *x2) ; break ;
	      case T_Gt:  x = (int) (*x1 >  *x2) ; break ;
	      case T_Le:  x = (int) (*x1 <= *x2) ; break ;
	      case T_Ge:  x = (int) (*x1 >= *x2) ; break ;
	      case T_Eq:  x = (int) (*x1 == *x2) ; break ;
	      case T_Neq: x = (int) (*x1 != *x2) ; break ;
	      default:
		break ;
	    }
	    popcnt = 2 ;
	}
	varstack.TmPop (popcnt) ;
	varstack.TmPush(x) ;
    }
    /* NOTREACHED */
}

// _ 
int CmmInterp::Condition1 (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    LexInfo li ;
    int st ;
    Value x1, x2 ;
    LocInfo loc ;

    st = Condition2 (t, lip, locp, skip) ;
    CHECKST_EX(st) ;
    for (;;) {
	t = Lex (&li) ;
	if (t != T_And) {
	    PutBack () ;
	    return st ;
	}
	if (!skip) {
	    x1 = varstack.VPop() ;
	    if (!x1.True()) {
		skip = 1 ;
		varstack.TmPush(x1) ;
	    }
	}
	t = Lex (&li) ;
	locp->Reset () ;
	loc.Reset () ;
	st = Condition2 (t, &li, &loc, skip) ;
	CHECKST_EX(st) ;
	if (!skip) {
	    x2 = varstack.VPop() ;
	    x1 = x2.True () ;
	    varstack.TmPush(x1) ;
	}
    }
    /* NOTREACHED */
}

// _a 
int CmmInterp::Condition0 (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    LexInfo li ;
    int st ;
    Value x1, x2 ;
    LocInfo loc ;

    st = Condition1 (t, lip, locp, skip) ;
    CHECKST_EX(st) ;
    for (;;) {
	t = Lex (&li) ;
	if (t != T_Or) {
	    PutBack () ;
	    return st ;
	}
	if (!skip) {
	    x1 = varstack.VPop() ;
	    if (x1.True()) {
		skip = 1 ;
		varstack.TmPush (x1) ;
	    }
	}
	t = Lex (&li) ;
	locp->Reset () ;
	loc.Reset () ;
	st = Condition1 (t, &li, &loc, skip) ;
	CHECKST_EX(st) ;
	if (!skip) {
	    x2 = varstack.VPop () ;
	    x1 = x2.True() ;
	    varstack.TmPush(x1) ;
	}
    }
    /* NOTREACHED */
}

// ?: 3Zq 
int CmmInterp::Conditional (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    Value tf ;
    int   is_true ;
    LexInfo li ;
    int skip_true, skip_false ;
    int st_true, st_false ;
    LocInfo loc ;
    int st ;

    st = Condition0 (t, lip, locp, skip) ;
    CHECKST_EX(st) ;
    t = Lex (&li) ;
    if (t != T_Question) {
	PutBack () ;
	return st ;
    }
    if (skip) {
	t = Lex (&li) ;
	loc.Reset () ;
	st = Condition0 (t, &li, &loc, 1) ;
	CHECKST_EX(st) ;
	t = Lex (&li) ;
	if (t != T_Colon) {
	    return SetErrorCode (SYNTAX_ERROR) ;
	} else {
	    t = Lex (&li) ;
	    st = Conditional (t, &li, &loc, 1) ;
	}
	return st ;
    }
    if (st == EXIT || st == THROW) {
	skip_true = skip_false = 1 ;
    } else {
	tf = varstack.VPop() ;
	is_true = tf.True () ;
	if (is_true) {
	    skip_true = 0 ; skip_false = 1 ;
	} else {
	    skip_true = 1 ; skip_false = 0 ;
	}
    }
    t = Lex (&li) ;
    loc.Reset () ;
    st_true = Condition0 (t, &li, &loc, skip_true) ;
    CHECKST_EX(st_true) ;
    if (!skip_true) {
	if (st_true == THROW) {
	    skip_false = 1 ;
	}
    }
    if (is_true) {
	*lip  = li ;
	locp->vtype = loc.vtype ;
	varstack.LPush (loc.instancep) ;
	varstack.LPush (loc.classp) ;
	varstack.LPush (loc.varp) ;
    }
    t = Lex (&li) ; // t = T_Colon
    t = Lex (&li) ;
    loc.Reset () ;
    st_false = Conditional (t, &li, &loc, skip_false) ;
    CHECKST_EX(st_false) ;
    if (is_true) {
	locp->varp      = (varstack.LPop ()).location ;
	locp->classp    = (varstack.LPop ()).location ;
	locp->instancep = (varstack.LPop ()).location ;
    } else {
	*lip  = li ;
	*locp = loc ;
    }
    return (is_true) ? st_true : st_false ;
}

int CmmInterp::ArrIndex (Token t, int max, int skip)
{
    int st ;
    LexInfo li ;
    int index = 0 ;
    LocInfo loc ;

    if (t != T_Lbl) {
	return -1 ;
    }
    t = Lex (&li) ;
    st = Assign (t, &li, &loc, skip) ;
    CHECKST_EX(st) ;
    if (!skip)
	index = (varstack.VPop()).ForceInt() ;
    t = Lex (&li) ;
    if (t != T_Rbl)
	return -1 ;
    if (skip)
	return 0 ;
    if (index < 0)
	return -1 ;
    if (max > 0 && index >= max)
	return -1 ;
    return index ;
}

//----------------------------------------------------------------
// CmmInterp::LookupVar -- ϐ̃T[` 
//----------------------------------------------------------------
Value *CmmInterp::LookupVar (Symbol *var_sym, Class *classp, VarType *vtype, int *is_member, Value **cpp)
{
    Value *varp, *var2p ;

    *is_member = 0 ;
    *vtype = VT_NormalVar ;
    *cpp = NULL ;
    varp = varstack.LookupVar (var_sym) ;
    if (!thisptr) {
	return varp ;
    }
    // thisptr uāvꍇ: 
    if (!varp || varp <= thisptr) {
	// name ̖Oϐ varp Athisptr X^bNŁuv 
	// ɂB̏ꍇAthisptr ̃oɓ name Ƃ 
	// o΁AD悷B 
	if (thisptr->IsInstance()) {
	    int index ;
	    Value *cp ;
	    var2p = thisptr->instance->FindMember (classp, var_sym,
						   &cp, vtype, &index) ;
	    if (var2p)
		*cpp = cp ;
	} else if (thisptr->IsClass()) {
	    var2p = thisptr->classp->FindMethodOrStatic (var_sym, vtype) ;
	} else {
	    var2p = classptr->classp->FindMethodOrStatic (var_sym, vtype) ;
	}
	if (!var2p)
	    return varp ;
	*is_member = 1 ;
	return var2p ;
    }
    return varp ;
}

//----------------------------------------------------------------
// CmmInterp::VarValue -- ϐ́u肩v𒲂ׂ 
//----------------------------------------------------------------
int CmmInterp::VarValue (Token t, LexInfo *lip, int skip, LocInfo *locp)
{
    LocInfo loc ;
    LexInfo li ;
    int nexttoken = 1 ;
    int st = 0 ;
    int st0 = 0 ;
    int num ;
    Value *arr ;
    Value x ;
    int i, j ;

    switch (t) {
      case T_Lpar:
	// ()
	t = Lex (&li) ;
	st = Assign (t, &li, locp, skip) ;
	CHECKST_EX(st) ;
	t = Lex (&li) ;
	if (t != T_Rpar)
	    return SetErrorCode (SYNTAX_ERROR) ;
	if (!skip) {
	    if (locp->varp && locp->varp->IsInstance()) {
		if (!locp->classp)
		    locp->classp = locp->varp->instance->SelectClass (classptr->classp) ;
		locp->instancep = locp->varp ;
	    }
	}
	break ;
      case T_IntNumber:
	if (!skip) {
	    if (locp->varp)
		return SetErrorCode (INVALID_EXPRESSION) ;
	    varstack.TmPush (lip->ival) ;
	    locp->Reset () ;
	}
	break ;
      case T_Number:
	if (!skip) {
	    if (locp->varp)
		return SetErrorCode (INVALID_EXPRESSION) ;
	    varstack.TmPush (lip->value) ;
	    locp->Reset () ;
	}
	break ;
      case T_Eval:
	locp->Reset () ;
	st = Eval (t, lip, locp, skip) ;
	CHECKST_EX(st) ;
	break ;
      case T_New:
	{
	    t = Lex (&li) ;
	    if (t != T_Word)
		return SetErrorCode (SYNTAX_ERROR) ;
	    st = Assign (t, &li, &loc, skip) ;
	    CHECKST_EX(st) ;
	    if (skip)
		return st ;
	    Value xclass = varstack.VPop () ;
	    if (!xclass.IsClass())
		return SetErrorCode (UNDEFINED_CLASS) ;
	    if (IsSpecialClass (xclass.classp->classnamep))
		return SetErrorCode (INVALID_NEW) ;
	    Instance *ip = CreateInstance (xclass.classp) ;
	    if (!ip)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	    x = ip ;
	    varstack.TmPush (x) ;
	    return 0 ;
	}
      case T_Symbol:
	if (!skip) {
	    if (locp->varp)
		return SetErrorCode (INVALID_EXPRESSION) ;
	    varstack.TmPush (lip->symbol) ;
	    locp->Reset () ;
	}
	break ;
      case T_String:
	if (!skip) {
	    if (locp->varp)
		return SetErrorCode (INVALID_EXPRESSION) ;
	    varstack.TmPush (lip->sval) ;
	    locp->Reset () ;
	}
	t = Lex (&li) ;
	PutBack () ;
	if (t == T_Lpar) {
	    if (skip) {
		st = PushArgs (skip, NULL) ;
	    } else {
		varstack.TmPop () ;
		st = FunCall (lip->sval, locp) ; CHECKST_EX(st) ;
	    }
	}
	break ;
      case T_Lbl:
	if (skip) {
	    t = Lex (&li) ;
	    if (t != T_Rbl) {
		for (; ; t = Lex (&li)) {
		    if (t == T_Rbl)
			break ;
		    if (t != T_Comma){
			st = Assign (t, &li, &loc, skip) ;
			CHECKST_EX(st) ;
			t = Lex (&li) ;
			if (t != T_Comma)
			    break ;
		    }
		}
	    }
	    if (t != T_Rbl)
		return SetErrorCode (SYNTAX_ERROR) ;
	} else {
	    // Array constant
	    int spsave = varstack.StackPtr () ;

	    locp->Reset () ;
	    t = Lex (&li) ;
	    if (t != T_Rbl) {
		for (; ; t = Lex (&li)) {
		    if (t == T_Rbl) {
			varstack.TmPush () ;
			break ;
		    }
		    if (t == T_Comma) {
			varstack.TmPush () ;
		    } else {
			// evaluate values
			loc.Reset () ;
			st = Assign (t, &li, &loc, skip) ;
			if (st < 0)
			    return -1 ;
			t = Lex (&li) ;
			if (t != T_Comma)
			    break ;
		    }
		}
	    }
	    if (t != T_Rbl)
		return SetErrorCode (SYNTAX_ERROR) ;
	    num = varstack.StackPtr() - spsave ;
	    if (heap_area.AllocArray (num, &varstack, &arr) < 0)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	    x.InitArr (arr, num) ;
	    for (i = 0, j = spsave ; i < num ; i++, j++)
		arr[i] = *varstack.Peek (j) ;
	    varstack.SetStackPtr (spsave) ;
	    varstack.TmPush (x) ;
	    locp->Reset () ;
	}
	break ;
      case T_Void:
	if (!skip) {
	    x.Init () ;
	    varstack.TmPush (x) ;
	    locp->Reset () ;
	}
	break ;
      case T_Pause:
	if (!skip) {
	    Debug () ;
	    locp->Reset () ;
	}
	return 0 ;
      case T_ArgPrefix:
	// wq $<> 
	locp->varp = PointArgument (skip) ;
	if (!skip) {
	    if (!locp->varp)
		return SetErrorCode (UNDEFINED_IDENTIFIER) ;
	    if (!locp->varp->IsInstance()) {
		locp->vtype = VT_NormalVar ;
		locp->instancep = NULL ;
		locp->classp = FixSpecialClass (locp->varp) ;
		varstack.TmPush (*locp->varp) ;
	    } else {
		locp->instancep = locp->varp ;
		locp->classp = locp->varp->instance->SelectClass (classptr->classp) ;
		varstack.TmPush (*locp->varp) ;
	    }
	} else {
	    if (!locp->varp)
		return -1 ;
	}
	break ;
      case T_Word:
	// ʏ̖O 
	// locp  instance w肵Ăꍇ͂̃oϐB 
	// Ȃꍇ́Aʏ̕ϐA邢́Athisptr Ŏw肳 
	// Instance ̃o  
	if (!skip) {
	    Value *vp ;
	    if (locp->instancep) {
		Value *cp ;
		
		if (!locp->classp)
		    locp->classp = locp->instancep->instance->classp->classnamep ;

		vp = locp->instancep->instance->FindMember (locp->classp->classp,
							    varsymbol, &cp, &locp->vtype) ;
		locp->varp = vp ;
		if (!vp)
		    return SetErrorCode (UNDEFINED_MEMBER) ;
		if (vp->IsInstance()) {
		    locp->instancep = vp ;
		    locp->classp = vp->instance->classp->classnamep ;
		} else {
		    locp->instancep = vp /* NULL */ ;
		    locp->classp = NULL ;
		}
		varstack.TmPush (*locp->varp) ;
	    } else {
		int is_member ;
		Value *cp ;
		Value v ;
		if (!(vp = LookupVar (varsymbol,
				      (classptr) ? classptr->classp : NULL,
				      &locp->vtype,
				      &is_member, &cp)))
		    return SetErrorCode (UNDEFINED_IDENTIFIER) ;
		locp->varp = vp ;
		if (vp->IsClass()) {
		    locp->instancep = vp ;
		    locp->classp    = vp ;
		} else if (vp->IsInstance ()) {
		    locp->instancep = locp->varp ;
		    locp->classp    = vp->instance->classp->classnamep ;
		} else if ((locp->vtype == VT_Method || locp->vtype == VT_Hiden)
			   && !locp->instancep)
		{
		    locp->instancep = thisptr ;
		    locp->classp    = cp ;
		}
		varstack.TmPush (*locp->varp) ;
	    }
	}
	break ;
      case T_This:
	if (!skip) {
	    if (!thisptr)
		return SetErrorCode (SYNTAX_ERROR) ;
	    if (thisptr->IsInstance()) {
		locp->varp      = thisptr ;
		locp->instancep = thisptr ;
		locp->classp = thisptr->instance->SelectClass (classptr->classp) ;
	    } else if (thisptr->IsClass()) {
		locp->instancep = thisptr ;
		locp->classp    = thisptr ;
		locp->varp      = thisptr ;
	    } else {
		locp->classp    = FixSpecialClass (thisptr) ;
		locp->varp      = thisptr ;
		locp->instancep = thisptr ;
	    }
	    locp->vtype = VT_NormalVar ;
	    varstack.TmPush (*locp->varp) ;
	}
	break ;
      case T_Self:
	if (!skip) {
	    if (!thisptr)
		return SetErrorCode (SYNTAX_ERROR) ;
	    locp->varp = thisptr ;
	    locp->instancep = thisptr ;
	    if (thisptr->IsInstance()) {
		locp->classp = thisptr->instance->classp->classnamep ;
	    } else if (thisptr->IsClass()) {
		locp->classp = thisptr ;
	    } else {
		locp->classp = FixSpecialClass (thisptr) ;
	    }
	    locp->vtype = VT_NormalVar ;
	    varstack.TmPush (*locp->varp) ;
	}
	break ;
      case T_PointTo:
      case T_ColonColon:
	// ->Member ,  ::Class ̏ꍇ ̏ꍇA 
	// VarValue ɓn locp  instance w肵Ă邩A 
	// thisptr Ō݂ instance w肵ĂKv 
	// ݂ class, instance ݒ肵ĂB 
	if (!skip) {
	    if (locp->instancep) {
		locp->varp = locp->instancep ;
	    } else {
		if (!thisptr)
		    return SetErrorCode (SYNTAX_ERROR) ;
		if (thisptr->IsInstance()) {
		    locp->instancep = thisptr ;
		    locp->classp = thisptr->instance->SelectClass (classptr->classp) ;
		    locp->varp = thisptr ;
		} else if (thisptr->IsClass()) {
		    locp->instancep = thisptr ;
		    locp->classp = thisptr ;
		    locp->varp = thisptr ;
		} else {
		    locp->classp = FixSpecialClass (thisptr) ;
		    locp->varp = thisptr ;
		    locp->instancep = thisptr ;
		}
	    }
	    locp->vtype = VT_NormalVar ;
	    varstack.TmPush (*locp->varp) ;
	}
	nexttoken = 0 ;
	break ;
      case T_ArgList:
	if (!skip) {
	    locp->Reset () ;
	    if (argindex < 0)
		return SetErrorCode (SYNTAX_ERROR) ;
	    if (heap_area.AllocArray (argcnt, &varstack, &arr) < 0) {
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	    }
	    x.InitArr (arr, argcnt) ;
	    for (i = 0, j = argindex ; i < argcnt ; i++, j++) {
		arr[i] = *varstack.Peek(j) ;
	    }
	    varstack.TmPush (x) ;
	}
	break ;
      case T_ArgCnt:
	if (!skip) {
	    locp->Reset () ;
	    if (argindex < 0)
		return SetErrorCode (SYNTAX_ERROR) ;
	    varstack.TmPush (argcnt) ;
	}
	break ;
      case T_BoundArg:
	t = Lex (&li) ;
	if (t != T_Word)
	    return SetErrorCode (SYNTAX_ERROR) ;
	if (!skip) {
	    Variable *vp ;
	    Value v ;
	    Variable *argstart = varstack.PeekStack (argindex) ;

	    locp->Reset () ;
	    vp = (Variable *)varstack.LookupVar (varname) ;
	    if (!vp) {
		v.Init() ; 
	    } else if (vp < argstart || vp >= argstart + argcnt) {
		v = 0 ;
	    } else {
		v = 1 ;
	    }
	    varstack.TmPush (v) ;
	}
	break ;
      case T_Position:
	if (!skip) {
	    locp->Reset () ;
	    Value v ;
	    v = *prog ;
	    varstack.TmPush (v) ;
	}
	break ;
      default:
	st = Statement (t, &li, locp, skip) ;
	CHECKST_EX(st) ;
	return st ;
	;
    }
    if (nexttoken) {
	t = Lex (&li) ;
	if (t != T_PointTo && t != T_ColonColon && t != T_Lbl && t != T_Lpar) {
	    PutBack () ;
	    return (st0) ? st0 : st ;
	}
    }
    int constThis = 0 ;

    for ( ; ; t = Lex (&li)) {
	switch (t) {
	  case T_Lbl:
	    // zCfbNX 
	    for (;;) {
		t = Lex (&li) ;
		loc.Reset () ;
		st = Assign (t, &li, &loc, skip) ;
		CHECKST_EX(st) ;
		t = Lex (&li) ;
		if (t != T_Rbl)
		    return SetErrorCode (SYNTAX_ERROR) ;
		if (!skip) {
		    int idx ;
		    Value *topp ;
		    idx = (varstack.VPop()).ForceInt () ;
		    topp = varstack.Top () ;
		    if (!topp->IsArray()) {
			return SetErrorCode (INVALID_EXPRESSION) ;
		    }
		    if (idx < 0 || idx >= topp->arr.numelems) {
			st0 = ThrowSystemException (arrayOutOfBoundsException) ;
			skip = 1 ;
		    } else {
			locp->varp = &topp->arr.arrp[idx] ;
			varstack.TmPop() ;
			varstack.TmPush(*locp->varp) ;
		    }
		}
		t = Lex (&li) ;
		if (t == T_Lbl) {
		    continue ;
		} else {
		    PutBack () ;
		    break ;
		}
	    }
	    if (!skip) {
		if (locp->varp->IsInstance()) {
		    locp->instancep = locp->varp ;
		    locp->classp = locp->varp->instance->classp->classnamep ;
		    locp->vtype = VT_NormalVar ;
		} else {
		    locp->classp = NULL ;
		    locp->instancep = NULL ;
		    locp->vtype = VT_NormalVar ;
		}
	    }
	    break ;
	  case T_PointTo: // ->
	    t = Lex (&li) ;
	    if (t == T_Word) {
		// '->' <O>
		// ݂ instance ̃ołȂĂ͂ȂȂB
		//
		if (!skip) {
		    Value *baseInstance = locp->instancep ;

		    if (constThis) {
			varstack.LPop () ; constThis = 0 ;
		    }
		    if (!locp->varp) {
			locp->varp = varstack.LPush (*varstack.Top()) ;
			constThis = 1 ;
		    }
		    varstack.TmPop () ;
		    if (locp->varp->IsInstance()) {
			Value *cp ;

			locp->instancep = locp->varp;
			locp->varp = locp->instancep->instance->FindMember
					    (locp->classp->classp,
					     varsymbol, &cp, &locp->vtype) ;
			if (!locp->varp)
			    return SetErrorCode (UNDEFINED_MEMBER) ;
			// ǒ^炻̃NX擾 
			if (locp->varp->IsInstance()) {
			    locp->instancep = locp->varp ;
			    locp->classp = locp->varp->instance->classp->classnamep ;
			} else if (locp->varp->IsClass()) {
			    locp->instancep = locp->varp ;
			    locp->classp = locp->varp ;
			} else if (locp->vtype != VT_Method
				   && locp->vtype != VT_Hiden
				   && locp->vtype != VT_BiMethod
				   && locp->vtype != VT_BiHiden)
			{
			    locp->classp = FixSpecialClass (locp->varp) ;
			} else {
			    locp->classp = cp ; // NX
			}
		    } else if (locp->varp->IsClass()) {
			locp->instancep = locp->varp ;
			locp->classp = locp->varp->classp->classnamep ;
			locp->varp   = locp->classp->classp->FindMethodOrStatic
			    			(varsymbol, &locp->vtype) ;
			if (!locp->varp)
			    return SetErrorCode (UNDEFINED_MEMBER) ;
			// ǒ^炻̃NX擾 
			if (locp->varp->IsInstance()) {
			    locp->classp = locp->varp->instance->classp->classnamep ;
			} else if (locp->varp->IsClass()) {
			    locp->classp = locp->varp ;
			} else if (locp->vtype != VT_Method
				   && locp->vtype != VT_Hiden
				   && locp->vtype != VT_BiMethod
				   && locp->vtype != VT_BiHiden)
			{
			    locp->classp = FixSpecialClass (locp->varp) ;
			}
		    } else {
			// JvZNX̃oT 
			locp->instancep = locp->varp ;
			if (!locp->classp) {
			    if (!(locp->classp = FixSpecialClass (locp->varp)))
				return SetErrorCode (INVALID_EXPRESSION) ;
			}
			locp->varp = locp->classp->classp->FindMethod (varsymbol, &locp->vtype) ;
			if (!locp->varp)
			    return SetErrorCode (UNDEFINED_MEMBER) ;
		    }
		    if (baseInstance
			&& baseInstance->IsInstance ()
			&& (locp->vtype == VT_Private
			    || locp->vtype == VT_Hiden
			    || locp->vtype == VT_BiHiden)
			&& (!thisptr || baseInstance->instance != thisptr->instance))
		    {
			return SetErrorCode (CANNOT_ACCESS_MEMBER) ;
		    }
		    varstack.TmPush (*locp->varp) ;
		}
	    } else if (t == T_Lpar) {
		varstack.TmPop () ;
		// '->' '(' <> ')' 
		t = Lex (&li) ;
		st = Assign (t, &li, locp, skip) ;
		t = Lex (&li) ;
		if (t != T_Rpar) {
		    return SetErrorCode (SYNTAX_ERROR) ;
		}
		if (!skip) {
		    if (!locp->varp) {
			return (st0) ? st0 : st ;
		    }
		    if (locp->varp->IsInstance()) {
			if (!locp->classp)
			    locp->classp = locp->varp->instance->classp->classnamep ;
		    }
		}
	    }
	    break ;
	  case T_ColonColon:
	    // ::<NX>  <NX>::<X^eBbN/\bh> 
	    t = Lex (&li) ;
	    if (t != T_Word)
		return SetErrorCode (SYNTAX_ERROR) ;
	    if (!skip) {
		if (!locp->instancep) {
		    if (constThis) {
			varstack.LPop () ;
			constThis = 0 ;
		    }
		    if (!locp->varp) {
			locp->varp = varstack.LPush (*varstack.Top()) ;
			constThis = 1 ;
		    }
		    locp->classp = FixSpecialClass (locp->varp) ;
		}
		varstack.TmPop () ;
		if (!locp->varp
		    || (!locp->varp->IsInstance() && !locp->varp->IsClass()))
		{
		    locp->classp->classp->FindClass (varsymbol, &locp->classp) ;
		} else if (locp->varp->IsInstance()) {
		    if (!locp->varp->instance->FindClass (locp->classp->classp,
							  varsymbol, &locp->classp))
			return SetErrorCode (UNDEFINED_CLASS) ;
		} else if (locp->varp->IsClass()) {
		    if (!locp->varp->classp->FindClass (varsymbol, &locp->classp))
			return SetErrorCode (INVALID_EXPRESSION) ;
		    locp->varp = locp->classp ;
		} else {
		    return SetErrorCode (INVALID_EXPRESSION) ;
		}
		varstack.TmPush (*locp->varp) ;
	    }
	    break ;
	  case T_Lpar:
	    PutBack () ;
	    if (skip) {
		st = PushArgs (skip, NULL) ; CHECKST_EX(st) ;
	    } else {
		varstack.TmPop () ;
		if (locp->instancep && varstack.InLStack (locp->instancep)) {
		    constThis = 1 ;
		}
		if (locp->varp->IsContext() && locp->varp->subtype == CTX_CREATOR) {
		    st = StartCreator (locp->classp, locp->varp) ;
		} else {
		    st = FunCall (locp->varp, locp) ; CHECKST_EX(st) ;
		}
		CHECKST_EX(st) ;
		if (st == EXIT) {
		    st0 = st ;
		    skip = 1 ;
		}
		if (constThis) {
		    varstack.LPop () ;
		    constThis = 0 ;
		}
	    }
	    break ;
	  default:
	    if (!skip) {
		if (constThis) {
		    varstack.LPop () ;
		    constThis = 0 ;
		}
	    }
	    PutBack () ;
	    return (st0 != NORMAL)? st0 : st ;
	}
    }
}

int CmmInterp::ThrowSystemException (Value *exception)
{
    Value v ;
    v = *prog ;
    exception->instance->SetValue (symbolTable->GetSymbol("pos"), v) ;
    varstack.TmPush (*exception) ;
    return THROW ;
}

int CmmInterp::StartCreator (Value *classp, Value *entry)
{
    int st ;
    int numargs ;
    int framepsave ;
    int stackpsave ;
    Instance *ip ;
    Value x ;

    ip = CreateInstance (classp->classp) ;
    if (!ip)
	return SetErrorCode (NOT_ENOUGH_MEMORY) ;
    x = ip ;
    varstack.TmPush (x) ;
    Value *instance = varstack.Top () ;

    framepsave = varstack.FramePtr () ;
    stackpsave = varstack.StackPtr () ;

    varstack.SetFramePtr (varstack.StackPtr()) ;
    st = PushArgs (0, instance, &numargs) ;    CHECKST_EX(st) ;
    st = CallCreator (classp, entry, instance, numargs) ;    CHECKST_EX(st) ;

    varstack.SetFramePtr (framepsave) ;
    varstack.SetStackPtr (stackpsave) ;

    return st ;
}

// NG[^Ăяo
int CmmInterp::CallCreator (Value *classp, Value *entry, Value *instance, int numargs)
{
    int retPC = prog->GetPC() ;
    int callPC ;
    Context *calladr ;
    Context *returnadr ;
    LexInfo li ;
    Token t ;
    int st = 0 ;
    int argindexsave ;
    int argcntsave ;
    Value *thisptrsave ;
    Value *classptrsave ;
    LocInfo loc ;

    if (entry) {
	varstack.TmPush (entry->context) ;
	calladr = &(varstack.Top()->context) ;

	returnadr = prog ;
	prog = calladr ;
	st = SetNames (numargs, varstack.FramePtr(), (int)instance) ; CHECKST_EX(st) ;
	argindexsave = argindex ;
	argcntsave   = argcnt ;
	thisptrsave  = thisptr ;
	classptrsave = classptr ;

	argindex = varstack.FramePtr () ;
	argcnt   = numargs ;
	thisptr  = instance ;
	classptr = classp ;
    }
    if (classp->classp->superclass) {
	t = Lex (&li) ;

	int stackpsave = varstack.StackPtr () ;
	int framepsave = varstack.FramePtr () ;
	int superargs = 0 ;
	Value *superCreator ;
	VarType vtype ;

	varstack.SetFramePtr (varstack.StackPtr()) ;
	if (t == T_Colon) {
	    st = PushArgs (0, instance, &superargs) ;
	    CHECKST_EX (st) ;
	} else {
	    PutBack () ;
	    superargs = 1 ;
	    varstack.TmPush (*instance) ;
	}
	superCreator = classp->classp->superclass->FindMethod (creatorSym, &vtype) ;
	if (superCreator) {
	    if (superCreator->IsContext()) {
		st = CallCreator (classp->classp->superclass->classnamep,
				  superCreator, instance, superargs) ;
	    } else {
		if (!has_compiler)
		    return SetErrorCode (COMPILER_NOT_INSTALLED) ;
		st = AcCallCreator (classp->classp->superclass->classnamep,
				    superCreator, instance, superargs) ;
	    }
	} else {
	    st = CallCreator (classp->classp->superclass->classnamep,
			      superCreator, instance, superargs) ;
	}
	CHECKST_EX(st) ;
	// t[|C^AX^bN|C^̕A 
	varstack.SetFramePtr (framepsave) ;
	varstack.SetStackPtr (stackpsave) ;
    }
    if (entry) {
	t = Lex (&li) ;
	loc.Reset () ;

	st = Statement (t, &li, &loc, 0) ;
	CHECKST_EX(st) ;

	argindex = argindexsave ;
	argcnt = argcntsave ;
	thisptr = thisptrsave ;
	classptr = classptrsave ;
	// ĂяoɕԂ 
	calladr->Set (callPC) ;
	prog = returnadr ;
	prog->Set (retPC) ;
    }
    return (st == EXIT) ? EXIT : NORMAL ;
}

int CmmInterp::DisposeInstance (Instance *instancep)
{
    Value *vp ;
    Value *classp ;
    Value *classvp ;
    Value *instancevp ;
    Value *namepsave ;
    int max_namelen_save ;
    int st ;

    //----------------------------------------------------------------
    // fBX|[UĂяṍAq[v̗\̈悩mۂ
    // ΂ȂȂB̂߁A݂̎̓obt@ namep->sptr 
    // płȂB̂߁A݂̎͗pobt@Z[uĂ
    // A\̈ɁAVȎ͗pobt@mۂB
    //----------------------------------------------------------------
    namepsave = varstack.TmPush (namep->sptr) ;
    max_namelen_save = max_namelen ;

    // ͗pobt@ADisposeɊmۂB
    max_namelen = 20 ;
    namep->sptr = heap_area.AllocString (max_namelen, &varstack) ;
    vp = varstack.TmPush (instancep) ;
    //----------------------------------------------------------------
    // ŉʃNXfBX|[UTA炻Ăяo
    //----------------------------------------------------------------
    for (classp = vp->instance->classp->classnamep ;
	 classp ; )
    {
	classvp = varstack.TmPush (*classp) ;
	if (classp->classp->have_disposer) {
	    Value *entry ;
	    VarType vtype ;
	    Value ret ;

	    entry = classvp->classp->FindMethodOrStaticOfClass (disposerSym, &vtype) ;
	    if (entry) {
		instancevp = varstack.TmPush (*vp) ;
		st = CallMethod (classvp, instancevp, entry, NULL, 0, &ret) ;
		CHECKST(st) ;
		varstack.TmPop() ;
	    }
	}
	if (!classvp->classp->superclass) {
	    varstack.TmPop() ;
	    break ;
	}
	classp = classvp->classp->superclass->classnamep ;
	varstack.TmPop() ;
    }
    varstack.TmPop () ;
    // ̓obt@ʏɕA
    namep->sptr = (varstack.VPop ()).sptr ;
    max_namelen = max_namelen_save ;
    return 0 ;
}


//  
int CmmInterp::Assign (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    LexInfo li ;
    int   st ;
    Token opr ;
    Value *lvalp ;
    Value *vp ;
    LocInfo loc ;

    st = Conditional (t, lip, locp, skip) ;
    CHECKST_EX(st) ;

    opr = Lex (&li) ;
    switch (opr) {
      default:
	// ł͂ȂB 
	PutBack () ;
	return st ;
      case T_Assign:
      case T_AddAssign:
      case T_SubAssign:
      case T_MultAssign:
      case T_DivAssign:
      case T_LshAssign:
      case T_RshAssign:
      case T_ModAssign:
      case T_RefAssign:
      case T_OrAssign:
      case T_AndAssign:
      case T_XorAssign:
	if (!skip) {
	    // BӒl̃P[VӒlX^bNɐς 
	    if (locp->vtype == VT_Const)
		return SetErrorCode (INVALID_EXPRESSION) ;
	    varstack.TmPop() ;
	    varstack.LPush (locp->varp) ;
	}
	// Eӎ̎s 
	t = Lex (&li) ;
	loc.Reset () ;
	st = Assign (t, &li, &loc, skip) ;

	CHECKST_EX(st) ;
	if (skip)
	    return st ;

	lvalp = varstack.LTop() ;

	Value *x0 ;
	Value *x ;
	Value rvalue ;
	char  *s ;
	char  *stmp ;

	x = varstack.Top() ;
	x0 = varstack.TmPush (*lvalp->location) ;
	if (opr == T_Assign) {
	    if (heap_area.CopyValue (x, &varstack, &rvalue) < 0)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	    *locp = loc ;
	} else if (opr == T_RefAssign) {
	    rvalue = *x ;
	    *locp = loc ;
	} else if (x0->IsReal ()) {
	    switch (opr)
	    {
	      case T_AddAssign:	rvalue = x0->value + x->ForceReal() ; break ; // += 
	      case T_SubAssign:	rvalue = x0->value - x->ForceReal() ; break ; // -= 
	      case T_MultAssign:rvalue = x0->value * x->ForceReal() ; break ; // *= 
	      case T_DivAssign:
		if (x->ForceReal() == 0.0)
		    return ThrowSystemException (divisionByZeroException) ;
		rvalue = x0->value / x->ForceReal() ;
		break ;
	      default: return SetErrorCode (INVALID_EXPRESSION) ;
	    }
	} else if (x0->IsInteger()) {
	    switch (opr) {
	      case T_AddAssign:	rvalue = x0->intval + x->ForceInt() ; break ; // += 
	      case T_SubAssign:	rvalue = x0->intval - x->ForceInt() ; break ; // -= 
	      case T_MultAssign:rvalue = x0->intval * x->ForceInt() ; break ; // *= 
	      case T_OrAssign:
		if (!x->IsInteger())
		    return SetErrorCode (INVALID_EXPRESSION) ;
		rvalue = (x0->intval | x->intval) ;
		break ;
	      case T_AndAssign:
		if (!x->IsInteger())
		    return SetErrorCode (INVALID_EXPRESSION) ;
		rvalue = (x0->intval & x->intval) ;
		break ;
	      case T_XorAssign:
	        if (!x->IsInteger())
		    return SetErrorCode (INVALID_EXPRESSION) ;
		rvalue = (x0->intval ^ x->intval) ;
		break ;
	      case T_DivAssign:
	      case T_ModAssign:
		if ((x->ForceInt()) == 0)
		    return ThrowSystemException (divisionByZeroException) ;
		if (opr == T_DivAssign)
		    rvalue = x0->intval / x->ForceInt() ;
		else
		    rvalue = x0->intval % x->ForceInt() ;
		break ;
	      case T_LshAssign:	rvalue = x0->intval << x->ForceInt() ; break ; // <<=
	      case T_RshAssign:	rvalue = x0->intval >> x->ForceInt() ; break ; // <<=
	      default: return SetErrorCode (INVALID_EXPRESSION) ;
	    }
	} else if (x0->IsString()) {
	    if (opr == T_AddAssign) {
		s = x->ForceString () ;
		stmp = heap_area.AllocString (strlen (x0->sval()) + strlen(s) +1,
					      &varstack) ;
		if (!stmp)
		    return SetErrorCode (NOT_ENOUGH_MEMORY) ;
		strcpy (stmp, lvalp->location->sptr) ;
		strcat (stmp, x->sptr) ;
		rvalue = stmp ;
	    } else if (opr == T_MultAssign) {
		int slen = strlen (x0->sptr) ;
		int nums = x->ForceInt () ;
		stmp = heap_area.AllocString (slen * nums + 1, &varstack) ;
		if (!stmp)
		    return SetErrorCode (NOT_ENOUGH_MEMORY) ;
		int i, j ;
		for (i = j = 0 ; i < nums ; i++, j += slen)
		    strcpy (stmp + j, x0->sptr) ;
		rvalue = stmp ;
	    } else {
		return SetErrorCode (INVALID_STRING_OPERATION) ;
	    }
	} else if (x0->IsArray()) {
	    int hst ;
	    switch (opr) {
	      case T_DivAssign:
		if (!x->IsNumber() && !x->IsString())
		    return SetErrorCode (INVALID_EXPRESSION) ;
		hst = heap_area.RemoveArray (x0, x->ForceInt(), &varstack, &rvalue) ;
		break ;
	      case T_AddAssign:
		if (!x->IsArray())
		    return SetErrorCode (INVALID_EXPRESSION) ;
		hst = heap_area.ConsArray (x0, x, &varstack, &rvalue) ;
		break ;
	      case T_LshAssign:
		hst = heap_area.AppendArray (x0, x, &varstack, &rvalue) ;
		break ;
	      case T_SubAssign:
		hst = heap_area.RemoveArray (x0, x, &varstack, &rvalue) ;
		break ;
	      case T_RshAssign:
		if (!x->IsNumber() && !x->IsString())
		    return SetErrorCode (INVALID_EXPRESSION) ;
		hst = heap_area.PopArray (x0, x->ForceInt(), &varstack, &rvalue) ;
		break ;
	      case T_MultAssign:
		hst = heap_area.AddArray (x0, x, &varstack, &rvalue) ;
		break ;
	      default:
		return SetErrorCode (INVALID_EXPRESSION) ;
	    }
	    if (hst < 0)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	} else {
	    return SetErrorCode (INVALID_EXPRESSION) ;
	}
	vp = lvalp->location ;
	varstack.LPop() ;
	*vp = rvalue ;
	lip->valp = vp ;
	varstack.TmPop(2) ;
	varstack.TmPush(rvalue) ;
	return st ;
    }
}

Instance *CmmInterp::NewInstance (char *classname)
{
    Value *cp ;

    cp = varstack.LookupVar (classname) ;
    if (!cp || !cp->IsClass())
	return NULL ;
    return CreateInstance (cp->classp) ;
}

Instance *CmmInterp::NewInstance (char *classname, Value *args, int numargs)
{
    int st ;
    int framepsave ;
    int stackpsave ;
    Instance *ip ;
    Value x ;
    Value *entry ;
    int i ;
    VarType vtype ;

    ip = NewInstance (classname) ;
    if (!ip)
	return NULL ;
    entry = ip->FindMember (NULL, creatorSym, &vtype) ;
    if (!entry)
	return NULL ;

    x = ip ;
    varstack.TmPush (x) ;
    Value *instance = varstack.Top () ;

    framepsave = varstack.FramePtr () ;
    stackpsave = varstack.StackPtr () ;

    varstack.SetFramePtr (varstack.StackPtr()) ;
    varstack.TmPush (*instance) ;
    for (i = 0 ; i < numargs ; i++) {
	varstack.TmPush (args[i]) ;
    }
    st = CallCreator (instance->instance->classp->classnamep,
		      entry, instance, numargs+1) ;
    if ((st < 0) || st == EXIT || st == THROW) return NULL ;

    varstack.SetFramePtr (framepsave) ;
    varstack.SetStackPtr (stackpsave) ;

    return varstack.Pop().instance ;
}

Instance *CmmInterp::CreateInstance (Class *cp)
{
    int num_slots = cp->offset + cp->num_instvars ;
    Instance *instancep ;
    Value *cpp ;
    Value *vslot ;

    // K[xWRNVĂl.... 
    cpp = varstack.TmPush (cp) ;
    instancep = heap_area.AllocInstance (num_slots, &varstack, &vslot) ;

    instancep->num_slots = num_slots ;
    instancep->classp = cpp->classp ;
    if (num_slots == 0)
	instancep->instance_values = NULL ;
    else
	instancep->instance_values = vslot ;
    varstack.TmPop () ;
    return instancep ;
}

// while  
int CmmInterp::WhileStatement (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    int st ;
    Value tf ;
    LexInfo li ;
    int loopPC ;
    int loopEndPC ;
    LocInfo loc ;

    if (!skip)
	locp->Reset () ;
    // Pass1: [vJnʒuƃ[vEoʒu𓾂 
    loopPC = prog->GetPC() ;
    t = Lex (&li) ;
    if (t != T_Lpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    t = Lex (&li) ;
    loc.Reset () ;
    st = Assign (t, &li, &loc, 1) ;
    CHECKST_EX(st) ;
    t = Lex (&li) ;
    if (t != T_Rpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    t = Lex (&li) ;
    loc.Reset () ;
    st = Statement (t, &li, &loc, 1) ;
    CHECKST_EX(st) ;
    if (skip)
	return st ; /* in skip case processing is done */

    // get address of the end of loop
    loopEndPC = prog->GetPC() ;

    // Pass2: [vs 
    varstack.TmPush () ;
    locp->Reset () ;
    lip->valp = NULL ;

    while (1) {
	prog->Set (loopPC) ;
	// ̌vZ 
	t = Lex (&li) ;
	loc.Reset() ;
	st = Assign (t, &li, &loc, skip) ;
	CHECKST_EX(st) ;
	tf = varstack.VPop() ;
	if (!tf.True())
	    break ;
	// [v{̂̎s 
	t = Lex (lip) ;
	varstack.TmPop(1) ;
	locp->Reset () ;
	st = Statement (t, lip, locp, skip) ;
	CHECKST_EX(st) ;
	if (st == BREAK || st == RETURN) {
	    if (st == BREAK)
		st = 0 ;
	    break ;
	}
    }
    prog->Set (loopEndPC) ;
    return st ;
}

// for  
int CmmInterp::ForStatement (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    int forstartPC ;
    int condPC ;
    int resetPC ;
    int bodyPC ;
    int loopEndPC ;
    LexInfo li ;
    int st ;
    Value tf ;
    int exprcnt ;
    LocInfo loc ;

    if (!skip)
	locp->Reset () ;
    if (Lex (&li) != T_Lpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    //================================================================
    // Pass 1: xAskip [hŃXLāAWv|CgT 
    //================================================================
    // ݒ莮 
    forstartPC = prog->GetPC () ;
    for (exprcnt = 0 ; ; exprcnt++) {
	t = Lex (&li) ;
	if (t == T_Eos) {
	    if (exprcnt != 0)
		return SetErrorCode (SYNTAX_ERROR) ;
	    break ;
	}
	loc.Reset () ;
	st = Assign (t, &li, &loc, 1) ;	CHECKST_EX(st) ;
	t = Lex (&li) ;
	if (t == T_Comma)
	    continue ;
	if (t == T_Eos)
	    break ;
	return SetErrorCode (SYNTAX_ERROR) ;
    }
   //  
    condPC = prog->GetPC() ;
    t = Lex (&li) ;
    if (t != T_Eos) {
	loc.Reset () ;
	st = Assign (t, &li, &loc, 1) ;	CHECKST_EX (st) ;
	t = Lex (&li) ;
    }
    if (t != T_Eos)
	return SetErrorCode (SYNTAX_ERROR) ;
    // Đݒ莮 
    resetPC = prog->GetPC() ;
    for (exprcnt = 0 ; ; exprcnt++) {
	t = Lex (&li) ;
	if (t == T_Rpar) {
	    if (exprcnt != 0)
		return SetErrorCode (SYNTAX_ERROR) ;
	    break ;
	}
	loc.Reset () ;
	st = Assign (t, &li, &loc, 1) ;	CHECKST_EX (st) ;
	t = Lex (&li) ;
	if (t == T_Comma)
	    continue ;
	if (t == T_Rpar)
	    break ;
	return SetErrorCode (SYNTAX_ERROR) ;
    }
    // [v{ 
    bodyPC = prog->GetPC() ;
    t = Lex (&li) ;
    loc.Reset () ;
    st = Statement (t, &li, &loc, 1) ; CHECKST_EX(st) ;
    loopEndPC = prog->GetPC () ;
    if (skip)
	return 0 ;

    //================================================================
    // Pass 2: [v̎s 
    //================================================================
    // ܂ for ( expr, expr ... ;
    prog->Set (forstartPC) ;
    while (1) {
	t = Lex (&li) ;
	if (t == T_Eos)
	    break ;
	loc.Reset () ;
	st = Assign (t, &li, &loc, skip) ;
	CHECKST_EX(st) ;
	varstack.TmPop(1) ;
	if (st == EXIT)
	    goto end_of_for_loop ;
	t = Lex (&li) ;
	if (t == T_Comma)
	    continue ;
	if (t == T_Eos)
	    break ;
	return SetErrorCode (SYNTAX_ERROR) ;
    }
    varstack.TmPush () ;
    while (1) {
	// [v 
	prog->Set (condPC) ;
	t = Lex (&li) ;
	if (t != T_Eos) {
	    loc.Reset () ;
	    st = Assign (t, &li, &loc, skip) ;
	    CHECKST_EX(st) ;
	    if (st == EXIT)
		goto end_of_for_loop ;
	    tf = varstack.VPop () ;
	    if (!tf.True()) {
		break ;
	    }
	}
	// [v{ 
	prog->Set (bodyPC) ;
	t = Lex (lip) ;
	locp->Reset () ;
	varstack.TmPop(1) ;
	st = Statement (t, lip, locp, skip) ;
	CHECKST_EX(st) ;
	if (st == BREAK || st == RETURN || st == EXIT || st == THROW) {
	    if (st == BREAK)
		st = 0 ;
	    break ;
	}
	// Ďs 
	prog->Set (resetPC) ;
	while (1) {
	    t = Lex (&li) ;
	    if (t == T_Rpar)
		break ;
	    loc.Reset () ;
	    st = Assign (t, &li, &loc, skip) ;
	    varstack.TmPop(1) ;
	    CHECKST_EX(st) ;
	    if (st == EXIT)
		goto end_of_for_loop ;
	    t = Lex (&li) ;
	    if (t == T_Comma)
		continue ;
	    if (t == T_Rpar)
		break ;
	    return SetErrorCode (SYNTAX_ERROR) ;
	}
    }
  end_of_for_loop:
    prog->Set (loopEndPC) ;
    return st ;
}

int CmmInterp::TryCatchStatement (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    int do_skip ;
    Value *retp ;
    int spsave = varstack.StackPtr () ;
    int retst = 0 ;
    int tryst ;
    int st ;
    int found_finally = 0 ;
    Value *einstance ;
    int tryStartPC ;
    int catchStartPC ;
    int do_finally = 0 ;

    // ܂ASKIP ŁAcatch ̃X^[gʒu𓾂 
    tryStartPC = prog->GetPC () ;
    t = Lex (lip) ;
    st = Statement (t, lip, locp, 1) ;

    //  catch \̃X^[gʒu 
    catchStartPC = prog->GetPC () ;

    if (!skip) {
	// Ƃɖ߂āAx͎s 
	prog->Set (tryStartPC) ;
	t = Lex (lip) ;
	locp->Reset () ;
	st = Statement (t, lip, locp, skip) ;
	if (st == EXIT || st < 0)
	    return st ;
	retst = st ;
	tryst = st ;
    }
    if (skip) {
	do_skip = 1 ;
    } else {
	Value *vp ;

	do_skip = 0 ;
	retst = st ;
	retp = varstack.Top () ;
	varstack.SetStackPtr (spsave) ;
	varstack.TmPush (*retp) ;

	if (st == THROW) {
	    einstance = varstack.Top () ;
	    if (!einstance->IsInstance()
		|| !einstance->instance->classp->FindClass (exceptionClassSym, &vp))
	    {
		return SetErrorCode (INVALID_OBJECT) ;
	    }
	} else {
	    do_skip = 1 ;
	    do_finally = 1 ;
	}
    }
    prog->Set (catchStartPC) ;
    for (;;) {
	t = Lex (lip) ;
	if (t != T_Catch && t != T_Finally) {
	    PutBack () ;
	    break ;
	}
	if (t == T_Catch) {
	    int skip_statement = 1 ;

	    if (found_finally)
		return SetErrorCode (SYNTAX_ERROR) ;
	    t = Lex (lip) ;
	    if (t != T_Lpar)
		return SetErrorCode (SYNTAX_ERROR) ;
	    t = Lex (lip) ;
	    if (t != T_Word)
		return SetErrorCode (SYNTAX_ERROR) ;
	    if (!do_skip) {
		Value *exception_class ;
		Value *real_classp ;

		exception_class = varstack.LookupVar (varname) ;
		if (!exception_class || !exception_class->IsClass())
		    return SetErrorCode (UNDEFINED_CLASS) ;
		if (einstance->instance->FindClass
		    		(NULL,
				 exception_class->classp->classnamep->sym,
				 &real_classp))
		{
		    skip_statement = 0 ;
		}
	    }
	    t = Lex (lip) ;
	    if (t != T_Word)
		return SetErrorCode (SYNTAX_ERROR) ;
	    if (!skip_statement) {
		varstack.SetSymSimple (spsave, varsymbol) ;
	    }
	    t = Lex (lip) ;
	    if (t != T_Rpar)
		return SetErrorCode (SYNTAX_ERROR) ;
	    t = Lex (lip) ;
	    locp->Reset () ;
	    st = Statement (t, lip, locp, skip_statement) ;
	    CHECKST_EX(st) ;
	    if (!skip_statement) {
		retp = varstack.Top () ;
		varstack.SetStackPtr (spsave) ;
		varstack.TmPush (*retp) ;
		if (st == THROW || st == EXIT) {
		    do_skip = skip = 1 ;
		}
		do_finally = 1 ;
		retst = st ;
	    }
	} else if (t == T_Finally) {
	    found_finally = 1 ;
	    if (!do_finally)
		skip = 1 ;
	    if (!skip)
		varstack.SetStackPtr (spsave) ;
	    t = Lex (lip) ;
	    locp->Reset () ;
	    st = Statement (t, lip, locp, skip) ;
	    CHECKST_EX(st) ;
	    if (!skip) {
		if (st == THROW || st == EXIT) {
		    do_skip = skip = 1 ;
		    retst = st ;
		}
	    }
	}
    }
    return retst ;
}

// if  
int CmmInterp::IfStatement (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    Value tf ;
    int   is_true ;
    LexInfo li ;
    int skip_true, skip_false ;
    int st_true, st_false ;
    LocInfo loc ;
    int st ;
    int inexit = 0 ;

    if (!skip)
	locp->Reset () ;
    t = Lex (&li) ;
    if (t != T_Lpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    t = Lex (&li) ;
    loc.Reset () ;
    st = Assign (t, &li, &loc, skip) ;
    CHECKST_EX(st) ;
    t = Lex (&li) ;
    if (t != T_Rpar)
	return SetErrorCode (SYNTAX_ERROR) ;

    if (skip) {
	t = Lex (&li) ;
	st = Statement (t, &li, &loc, 1) ;
	CHECKST_EX(st) ;
	t = Lex (&li) ;
	if (t != T_Else) {
	    PutBack () ;
	    st = 0 ;
	} else {
	    t = Lex (&li) ;
	    st = Statement (t, &li, &loc, 1) ;
	}
	return st ;
    }
    tf = varstack.VPop() ;
    is_true = tf.True () ;

    if (is_true) {
	skip_true = 0 ; skip_false = 1 ;
    } else {
	skip_true = 1 ; skip_false = 0 ;
    }
    t = Lex (&li) ;
    loc.Reset () ;
    st_true = Statement (t, &li, &loc, skip_true) ;
    CHECKST_EX(st_true) ;
    if (!inexit && is_true) {
	*lip  = li ;
	locp->vtype = loc.vtype ;
	varstack.LPush (loc.instancep) ;
	varstack.LPush (loc.classp) ;
	varstack.LPush (loc.varp) ;
    }
    t = Lex (&li) ;
    if (t == T_Else) {
	t = Lex (&li) ;
	loc.Reset () ;
	st_false = Statement (t, &li, &loc, skip_false) ;
	CHECKST_EX(st_false) ;
	if (!inexit && is_true) {
	    locp->varp      = (varstack.LPop ()).location ;
	    locp->classp    = (varstack.LPop ()).location ;
	    locp->instancep = (varstack.LPop ()).location ;
	}
	if (!inexit && !is_true) {
	    *lip = li ;
	    *locp = loc ;
	}
    } else {
	PutBack () ;
	if (!inexit && is_true) {
	    varstack.LPop () ;
	    varstack.LPop () ;
	    varstack.LPop () ;
	}
	if (!inexit && !is_true) {
	    varstack.TmPush () ;
	    lip->valp = NULL ;
	    locp->Reset () ;
	    st_false = 0 ;
	}
    }
    return (inexit) ? EXIT : (is_true) ? st_true : st_false ;
}

// ֐`  -- 
int CmmInterp::FuncDef (Token t, LexInfo *lip, LocInfo *locp, int skip, int is_func)
{
    LexInfo li ;
    Value fname ;

    if (is_func && !skip && (exec_mode != ExInterp) && has_compiler) {
	// exec_mode  AcInterp, AcCompiler ̏ꍇ́AA-Code ɃRp 
	// C 
	Value form ;
	int st ;
	st = AcFuncDef (t, lip, Ac_InFunc, &form, 1) ; CHECKST_EX(st) ;
	st = AcExecForm (&form, locp) 		     ; CHECKST_EX(st) ;
	return 0 ;
    }
    if (Lex (&li) != T_Word)
	return SetErrorCode (SYNTAX_ERROR) ;
    // ֐ -- 
    if (!skip) {
	if (heap_area.CopyValue (namep, &varstack, &fname) < 0)
	    return SetErrorCode (NOT_ENOUGH_MEMORY) ;

	// ֐̈ʒu(Context)X^bNɐς -- 
	Context ctx = *prog ;
//#TEST#
#if 0
	if (is_func)
	    ctx.DefineFunc () ;
	else
	    ctx.DefineMacro () ;
#endif
//#TEST#
	Value *fmp ;
	fmp = varstack.Push (fname.sptr, ctx) ;
	fmp->subtype = (is_func) ? CTX_FUNCTION : CTX_MACRO ;
    }
    if (Lex (&li) != T_Lpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    //  
    SkipBody (1) ;
    Value x ;
    x = *varstack.Top () ;
    if (!skip) {
	varstack.TmPush(x) ;
    }
    return 0 ;
}

// \bh` --
int CmmInterp::MethoDef (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    LexInfo li ;
    Value *vp ;
    int slot ;
    Token methtype ;
    int is_creator ;

    if (!skip && (exec_mode != ExInterp) && has_compiler) {
	// exec_mode  AcInterp ̏ꍇ́AA-Code ɃRpC 
	int st ;
	Value form ;
	st = AcMethoDef (t, lip, Ac_InMethod, &form) ; CHECKST_EX(st) ;
	st = AcExecForm (&form, locp) ;		       CHECKST_EX(st) ;
	return 0 ;
    }
    methtype = t ;
    if (Lex (&li) != T_Word)
	return SetErrorCode (SYNTAX_ERROR) ;
    // NX̃T[` --
    if (!skip) {
	vp = varstack.LookupVar (li.symbol->symbol) ;
	if (!vp || !vp->IsClass()) {
	    return SetErrorCode (UNDEFINED_CLASS) ;
	}
    }
    t = Lex (&li) ;
    if (t != T_ColonColon) {
	return SetErrorCode (SYNTAX_ERROR) ;
    }
    // \bh̃T[` 
    t = Lex (&li) ;
    if (t != T_Word) {
	return SetErrorCode (SYNTAX_ERROR) ;
    }
    is_creator = 0 ;
    if (li.symbol == creatorSym) {
	if (methtype != T_Method)
	    return SetErrorCode (SYNTAX_ERROR) ;
	is_creator = 1 ;
    }
    if (li.symbol == disposerSym) {
	vp->classp->have_disposer = 1 ;
    }
    if (!skip) {
	VarType vtype ;
	if ((slot = vp->classp->FindMyEntry (varsymbol, &vtype)) < 0) {
	    vtype = (methtype == T_Method) ? VT_Method : VT_Hiden ;
	    if ((slot = AllocMethodSlot (vp, varsymbol, vtype)) < 0)
		return -1 ;
	}
	if (vtype != VT_Method && vtype != VT_Hiden)
	    return SetErrorCode (INVALID_MEMBER) ;
	// ֐̈ʒu(Context)X^bNɐς 
	Context ctx = *prog ;
	if (is_creator)
	    vp->classp->SetCreator (slot, ctx) ;
	else
	    vp->classp->SetMethod (slot, ctx) ;
    }
    if (Lex (&li) != T_Lpar)
	return SetErrorCode (SYNTAX_ERROR) ;

    if (is_creator)
	SkipCreatorBody (1) ;
    else
	SkipBody (1);
    if (!skip) {
	varstack.TmPush() ;
    }
    return 0 ;
}

int CmmInterp::ExecMacro (Value *macrop, int skip)
{
    int st ;
    Value *mexpanded ;
    int shrinkp ;
    Token t ;
    LexInfo li ;
    LocInfo loc ;

    st = ExpandMacro (macrop, skip) ;
    CHECKST_EX(st) ;
    if (skip)
	return 0 ;
    mexpanded = varstack.Top () ;
    shrinkp = varstack.TopIndex () ;
    Context *retadr = prog ;

    prog = SetContext (mexpanded->sptr, 0) ;
    t = Lex (&li) ;
    st = Statement (t, &li, &loc, skip) ;
    CHECKST_EX(st) ;
    varstack.Shrink (shrinkp, 2) ;

    prog = retadr ;
    return st ;
}

//----------------------------------------------------------------
// }NWJ 
//	C^[v^ł̂ݎg 
//----------------------------------------------------------------
int CmmInterp::ExpandMacro (Value *macrop, int skip)
{
    Token t ;
    LexInfo li ;
    int argstart ;
    int argend ;
    int spsave = varstack.StackPtr () ;
    int m_body_startPC ;
    int m_body_endPC ;
    int argstartSP ;
    Context *macroadr ;
    Context *returnadr ;
    Value *mvar_startp ;
    Value *mvar_endp ;
    Value *mexpanded ;
    int numargs ;
    int st ;
    int argc, pp ;
    char *s ;
    Value v ;
    int i, j ;
    LocInfo loc ;
    int par_rev  ;
    int c ;

    varstack.TmPush (macrop->context) ;
    macroadr    = &(varstack.Top()->context) ;
    mvar_startp = varstack.SP () ;
    argstartSP  = varstack.StackPtr () ;
    // }N̏B𕶎񉻂ăX^bNɐς 
    if (Lex (&li) != T_Lpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    for (numargs = 0 ; ; ) {
	argend = argstart = prog->GetPC() ;
	par_rev = 0 ;
	while (1) {
	    c = prog->GetC () ;
	    if (!c)
		return SetErrorCode (SYNTAX_ERROR) ;
	    if ((c == '/' && prog->PeekC() == '/') || c == '#')
	    {
		while ((c = prog->GetC()) && c != '\n')
		    ;
		continue ;
	    }
	    if (par_rev == 0 && (c == ',' || c == ')')) {
		argend = prog->GetPC () - 1 ;
		break ;
	    }
	    if (iskanji(c)) {
		c = prog->GetC () ;
		continue ;
	    }
	    switch (c) {
	      case '(':
		par_rev++ ;
		break ;
	      case ')':
		par_rev-- ;
		break ;
	      case '[':
		t = T_Lbl ;
		Term (t, &li, &loc, 1) ;
		break ;
	      case '"' :
	      case '\'':
		prog->Back (1) ;
		Lex (&li) ;
		break ;
	      case '\\':
		c = prog->GetC () ;
		if (iskanji(c))
		    c = prog->GetC () ;
		break ;
	      default:
		;
	    }
	}
#if 0
	while (1) {
	    t = Lex (&li) ;
	    if (par_rev == 0 && (t == T_Comma || t == T_Rpar))
		break ;
	    argend = prog->GetPC () ;
	}
#endif
	if (!skip) {
	    // ߂ƏI̋󔒂JbgB 
	    for (; argstart < argend && isspace (prog->text[argstart]) ; argstart++)
		;
	    for (--argend ; argend >= argstart && isspace(prog->text[argend]) ; argend--)
		;
	    argend++ ;
	    s = heap_area.AllocString (argend - argstart + 1, &varstack) ;
	    for (i = 0, j = argstart ; j < argend ; i++, j++)
		s[i] = prog->text[j] ;
	    s[i] = '\0' ;
	    v = s ;
	    varstack.TmPush (v) ;
	}
	numargs++ ;
#if 0
	if (t == T_Rpar)
	    break ;
#endif
	if (c == ')')
	    break ;
    }
    if (skip)
	return 0 ;

    returnadr = prog ;
    // }N`ɔ 
    prog = macroadr ;
    mvar_endp = varstack.SP () ;
    if (Lex (&li) != T_Lpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    // }NɖO 
    for (argc = 0, pp = argstartSP ; pp < varstack.Max() ; argc++, pp++) {
	t = Lex (&li) ;
	if (t == T_Rpar) {
	    if (argc != 0)
		return SetErrorCode (SYNTAX_ERROR) ;
	    break ;
	}
	if (t != T_Word)
	    return SetErrorCode (SYNTAX_ERROR) ;
	if (argc < numargs) {
	    varstack.SetSymbol (pp, li.symbol) ;
	}
	t = Lex (&li) ;
	if (t == T_Comma)
	    continue ;
	if (t == T_Rpar)
	    break ;
	return SetErrorCode (SYNTAX_ERROR) ;
    }
    m_body_startPC = prog->GetPC () ;
    t = Lex (&li) ;
    loc.Reset () ;
    st = Statement (t, &li, &loc, 1) ;
    CHECKST_EX(st) ;
    m_body_endPC = prog->GetPC () ;

    char *ss = heap_area.AllocString (m_body_endPC - m_body_startPC + 1, &varstack) ;
    ss[0] = '\0' ;

    mexpanded = varstack.TmPush (ss) ;
    prog->Set (m_body_startPC) ;
    int copyfrom ;
    // }NWJ 
    while (1) {
	Value *vp ;
	copyfrom = prog->GetPC () ;
	if (copyfrom >= m_body_endPC)
	    break ;
	t = Lex (&li) ;
	if (t == T_Word
	    && (vp = LookupVar (varsymbol))
	    && vp >= mvar_startp && vp < mvar_endp)
	{
	    if (AddStr (mexpanded, vp) < 0) {
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	    }
#if 0
	    if (AddChar (mexpanded, '"') < 0
		|| AddStrQuoted (mexpanded, vp) < 0
		|| AddChar (mexpanded, '"') < 0)
	    {
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	    }
#endif
	} else if (t == T_ArgList) {
	    if (AddChar (mexpanded, '[') < 0)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	    for (j = argstartSP ; j < argstartSP + numargs ; j++) {
		if (AddChar (mexpanded, '"') < 0
		    || AddStrQuoted  (mexpanded, varstack.Peek(j)) < 0
		    || AddChar (mexpanded, '"') < 0)
		{
		    return SetErrorCode (NOT_ENOUGH_MEMORY) ;
		}
	    }
	    if (AddChar (mexpanded, ']') < 0)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	} else if (t == T_ArgCnt) {
	    char cnts[20] ;
	    sprintf (cnts, "%d", numargs) ;
	    if (AddStr (mexpanded, cnts) < 0)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	} else {
	    if (AddStr (mexpanded, prog, copyfrom, prog->GetPC ()) < 0)
		return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	}
    }
    Value x ;
    x = varstack.VPop () ;
    varstack.SetStackPtr (spsave) ;
    varstack.TmPush (x) ;
    prog = returnadr ;
    return st ;
}

int CmmInterp::FunCall (char *str, Value *entp, LocInfo *locp)
{
    int st ;
    int framepsave = varstack.FramePtr () ;
    int stackpsave = varstack.StackPtr () ;
    int numargs ;
    Context *calladr ;
    Value x ;
    BuiltinFunc builtin = NULL ;
    BuiltinMethod bimethod = NULL ;
    int method = 0 ;
    Value *acfuncp = NULL ;

    if (str) {
	// 萔֐ 
	// "(a, b) { a + b }" (10, 20) ; 
	//    ^ ^ ֐{  ^ 
	calladr = SetContext (str, 0) ;
    } else if (entp) {
	if (entp->IsContext()) {
	    // ʏ̊֐ macro or Class method 
	    if (entp->subtype == CTX_MACRO  /* entp->context.IsMacro() */)
		return ExecMacro (entp, 0) ;
	    if (entp->subtype == CTX_METHOD /* entp->context.IsMethod() */) {
		method++ ;
		varstack.TmPush (entp->context) ;
		calladr = &(varstack.Top()->context) ;
	    } else {
		varstack.TmPush (entp->context) ;
		calladr = &(varstack.Top()->context) ;
	    }
	} else if (entp->IsString()) {
	    // ֐ 
	    calladr = SetContext (entp->sptr, 0, CTX_FUNCTION) ;
	    if (locp->vtype == VT_Method)
		method++ ;
	} else if (entp->IsBiMethod()) {
	    if (!locp->instancep /* ||!locp->instancep->IsInstance() */)
		return SetErrorCode (SYNTAX_ERROR) ;
	    method++ ;
	    bimethod = entp->bimethod ;
	} else if (entp->IsBuiltin()) {
	    // gݍ݊֐ 
	    builtin = entp->entry ;
	} else if (entp->IsArray()) {
	    if (locp->vtype == VT_Method)
		method++ ;
	    acfuncp = varstack.TmPush (entp->arr) ;
	} else {
	    return SetErrorCode (BAD_FUNCTION_OR_METHOD) ;
	}
    }
    // newfp = varstack.StackPtr () ;
    varstack.SetFramePtr (varstack.StackPtr()) ;
    st = PushArgs (0, locp->instancep, &numargs) ;
    CHECKST_EX(st) ;
    // varstack.SetFramePtr (newfp) ;
    LocInfo loc ;

    if (builtin) {
	st = (*builtin) (this, varstack.FrameSize(), varstack.GetFrame(), &x) ;
	if (st < 0)
	    return SetErrorCode (FUNCALL_ERROR) ;
    } else if (bimethod) {
	st = (*bimethod) (this, locp->instancep, varstack.FrameSize(), varstack.GetFrame(), &x) ;
	if (st < 0)
	    return SetErrorCode (METHODCALL_ERROR) ;
    } else if (acfuncp) {
	if (!has_compiler){
	    return SetErrorCode (COMPILER_NOT_INSTALLED) ;
	}
	st = AcCallForm (acfuncp,
			 numargs,
			 (method) ? locp->instancep : NULL,
			 (method) ? locp->classp : NULL,
			 &loc) ;
	CHECKST_EX(st) ;
	x = varstack.VPop () ;
    } else {
	st = CallContext (calladr,
			  numargs,
			  (method) ? locp->instancep : NULL,
			  (method) ? locp->classp : NULL,
			  &loc) ;
	CHECKST_EX(st) ;
	x = varstack.VPop () ;
    }
    if (st != EXIT && st != THROW) {
	// t[|C^AX^bN|C^̕A 
	// ^[lZbg
	varstack.SetFramePtr (framepsave) ;
	varstack.SetStackPtr (stackpsave) ;
	varstack.TmPush (x) ;
	*locp = loc ;
	return NORMAL ;
    }
    return st ;
}

int CmmInterp::FunCall (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    int st ;
    LexInfo li ;

    if (!skip)
	locp->Reset () ;
    t = Lex (&li) ;
    if (t != T_Lpar && t != T_Word && t != T_String && t != T_PointTo && t != T_ColonColon)
	return SetErrorCode (SYNTAX_ERROR) ;
    if (t == T_String) {
	if (skip)
	    st = PushArgs (skip, 0) ;
	else
	    st = FunCall (li.sval, locp) ;
	CHECKST_EX(st) ;
    } else {
	st = VarValue (t, &li, skip, locp) ;
	CHECKST_EX(st) ;
    }
    return st ;
}

int CmmInterp::PushArgs (int skip, Value *ip, int *numargsp)
{
    int     st ;
    Token   t ;
    LexInfo li ;
    LocInfo loc ;
    int     numargs ;
    Value   *thisp ;
    int retst = 0 ;

    if (Lex (&li) != T_Lpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    if (skip) {
	for ( ; ; ) {
	    int par_rev = 0 ;
	    int c ;
	    while (1) {
		c = prog->GetC () ;
		if (!c)
		    return SetErrorCode (SYNTAX_ERROR) ;
		if (c == '$' && (prog->PeekC() == '#')) {
		    c = prog->GetC () ;
		    continue ;
		}
		if ((c == '/' && prog->PeekC() == '/')
		    || c == '#')
		{
		    while ((c = prog->GetC()) && c != '\n')
			;
		    continue ;
		}
		if (par_rev == 0 && (c == ',' || c == ')')) {
		    break ;
		}
		if (iskanji(c)) {
		    c = prog->GetC () ;
		    continue ;
		}
		switch (c) {
		  case '(':    par_rev++ ;    break ;
		  case ')':    par_rev-- ;    break ;
		  case '[':
		    t = T_Lbl ;
		    Term (t, &li, &loc, 1) ;
		    break ;
		  case '"' :
		  case '\'':
		    prog->Back (1) ;
		    Lex (&li) ;
		    break ;
		  case '\\':
		    c = prog->GetC () ;
		    if (iskanji(c))
			c = prog->GetC () ;
		    break ;
		  default:
		    ;
		}
	    }
	    if (c == ')')
		break ;
	}
	return 0 ;
#if 0
	for (numargs = 0 ; ; ) {
	    while (1) {
		t = Lex (&li) ;
		if (t == T_Comma || t == T_Rpar)
		    break ;
		loc.Reset () ;
		st = Assign (t, &li, &loc, 1) ;
		CHECKST_EX(st) ;
	    }
	    numargs++ ;
	    if (t == T_Rpar)
		break ;
	}
#endif
    } else {
	st = NORMAL ;
	varstack.SetFramePtr (varstack.StackPtr()) ;
	// X^bNɐς 
	numargs = 0 ;
	if (ip) {
	    thisp = varstack.TmPush (*ip /* ip->instance */) ;
	    numargs++ ;
	} else {
	    thisp = NULL ;
	}
	for ( ; ; ) {
	    t = Lex (&li) ;
	    if (t == T_Rpar)
		break ;
	    loc.Reset () ;
	    st = Assign (t, &li, &loc, skip) ;
	    CHECKST_EX(st) ;
	    if (!skip && st != NORMAL) {
		skip = 1 ;
		retst = st ;
	    }
	    numargs++ ;
	    t = Lex (&li) ;
	    if (t != T_Comma)
		break ;
	}
    }
    if (t != T_Rpar) {
	return SetErrorCode (SYNTAX_ERROR) ;
    }
    if (numargsp)
	*numargsp = numargs ;
    return st ;
}

int CmmInterp::CallContext (Context *calladr, int numargs, Value *thisp, Value *classp, LocInfo *locp)
{
    // ֐{(ʒu) ɃWv 
    int retPC = prog->GetPC() ;
    int callPC = calladr->GetPC() ;
    LexInfo li ;
    Token t ;
    Context *returnadr ;
    int st ;
    int argindexsave ;
    int argcntsave ;
    Value *thisptrsave ;
    Value *classptrsave ;
    LocInfo loc ;

    returnadr = prog ;
    prog = calladr ;
    // lɁAoCh 
    st = SetNames (numargs, varstack.FramePtr(), (int)thisp) ; CHECKST_EX(st) ;
    argindexsave = argindex ;
    argcntsave   = argcnt ;
    thisptrsave  = thisptr ;
    classptrsave = classptr ;

    argindex     = varstack.FramePtr() ;
    argcnt       = numargs ;
    if (thisp) {
	thisptr = varstack.Peek (varstack.FramePtr()) ;
    } else {
	thisptr = NULL ;
    }
    classptr     = classp ;

    t = Lex (&li) ;
    loc.Reset () ;
    st = Statement (t, &li, &loc, 0) ;
    CHECKST_EX(st) ;

    argindex = argindexsave ;
    argcnt = argcntsave ;
    thisptr = thisptrsave ;
    classptr = classptrsave ;
    // ĂяoɕԂ 
    calladr->Set (callPC) ;
    prog = returnadr ;
    prog->Set (retPC) ;
    *locp = loc ;
    return (st == EXIT) ? EXIT : ((st == THROW) ? THROW : NORMAL) ;
}

int CmmInterp::SetNames (int numargs, int startsp, int method)
{
    Token t ;
    LexInfo li ;
    int endpp = startsp + numargs ;
    int pp = startsp ;
    char *s ;

    t = Lex (&li) ;
    if (t != T_Lpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    if (method) {
	varstack.SetName (pp, "this") ;
	pp++ ;
    }
    t = Lex (&li) ;
    if (t == T_Rpar)
	return 0 ;
    for ( ; ; pp++, t = Lex (&li)) {
	if (t != T_Word)
	    return SetErrorCode (SYNTAX_ERROR) ;
	if (pp < endpp)
	    varstack.SetSymbol (pp, li.symbol) ;
	t = Lex (&li) ;
	if (t == T_Comma) {
	    continue ;
	} else if (t == T_Rpar) {
	    break ;
	} else {
	    return SetErrorCode (SYNTAX_ERROR) ;
	}
    }
    return 0 ;
}

int CmmInterp::SkipBody (int checksep)
{
    Token t ;
    LexInfo li ;
    LocInfo loc ;
    int st ;

    //  
    if ((st = SkipArgList ()) < 0)
	return st ;
    // ֐{́A̓XLbv 
    t = Lex (&li) ;
    loc.Reset () ;
    if (Statement (t, &li, &loc, 1, checksep) < 0)
	return -1 ;
    return 0 ;
}

int CmmInterp::SkipCreatorBody (int cheksep)
{
    Token t ;
    LexInfo li ;
    LocInfo loc ;
    int st ;

    if ((st = SkipArgList ()) < 0)
	return st ;
    t = Lex (&li) ;
    if (t == T_Colon) {
	if ((st = PushArgs (1, 0)) < 0)
	    return st ;
	t = Lex (&li) ;
    }
    loc.Reset () ;
    if (Statement (t, &li, &loc, 1, cheksep) < 0)
	return -1 ;
    return 0 ;
}

int CmmInterp::SkipArgList ()
{
    Token t ;
    LexInfo li ;

    //  
    for ( ; ; ) {
	t = Lex (&li) ;
	if (t == T_Rpar)
	    break ;
	if (t != T_Word)
	    return SetErrorCode (SYNTAX_ERROR) ;
	t = Lex (&li) ;
	if (t == T_Comma)
	    continue ;
	if (t == T_Rpar)
	    break ;
	return SetErrorCode (SYNTAX_ERROR) ;
    }
    return 0 ;
}

//----------------------------------------------------------------
// NX` 
// Cmm NX̃f[^\ 
//
// Class
//
//  +---------------------------------------+
//  |                                       |
//  +--> +----+--------+     +--------------|------+
// stack |name|classptr----->|superclass    |      |
//       +----|+--------+ +->|classnamep ---+      |
//            |           |  |offset               |
// +----------+           |  |num_members    (Classȏ) 
// |                      |  |num_cvs_methods(Classϐ(static)ƃ\bh̐) 
// +---> Class          |  |num_instvars   (Instanceϐ(private/public)̐) 
//                        |  |class_template -----------+
//                        |  |class_vars_or_methods--+  |
//                        |  +---------------------+ |  |
//                        +------------------+       |  |
// +-----------------------------------------|----------+
// |	 oev[g		     |       |
// +-> +-------+-----+----+ ^		     | +-----+ Value class ̔z 
//     |iv_type|index|name--->"member_name1" | |  +-------+ ^
//     +-------+-----+----+ |		     | +->|	  | |
//     |iv_type|index|name| |		     |	  |	  | num_cvs_methods
//     +-------+-----+----+ |num_members     |	  |	  | |
//     |iv_type|index|name| |		     |	  +-------+ v
//     +-------+-----+----+ |                |	    staic/method GA 
//     |iv_type|index|name| |		     | 
//     +-------+-----+----+ v                | 
//   * iv_type ̓oϐ̎            | 
//     (VT_Method, VT_ClassVar(static)       | 
//      VT_Private,VT_Public ̂ꂩ)     | 
//   * index ́Aiv_type VT_Method         | 
//     VT_ClassVar ̂Ƃ́Astatic/method   | 
//     GÃCfbNXAVT_Private      | 
//     VT_PubliĉƂ́AInstance ̕ϐ    | 
//     GÃCfbNX                  | 
//   * oev[ǵA2T[`     |
//     ł悤ɁAname Ń\[gĂ   |
//                                           | 
// Instance                                  | 
//          X^bN                         | 
//    +-----+--------+   +---------------+   | 
//    |name+|instance--->|classp ------------+ 
//    +----|+--------+   |num_slots (classp炽ǂnum_instvars̑) 
//	   |	         |instance_values-->+--------+ ^ 
//  +------+	         +---------------+  |        | | 
//  |				            |        | | 
//  +---> Instance		            |        | | 
//				            |        | num_slots 
//                                          |        | | 
//                      InstanceϐGA  |        | | 
//                      (Value class̔z) |        | | 
//                                          +--------+ v 
//---------------------------------------------------------------- 
int CompareClassTemplate (const void *pa, const void *pb)
{
    return (int)(((Class::ClassMemberTemplate *)pa)->name_sym)
		- (int)(((Class::ClassMemberTemplate *)pb)->name_sym) ;
}

int CmmInterp::ClassDef (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    LexInfo li ;
    char *s ;
    Value *superclass = NULL ;
    Variable *varp ;
    int i ;
    Token ctype ;
    LocInfo loc ;

    t = Lex (&li) ;
    if (t != T_Word) {
	return SetErrorCode (SYNTAX_ERROR) ;
    } else if (!skip) {
	// X^bNɃNX`GAmہB܂A`{̂͂Ȃ 
	varp = varstack.Push (li.symbol, (Class *)NULL) ;
    }
    t = Lex (&li) ;
    if (t == T_Colon) {
	// X[p[NX`Ă 
	t = Lex (&li) ;
	if (t != T_Word) {
	    return SetErrorCode (SYNTAX_ERROR) ;
	} else if (!skip) {
	    if (!(superclass = varstack.LookupVar (varsymbol)))
		return SetErrorCode (UNDEFINED_CLASS) ;
	    if (!superclass->IsClass ())
		return SetErrorCode (SYNTAX_ERROR) ;
	    if (IsSpecialClass (superclass))
		return SetErrorCode (INVALID_SUPER_CLASS) ;
	}
	t = Lex (&li) ;
    } else {
	superclass = classClass ;
    }
    if (t != T_Lbr) {
	return SetErrorCode (SYNTAX_ERROR) ;
    }
    //
    // Pass 1. static, private, method ̒`Ă鐔𒲂ׂ 
    //
    int defPC = prog->GetPC () ;
    int num_slot = 0 ;
    int num_cvs_methods = 0 ;
    int num_inst_vars = 0 ;
    int is_creator = 0 ;
    int is_disposer = 0 ;
    int has_creator = 0 ;

    for (;;) {
	t = Lex (&li) ;
	if (t == T_Rbr) {
	    break ;
	}
        if (t != T_Static && t != T_Private
	    && t != T_Public && t != T_Method && t != T_Hiden)
	{
	    return SetErrorCode (SYNTAX_ERROR) ;
	}
	ctype = t ;
	t = Lex (&li) ;
	for (;;) {
	    if (t != T_Word) {
		return SetErrorCode (SYNTAX_ERROR) ;
	    } else {
		num_slot++ ;
	    }
	    is_creator = is_disposer = 0 ;
	    if (ctype == T_Static || ctype == T_Method || ctype == T_Hiden) {
		num_cvs_methods++ ;
		if (li.symbol == creatorSym) {
		    if (ctype != T_Method)
			return SetErrorCode (SYNTAX_ERROR) ;
		    has_creator++ ;
		    is_creator = 1 ;
		}
	    } else {
		num_inst_vars++ ;
	    }
	    t = Lex (&li) ;
	    if (t == T_Lpar) {
		if (ctype != T_Method && ctype != T_Hiden)
		    return SetErrorCode (SYNTAX_ERROR) ;
		if (is_creator) {
		    if (SkipCreatorBody (0) < 0)
			return -1 ;
		} else {
		    if (SkipBody (0) < 0)
			return -1 ;
		}
		t = Lex (&li) ;
	    } else if (t == T_Assign) {
		int st ;

		if (ctype != T_Static)
		    return SetErrorCode (SYNTAX_ERROR) ;
		t = Lex (&li) ;
		st = Assign (t, &li, &loc, 1) ;
		CHECKST_EX(st) ;

		t = Lex (&li) ;
	    }

	    if (t == T_Eos) {
		break ;
	    } else if (t == T_Comma) {
		if (is_creator)
		    return SetErrorCode (SYNTAX_ERROR) ;
		t = Lex (&li) ;
	    } else {
		if (t == T_Static || t == T_Private
		    || t == T_Public || t == T_Method || t == T_Hiden
		    || t == T_Rbr )
		{
		    PutBack () ;
		}
		break ;
	    }
	}
    }
    if (has_creator > 1)
	return SetErrorCode (TOO_MANY_CREATOR) ;
    if (skip) {
	return 0 ;
    }
    // NG[^`Ȃ 
    if (has_creator == 0) {
	num_slot++ ;
	num_cvs_methods++ ;
    }
    //----------------------------------------------------------------
    // Class ̖{́A static private, method GÅm 
    //----------------------------------------------------------------
    // Class NX{ 
    Class *classp ;
    classp = heap_area.AllocClass (&varstack) ;
    // ȉANXoe[uƂAstatic/method Xbgr 
    // ŁAK[xWRNVȂ悤ɁAuvƏ 
    if (!classp) {
	return SetErrorCode (NOT_ENOUGH_MEMORY) ;
    }
    classp->have_disposer = 0 ;
    if (superclass) {
	classp->superclass = superclass->classp ;
	classp->offset = superclass->classp->offset + superclass->classp->num_instvars ;
    } else {
	classp->superclass = NULL ;
	classp->offset = 0 ;
    }
    classp->num_members	= classp->num_cvs_methods = classp->num_instvars = 0 ;
    classp->class_template = NULL ;
    classp->class_vars_or_methods = NULL ;
    //----------------------------------------------------------------
    // Class {̂X^bÑGA|CgB 
    // ̌Aclassp ́AK[xWRNVňʒu\ 
    // ̂ŁAX^bNoR (varp ʂ)QƂB 
    //----------------------------------------------------------------
    *varp = classp ;
    classp->classnamep = varp ;
    // NXoe[u̍쐬 
    Class::ClassMemberTemplate *class_member_p ;
    class_member_p
	= (Class::ClassMemberTemplate *)heap_area.AllocSegment
	    				(sizeof(Class::ClassMemberTemplate) * num_slot,
					 &varstack) ;
    if (!class_member_p)
	return SetErrorCode (NOT_ENOUGH_MEMORY) ;
    varp->classp->class_template = class_member_p ;

    // Class ϐ (static ϐ) ƃ\bĥ߂̃Xbg̍쐬
    if (num_cvs_methods > 0) {
	Value *cvs_method_p ;

	cvs_method_p = (Value *)heap_area.AllocSegment
	    				(sizeof(Value) * num_cvs_methods,
					 &varstack) ;
	if (!cvs_method_p)
	    return SetErrorCode (NOT_ENOUGH_MEMORY) ;
	for (i = 0 ; i < num_cvs_methods ; i++)
	    cvs_method_p[i].Init() ;
	varp->classp->class_vars_or_methods = cvs_method_p ;
    }
    //----------------------------------------------------------------
    // Pass 2. oϐA\bhXbg̐ݒ 
    //----------------------------------------------------------------
    int cvs_method_idx = 0 ;
    int inst_var_idx = 0 ;
    int num_static_initializer = 0 ;

    prog->Set (defPC) ;
    for (i = 0 ; ; ) {
	ctype = t = Lex (&li) ;
	if (t == T_Rbr)
	    break ;
	t = Lex (&li) ;
	varp->classp->num_members = i ;
	for (;;) {
	    if (t != T_Word)
		fprintf (stderr, "BUG in CmmInterp::ClassDef\n") ;
	    Symbol *member_sym ;
	    // o̐ݒ 
	    member_sym = li.symbol ;
	    varp->classp->class_template[i].iv_type
		= (  (ctype == T_Static)  ? VT_ClassVar
		   : (ctype == T_Method)  ? VT_Method
		   : (ctype == T_Hiden)   ? VT_Hiden
		   : (ctype == T_Private) ? VT_Private
		   : 			    VT_Public ) ;
	    varp->classp->class_template[i].name_sym = member_sym ;
	    if (ctype == T_Static || ctype == T_Method || ctype == T_Hiden) {
		varp->classp->class_template[i].index = cvs_method_idx++ ;
		varp->classp->num_cvs_methods = cvs_method_idx ;
	    } else {
		varp->classp->class_template[i].index = inst_var_idx++ ;
		varp->classp->num_instvars = inst_var_idx ;
	    }
	    varp->classp->num_members = ++i ;

	    is_creator  = ((ctype == T_Method) && (li.symbol == creatorSym)) ;
	    is_disposer = (li.symbol == disposerSym) ;

	    int funcPC = prog->GetPC () ;
	    t = Lex (&li) ;
	    if (t == T_Lpar) {
		// \bh{̂`Ă 
		if (is_disposer) {
		    varp->classp->have_disposer = 1 ;
		}
		if (exec_mode != ExInterp && has_compiler) {
		    Symbol *classnamesym ;
		    Symbol *methodnamesym ;
		    Value form ;

		    classnamesym  = varp->sym ;
		    methodnamesym = member_sym ;

		    PutBack () ;
		    if (is_creator) {
			if (AcCreatorBody (classnamesym, methodnamesym, &form) < 0)
			    return -1 ;
		    } else {
			if (AcMethodBody (classnamesym, methodnamesym, &form) < 0)
			    return -1 ;
		    }
		    varp->classp->class_vars_or_methods [cvs_method_idx-1] = form.arr ;
		    t = Lex (&li) ;
		} else {
		    Context ctx ;
		    ctx.Set (prog->text, funcPC) ;
		    varp->classp->class_vars_or_methods [cvs_method_idx-1] = ctx ;
		    varp->classp->class_vars_or_methods [cvs_method_idx-1].subtype
			= (is_creator) ? CTX_CREATOR : CTX_METHOD ;
		    if (is_creator) {
			SkipCreatorBody (0) ;
		    } else {
			SkipBody (0) ;
		    }
		    t = Lex (&li) ;
		}
	    } else if (t == T_Assign) {
		int st ;
		varp->classp->class_vars_or_methods[cvs_method_idx-1] = *prog ;
		varp->classp->class_vars_or_methods[cvs_method_idx-1].subtype
		    = CTX_STATIC_INITIALIZER ;
		t = Lex (&li) ;
		st = Assign (t, &li, &loc, 1) ; // Skip
		CHECKST_EX(st) ;
		num_static_initializer++ ;
		t = Lex (&li) ;
	    } else if (is_creator) {
		// NG[^̃Gg`Ă邪A̖{
		// ȂB̏ꍇ́AkNG[^Zbg
		Context ctx ;
		ctx.Set (nullCreator, 0) ;
		varp->classp->class_vars_or_methods[cvs_method_idx-1] = ctx ;
		varp->classp->class_vars_or_methods[cvs_method_idx-1].subtype
		    = CTX_CREATOR ;
	    }
	    if (t == T_Eos) {
		break ;
	    } else if (t == T_Comma) {
		t = Lex (&li) ;
	    } else {
		if (t == T_Static    || t == T_Private
		    || t == T_Public || t == T_Method
		    || t == T_Hiden
		    || t == T_Rbr)
		{
		    PutBack () ;
		}
		break ;
	    }
	}
    }
    if (has_creator == 0) {
	// NG[^GgȂ
	Context ctx ;
	ctx.Set (nullCreator, 0) ;
	varp->classp->class_template[i].name_sym  = creatorSym ;
	varp->classp->class_template[i].iv_type   = VT_Method ;
	varp->classp->class_template[i].index     = cvs_method_idx ;
	varp->classp->num_members = ++i ;
	varp->classp->class_vars_or_methods [cvs_method_idx] = ctx ;
	varp->classp->class_vars_or_methods [cvs_method_idx].subtype = CTX_CREATOR ;
	varp->classp->num_cvs_methods = ++cvs_method_idx ;
    }
    qsort (varp->classp->class_template,
	   (size_t)varp->classp->num_members,
	   (size_t)sizeof (Class::ClassMemberTemplate),
	   CompareClassTemplate) ;
    Value x = *varp ;

    if (num_static_initializer > 0) {
	Value *classptrsave = classptr ;
	Value *thisptrsave = thisptr ;
	Context *progSave = prog ;
	int st ;

	classptr = varp ;
	thisptr = varp ;
	for (i = 0 ; i < num_cvs_methods ; i++) {
	    if (varp->classp->class_vars_or_methods[i].subtype != CTX_STATIC_INITIALIZER)
		continue ;
	    prog = SetContext (varp->classp->class_vars_or_methods[i].context.text,
			       varp->classp->class_vars_or_methods[i].context.PC) ;
	    loc.Reset() ;
	    t = Lex (&li) ;
	    st = Assign (t, &li, &loc, 0) ;
	    CHECKST_EX(st) ;
	    varp->classp->class_vars_or_methods[i] = varstack.VPop () ;
	    varp->classp->class_vars_or_methods[i].subtype = CTX_NONE ;
	    varstack.TmPop () ;
	}

	classptr = classptrsave ;
	thisptr  = thisptrsave ;
	prog = progSave ;
    }

    varstack.TmPush (x) ;
    return 0 ;
}

int CmmInterp::AllocMethodSlot (Value *vp, Symbol *method_symbol, VarType methtype)
{
    int i ;
    Class::ClassMemberTemplate *newTemplate ;
    int num_slots = vp->classp->num_members ;
    int num_cvs_methods = vp->classp->num_cvs_methods ;
    int newindex ;

    newindex = num_cvs_methods ;

    newTemplate	= (Class::ClassMemberTemplate *)heap_area.AllocSegment
			(sizeof(Class::ClassMemberTemplate) * (num_slots + 1),
			 &varstack) ;
    if (!newTemplate)
	return SetErrorCode (NOT_ENOUGH_MEMORY) ;
    for (i = 0 ; i < num_slots ; i++)
	newTemplate[i] = vp->classp->class_template[i] ;
    newTemplate[i].iv_type	= methtype ;
    newTemplate[i].name_sym	= method_symbol ;
    newTemplate[i].index	= newindex ;
    vp->classp->class_template	= newTemplate ;
    vp->classp->num_members	= num_slots + 1 ;

    Value *cvs_method_p = (Value *)heap_area.AllocSegment
					(sizeof(Value) * (num_cvs_methods + 1),
					 &varstack) ;
    if (!cvs_method_p)
	return SetErrorCode (NOT_ENOUGH_MEMORY) ;
    for (i = 0 ; i < num_cvs_methods ; i++)
	cvs_method_p[i] = vp->classp->class_vars_or_methods[i] ;
    cvs_method_p[i].Init () ;

    vp->classp->num_cvs_methods = num_cvs_methods + 1 ;
    vp->classp->class_vars_or_methods = cvs_method_p ;
    qsort (vp->classp->class_template,
	   (size_t)vp->classp->num_members,
	   (size_t)sizeof (Class::ClassMemberTemplate),
	   CompareClassTemplate) ;
    VarType dum ;
    newindex = vp->classp->FindMyEntry (method_symbol, &dum) ;
    return newindex ;
}

// ϐ` 
int CmmInterp::VarDef  (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    LexInfo li ;
    Value x ;
    int st ;
    Value *varp ;
    Symbol *var_symbol ;
    LocInfo loc ;

    for (;;) {
	t = Lex (&li) ;
	if (t != T_Word)
	    return SetErrorCode (SYNTAX_ERROR) ;
	if (!skip) {
	    x.Init () ;
	    varp = varstack.Push (li.symbol, x) ;
	}
	t = Lex (&li) ;
#if 0
	if (t == T_Lbl) {
	    // zTCYw肳Ă 
	    Value *arr ;

	    index = ArrIndex (t, -1, skip) ;
	    if (index < 0)
		return SetErrorCode (SYNTAX_ERROR) ;
	    if (!skip) {
		if (heap_area.AllocArray (index, &varstack, &arr) < 0)
		    return SetErrorCode (NOT_ENOUGH_MEMORY) ;
		for (int i = 0 ; i < index ; i++)
		    arr[i].Init() ;
		varp->InitArr (arr, index) ;
	    }
	    t = Lex (&li) ;
	}
#endif
	if (t == T_Assign || t == T_RefAssign) {
	    //  
	    t = Lex (&li) ;
	    loc.Reset () ;
	    st = Assign (t, &li, &loc, skip) ;
	    CHECKST_EX(st) ;
	    if (!skip)
		x = *varp = varstack.VPop() ;
	    t = Lex (&li) ;
	}
	if (t != T_Comma) {
	    PutBack () ;
	    break ;
	}
    }
    if (!skip)
	varstack.TmPush(x) ;
    return 0 ;
}

// \[Xt@C̃[fBO 
int CmmInterp::Load (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    LexInfo li ;
    Value x ;
    char *buffer ;
    int st ;
    int shrink ;
    LocInfo loc ;

    if (!skip)
	locp->Reset () ;
    if (Lex (&li) != T_Lpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    t = Lex (&li) ;
    loc.Reset () ;
    st = Statement (t, &li, &loc, skip) ;
    CHECKST_EX(st) ;
    if (Lex (&li) != T_Rpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    if (skip)
	return st ;
    //
    int loaded ;
    Value vname ;
    vname = varstack.VPop () ;
    if (!vname.IsString())
	return ThrowSystemException (typeMismatchException) ;
    if ((loaded = LoadText (vname.sptr, &buffer)) < 0) {
	fprintf (stderr, "%s: ", vname.sptr) ;
	return ThrowSystemException (fileLoadException) ;
    }
    if (loaded) {
	varstack.TmPush (1) ;
    } else {
	int acode = 0 ;
	if (!strncmp (buffer, ACODE_HEADER, strlen(ACODE_HEADER))) {
	    acode++ ;
	}
	Context *lastProgContext = prog ;
	int     lastLastPC = lastPC ;

	if (acode) {
	    Value form ;
	    if (!has_compiler) {
		return SetErrorCode (COMPILER_NOT_INSTALLED) ;
	    }
	    st = AcParseACode (buffer, &form) ; CHECKST_EX(st) ;
	    st = AcExecute (&form) ; CHECKST_EX(st) ;
	    locp->Reset () ;
	} else {
	    prog = SetContext (buffer, 0) ;
	    shrink = varstack.TopIndex() ;

	    lastPC = prog->GetPC() ;
	    st = Program (&x, &loc) ;
	    CHECKST_EX(st) ;
	    *locp = loc ;
	    varstack.Shrink(shrink, 1) ; // remove loaded source 
	    varstack.TmPush (x) ;
	}
	prog   = lastProgContext ;
	lastPC = lastLastPC ;
    }
    return st ;
}

int CmmInterp::LoadText (char *srcp, char **bufferp)
{
    Value *xp ;
    int flen ;
    Value *vp ;
    int found ;
    char *file ;
    int psize ;
    int i, j ;
    int fd ;
    char *buffer ;
    int rsize ;
    static char *suffixes_for_compiler[] = {"", ".ac", ".cmm"} ;
    static char *suffixes_for_interp  [] = {"", ".cmm"};
    int filesize ;

    int   nsufs ;
    char **suffixes ;

    if (has_compiler) {
	nsufs = ARRSIZE(suffixes_for_compiler) ;
	suffixes = suffixes_for_compiler ;
    } else {
	nsufs = ARRSIZE(suffixes_for_interp) ;
	suffixes = suffixes_for_interp ;
    }
    if (!(file = FindCmmFile ("loadPath", srcp, suffixes, nsufs, &filesize))) {
	return -1 ;
    }
    Value *moduleP = varstack.LookupVar ("__loadedModules") ;
    Value *srcP    = varstack.LookupVar ("__loadedSources") ;
    if (!moduleP) {
	fprintf (stderr, "Predefined Variable __loadedModules is not defined!!\n") ;
    }
    //================================================================
    // Check already loaded 
    //================================================================
    int numodules = moduleP->arr.numelems ;

    for (i = 0 ; i < numodules ; i++) {
	if (!strcmp (moduleP->arr.arrp[i].sptr, file)) {
	    return 1 ;
	}
    }
    Value *xpath ;
    Value ret ;
    Value *bufp ;
    int is_acode = 0 ;

    xpath = varstack.TmPush (file) ;
    if (heap_area.AppendArray (moduleP, xpath, &varstack, &ret) < 0)
	return SetErrorCode (NOT_ENOUGH_MEMORY) ;
    *moduleP = ret ;

    if ((fd = open (xpath->sptr, O_RDONLY)) < 0)
	return -1 ;
    // \[XR[hi[GAm
    int addlen = strlen (xpath->sptr) + 10 ;
    //int addlen = 0 ;

    if (!(buffer = heap_area.AllocSegment (filesize + addlen + 1, &varstack))) {
	close (fd) ;
	return SetErrorCode (NOT_ENOUGH_MEMORY) ;
    }
    // ܂At@C̐擪݁AA-Code \[XR[h𔻒fB
    rsize = read (fd, buffer, strlen(ACODE_HEADER)) ;
    if (rsize >= strlen(ACODE_HEADER)
	&& !strncmp (buffer, ACODE_HEADER, strlen(ACODE_HEADER)))
    {
	is_acode = 1 ;
    }
    lseek (fd, 0, SEEK_SET) ;
    
    // \[XR[hGȀ 
    for (i = 0 ; i < filesize + addlen + 1 ; i++)
	buffer[i] = 0 ;
    if (!is_acode) {
	sprintf (buffer, "//##%s\n", xpath->sptr) ;
    }
    // \[XR[h̓ǂݍ 
    rsize = read (fd, buffer + strlen(buffer), filesize) ;
    Value newsrc, *newsrcP ;

    newsrc = buffer ;
    newsrcP = varstack.TmPush (buffer) ;
    if (heap_area.AppendArray (srcP, newsrcP, &varstack, srcP) < 0)
	return SetErrorCode (NOT_ENOUGH_MEMORY) ;
    buffer = newsrcP->sptr ;
    if (rsize < 0) {
	close (fd) ;
	return -1 ;
    }
    close (fd) ;
    varstack.TmPop() ;
    *bufferp = buffer ;
    return 0 ;
}

//----------------------------------------------------------------
// CmmInterp::Package   binary package ̃[h
//----------------------------------------------------------------
int CmmInterp::Package (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    LexInfo li ;
    Value x ;
    char *buffer ;
    int st ;
    LocInfo loc ;
    char *pkgname ;
 
    if (!skip)
	locp->Reset () ;
    if (Lex (&li) != T_Lpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    t = Lex (&li) ;
    loc.Reset () ;
    st = Statement (t, &li, &loc, skip) ;
    CHECKST_EX(st) ;
    if (Lex (&li) != T_Rpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    if (skip)
	return st ;
    //
    int loaded ;
    Value vname ;
    vname = varstack.VPop () ;
    if (!(pkgname = vname.GetString())) {
	return ThrowSystemException (typeMismatchException) ;
    }
    if (LoadPackage (vname.sptr) < 0) {
	return ThrowSystemException (packageLoadException) ;
    }
    varstack.TmPush (1) ; // Set return status
    return NORMAL ;
}

int CmmInterp::LoadPackage (char *pkgname)
{
    static char *suffixes[] = {"", ".pkg", ".so" } ;
    static char installerName [] = "Install" ;
    Value *loadedPackageP ;
    char  *pkgpath ;
    Value *pkgpathP ;
    Value *pkgnameP ;
    Value *initializerP ;
    int  filesize ;
    void *handle ;
    Installer installer ;
    Value ret ;
    int  shrink ;
    int  i ;
    
    pkgpath = FindCmmFile ("packagePath", pkgname,
			   suffixes, ARRSIZE(suffixes), &filesize) ;

    if (!pkgpath) {
	return -1 ;
    }
    pkgpathP = varstack.TmPush (pkgpath) ;
    shrink = varstack.TopIndex () ;
    
    loadedPackageP = varstack.LookupVar ("__loadedPackages") ;
    if (!loadedPackageP) {
	fprintf (stderr, "Internal Error: predefined variable __loadedPackages is missing\n") ;
	exit(1);
    }
    for (i = 0 ; i < loadedPackageP->arr.numelems ; i++) {
	if (!strcmp (pkgpath, loadedPackageP->arr.arrp[i].sptr)) {
	    varstack.TmPop () ;
	    return 0 ;
	}
    }
    if (!pkgpath) {
	return -1 ; // Tempolary --> error or exception
    }
    Context *progSave = prog ;
    handle = dlopen (pkgpath, RTLD_LAZY) ;

    if (!handle) {
	fprintf (stderr, "dlopen: %s\n", dlerror()) ;
	return -1 ;
    }
    if (!(installer = (Installer)dlsym (handle, installerName))) {
	dlclose (handle) ;
	return -1 ;
    }
    if ((*installer)(this) < 0) {
	dlclose (handle) ;
	return -1 ;
    }
    prog = progSave ;
    if (heap_area.AppendArray (loadedPackageP, pkgpathP, &varstack, loadedPackageP) < 0) {
	dlclose (handle) ;
	return -1 ;
    }
    varstack.Shrink (shrink, 1) ;
    return 0 ;
}

char *CmmInterp::FindCmmFile (char *path_varname, char *filehead,
			    char **suffixes, int sufcnt, int *filesizep)
{
    Value *pathp ;
    Value *fileheadp ;
    int   fileheadlen = strlen(filehead) ;
    char  *filepath ;
    int maxsuflen = 0 ;
    int i, j ;
    int pathlen ;
    struct stat fst ;
    char *ret ;
    int found ;

    fileheadp = varstack.TmPush (filehead) ;
    
    for (i = 0 ; i < sufcnt ; i++) {
	int len = strlen(suffixes[i]) ;
	if (len > maxsuflen)
	    maxsuflen = len ;
    }
    if (fileheadp->sptr[0] == '/') {
	pathp = NULL ; // Full Path
    } else {
	pathp = varstack.LookupVar (symbolTable->GetSymbol(path_varname)) ;
    }
    filepath = heap_area.AllocString (MAXPATHLEN + 1 + strlen(filehead) + maxsuflen + 2, &varstack) ;

    found = -1 ;
    // JgfBNgTB
    for (i = 0 ; i < sufcnt && found < 0 ; i++) {
	char *pathp ;
	
	getcwd (filepath, MAXPATHLEN) ;
	pathp = filepath + strlen(filepath) ;
	sprintf (pathp, "/%s%s",	 fileheadp->sptr, suffixes[i]) ;
	if (stat (filepath, &fst) >= 0) {
	    varstack.TmPop() ;
	    *filesizep = fst.st_size ;
	    return filepath ;
	}
    }
    if (!pathp) {
	// pXݒ肳ĂȂ̂ŁAȏ͒TȂ
	return NULL ;
    }
    if (pathp->IsString()) {
	int addpathsep = 0 ;
	if (pathp->sptr[strlen(pathp->sptr)-1] == '/') {
	    pathlen = strlen(pathp->sptr) + fileheadlen + maxsuflen + 2 ;
	} else {
	    addpathsep = 1 ;
	    pathlen = strlen(pathp->sptr) + fileheadlen + maxsuflen + 3 ;
	}
	filepath = heap_area.AllocString (pathlen, &varstack) ;
	for (j = 0 ; found < 0 && j < sufcnt ; j++) {
	    if (addpathsep)
		sprintf (filepath, "%s/%s%s",
			 pathp->sptr, fileheadp->sptr, suffixes[j]) ;
	    else
		sprintf (filepath, "%s%s%s",
			 pathp->sptr, fileheadp->sptr, suffixes[j]) ;
	    found = stat (filepath, &fst) ;
	}
    } else if (pathp->IsArray()) {
	found = -1 ;
	for (i = 0 ; found < 0 && i < pathp->arr.numelems ; i++) {
	    if (!pathp->arr.arrp[i].IsString())
		continue ;
	    char *apath = pathp->arr.arrp[i].sptr ;
	    if (apath[strlen(apath)-1] == '/') {
		pathlen = strlen(apath) + fileheadlen + maxsuflen + 2 ;
		filepath = heap_area.AllocString (pathlen, &varstack) ;
		if (!filepath)
		    return (char *)SetErrorCode (NOT_ENOUGH_MEMORY) ;
		for (j = 0 ; found < 0 && j < sufcnt ; j++) {
		    sprintf (filepath, "%s%s%s",
			     pathp->arr.arrp[i].sptr, fileheadp->sptr, suffixes[j]) ;
		    found = stat (filepath, &fst) ;
		}
	    } else {
		pathlen = strlen (apath) + fileheadlen + maxsuflen + 3 ;
		filepath = heap_area.AllocString (pathlen, &varstack) ;
		if (!filepath)
		    return (char *)SetErrorCode (NOT_ENOUGH_MEMORY) ;
		for (j = 0 ; found < 0 && j < sufcnt ; j++) {
		    sprintf (filepath, "%s/%s%s",
			     pathp->arr.arrp[i].sptr, fileheadp->sptr, suffixes[j]) ;
		    found = stat (filepath, &fst) ;
		}
	    }
	}
    }
    if (found) {
	*filesizep = fst.st_size ;
	ret = filepath ;
    } else {
	ret = NULL ;
    }
    varstack.TmPop () ;
    return ret ;
}

// eval  
int CmmInterp::Eval (Token t, LexInfo *lip, LocInfo *locp, int skip)
{
    int st ;
    LexInfo li ;
    Value x ;
    Value xp ;
    int shrink ;
    LocInfo loc ;

    if (Lex (&li) != T_Lpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    t = Lex (&li) ;
    loc.Reset () ;
    st = Assign (t, &li, &loc, skip) ;
    CHECKST_EX(st) ;
    if (Lex (&li) != T_Rpar)
	return SetErrorCode (SYNTAX_ERROR) ;
    // skip ꍇ͂ŏI 
    if (skip)
	return st ;

    lip->valp = li.valp ;
    *locp = loc ;
    xp = varstack.VPop () ;
    if (xp.IsString()) {
	Context *lastProgContext = prog ;
	int     lastLastPC = lastPC ;

	// Context ̐؂ւ 
	prog = SetContext (xp.sptr, 0) ;
	lastPC = 0 ;

	shrink = varstack.TopIndex() ;

	loc.Reset () ;
	st = Program (&x, &loc) ;
	CHECKST_EX(st) ;

	*locp = loc ;
	varstack.Shrink (shrink, 1) ;
	varstack.TmPush (x) ;
	// Context ̕A 
	prog   = lastProgContext ;
	lastPC = lastLastPC ;
    } else if (xp.IsSymbol()) {
	Context *lastProgContext = prog ;
	int     lastLastPC = lastPC ;

	// Context ̐؂ւ 
	prog = SetContext (xp.symbol->symbol, 0) ;
	lastPC = 0 ;

	shrink = varstack.TopIndex() ;

	loc.Reset () ;
	st = Program (&x, &loc) ;
	CHECKST_EX(st) ;

	*locp = loc ;
	varstack.Shrink (shrink, 1) ;
	varstack.TmPush (x) ;
	// Context ̕A 
	prog   = lastProgContext ;
	lastPC = lastLastPC ;
    } else if (xp.IsArray () && has_compiler) {
	st = AcExecute (&xp) ;
	CHECKST_EX(st) ;
    } else {
	SetErrorCode (INVALID_EXPRESSION) ;
	return -1 ;
    }
    return st ;
}

//  ... قƂ͎ǁA܂ 
int CmmInterp::Statement (Token t, LexInfo *lip, LocInfo *locp, int skip, int checksep)
{
    int st ;
    LexInfo li ;
    Value x ;
    int st0 ;
    int do_skip ;
    int spsave ;
    LocInfo loc ;
    Token brk_ret_exit ;

    switch (t) {
      case T_If:        st = IfStatement    (t, lip, locp, skip)   ; break ;
      case T_While:     st = WhileStatement (t, lip, locp, skip)   ; break ;
      case T_For:	st = ForStatement   (t, lip, locp, skip)   ; break ;
      case T_Try:	st = TryCatchStatement (t, lip, locp, skip) ; break ;
      case T_Vardef:    st = VarDef         (t, lip, locp, skip)   ; break ;
      case T_Class:     st = ClassDef       (t, lip, locp, skip)   ; break ;
      case T_Method:
      case T_Hiden:	st = MethoDef       (t, lip, locp, skip)   ; break ;
      case T_Func:      st = FuncDef        (t, lip, locp, skip, 1); break ;
      case T_Macro:	st = FuncDef        (t, lip, locp, skip, 0); break ;
      case T_Load:	st = Load           (t, lip, locp, skip)   ; break ;
      case T_Package:   st = Package	    (t, lip, locp, skip)   ; break ;
      case T_Break:
      case T_Return:
      case T_Exit:
	brk_ret_exit = t ;
	t = Lex(&li) ;
	if (t != T_Eos) {
	    st = Assign (t, &li, locp, skip) ;
	    CHECKST_EX(st) ;
	} else {
	    PutBack () ;
	    if (!skip)
		varstack.TmPush() ;
	}
	st = (skip) ?  NORMAL :
			(brk_ret_exit == T_Break) ? BREAK
			    : (brk_ret_exit == T_Exit) ? EXIT 
				: RETURN ;
	break ;
      case T_Throw:
	t = Lex (&li) ;
        st = Assign (t, &li, locp, skip) ;
	CHECKST_EX(st) ;
	if (skip) {
	    return st ;
	} else {
	    if (st != EXIT)
		st = THROW ;
	}
	break ;
      case T_Continue:
	if (!skip)
	    varstack.TmPush () ;
	st = (!skip) ? CONTINUE : NORMAL ;
	break ;
      case T_Lbr:
	st = st0 = NORMAL ;
	do_skip = skip ;
	spsave = varstack.StackPtr () ;
	if (!skip) {
	    varstack.TmPush() ;
	    lip->valp = NULL ;
	    loc.Reset () ;
	}
	for (;;) {
	    t = Lex (&li) ;
	    if (t == T_Eof)
		return SetErrorCode (SYNTAX_ERROR) ;
	    if (t == T_Rbr)
		break ;
	    if (!do_skip)
		x = varstack.VPop () ;
	    loc.Reset () ;
	    st = Statement (t, &li, &loc, do_skip) ;
	    CHECKST_EX(st) ;
	    if (st != NORMAL) {
		st0 = st ;
		do_skip = 1 ;
	    }
	}
	if (!skip) {
	    x = varstack.VPop () ;
	    varstack.SetStackPtr (spsave) ;
	    varstack.TmPush (x) ;
	    *locp = loc ;
	    lip->valp = li.valp ;
	    if (st0 != NORMAL)
		st = st0 ;
	}
	break ;
      case T_LLbr:
	st = st0 = NORMAL ;
	do_skip = skip ;
	if (!skip) {
	    varstack.TmPush() ;
	    lip->valp = NULL ;
	    loc.Reset () ;
	}
	while (1) {
	    t = Lex (&li) ;
	    if (t == T_Eof)
		return SetErrorCode (SYNTAX_ERROR) ;
	    if (t == T_RRbr)
		break ;
	    if (!do_skip)
		x = varstack.VPop () ;
	    loc.Reset () ;
	    st = Statement (t, &li, &loc, do_skip) ;
	    CHECKST_EX(st) ;
	    if (st != NORMAL) {
		st0 = st ;
		do_skip = 1 ;
	    }
	}
	if (!skip) {
	    x = varstack.VPop () ;
	    varstack.TmPush (x) ;
	    *locp = loc ;
	    lip->valp = li.valp ;
	    if (st0 != NORMAL)
		st = st0 ;
	}
	break ;
      case T_Eos:
      case T_Eof:
	if (!skip)
	    varstack.TmPush() ;
	st = 0 ;
	break ;
      case T_Word:
      case T_WorkVar: case T_Pause:
      case T_Plus:   case T_Minus:   case T_Not: case T_Eval:
      case T_Number: case T_IntNumber: case T_String: case T_Symbol:
      case T_Lpar:   case T_ArgPrefix: case T_Void: case T_ArgList:
      case T_ColonColon: case T_PointTo: case T_PP: case T_MM:
      case T_BitRev: case T_Lbl: case T_New: case T_This: case T_Self:
      case T_Position: case T_BoundArg:
	st = Assign (t, lip, locp, skip) ;
        CHECKST_EX(st) ;
	break ;
      case T_Err:
      default:
	return SetErrorCode (SYNTAX_ERROR) ;
    }
    if (checksep) {
	t = Lex (&li) ;
	if (t != T_Eos) {
	    PutBack () ;
	}
    }
    return st ;
}

int CmmInterp::Program (Value *valp)
{
    LocInfo loc ;
    return Program (valp, &loc) ;
}

int CmmInterp::Program (Value *valp, LocInfo *locp)
{
    int    st = 0 ;
    Value retval ;
    Token  t ;
    LexInfo li ;
    LocInfo loc ;

    while (1) {
	t = Lex (&li) ;
	if (t == T_Eof)
	    break ;
	if (t == T_Eos)
	    continue ;
	loc.Reset () ;
	st = Statement (t, &li, &loc, 0, 0) ;
	// st = Assign (t, &li, &loc, 0) ;
	if (st == RETURN || st == EXIT || st == THROW || st < 0)
	    break ;
	retval = varstack.VPop() ;
    }
    *locp = loc ;
    *valp = retval ;
    return st ;
}

Value *CmmInterp::PointArgument (int skip)
{
    Token t ;
    LexInfo li ;
    int st ;
    Value x ;
    int index ;
    LocInfo loc ;

    t = Lex (&li) ;
    if (t == T_Word) {
	if (skip)
	    return (Value *)1 ;
	Value *vp ;
	vp = varstack.LookupVar (varsymbol) ;
	if (!vp) {
	    SetErrorCode (UNDEFINED_IDENTIFIER) ;
	    return NULL ;
	}
	return vp ;
    } else if (t != T_Lbl) {
	SetErrorCode (SYNTAX_ERROR) ;
	return NULL ;
    }
    t = Lex (&li) ;
    st = Assign (t, &li, &loc, skip) ;
    if (st < 0)
	return NULL ;
    if (Lex (&li) != T_Rbl) {
	SetErrorCode (SYNTAX_ERROR) ;
	return NULL ;
    }
    if (skip)
	return (Value *)1 ;
    x = varstack.VPop () ;
    if (!x.IsNumber()) {
	SetErrorCode (INVALID_ARRAY_INDEX) ;
	return NULL ;
    }
    index = x.ForceInt() ;
    if (argindex < 0) {
	SetErrorCode (SYNTAX_ERROR) ;
	return NULL ;
    }
    if (index < 0 || index >= argcnt) {
	SetErrorCode (INVALID_ARRAY_INDEX) ;
	return NULL ;
    }
    return varstack.Peek (argindex + index) ;
}

Value *CmmInterp::ReadSource (char *filename)
{
    FILE *fp ;
    struct stat st ;
    char *buffer ;

    fp = fopen (filename, "r");
    if (!fp) {
	fprintf (stderr, "Cannot read file %s\n", filename) ;
	return NULL ;
    }

    fstat ((int)fileno(fp), &st) ;
    buffer = heap_area.AllocSegment (st.st_size + 1, &varstack) ;
    if (!buffer) {
	fclose (fp) ;
	return NULL ;
    }
    fread (buffer, st.st_size, 1, fp) ;
    buffer [st.st_size] = '\0' ;
    Value *vp ;
    vp = varstack.TmPush(buffer) ;
    return vp ;
}

int CmmInterp::ExecInterp (char *filename)
{
    Value *vp ;

    vp = ReadSource (filename) ;
    if (!vp)
	return -1 ;
    if (!strncmp (vp->sptr, ACODE_HEADER, strlen(ACODE_HEADER))) {
	return ExecACode (vp->sptr) ;
    }
    return Execute (vp->sptr) ;
}

void CmmInterp::HandleSignal (Value *entp, int signo)
{
    Value *entry ;
    Value *namep_save = namep ;
    int   max_namelen_save = max_namelen ;
#if 0
    Value *stringp_save = stringp ;
#endif
    int   max_strlen_save = max_strlen ;
    char *s ;
    Value arg ;
    Value ret ;
    arg = signo ;

    entry = varstack.TmPush (*entp) ;

    max_namelen = 20 ;
    s = heap_area.AllocSegment (max_namelen, &varstack) ;
    if (!s) {
	SetErrorCode (NOT_ENOUGH_MEMORY) ;
	goto END0 ;
    }
    namep = varstack.TmPush (s) ;
#if 0
    max_strlen = 128 ;
    s = heap_area.AllocSegment (max_strlen, &varstack) ;
    if (!s) {
	SetErrorCode (NOT_ENOUGH_MEMORY) ;
	goto END1 ;
    }
    stringp = varstack.TmPush (s) ;
#endif

    Call (entry, (Value *)NULL, &arg, 1, &ret) ;

    varstack.TmPop () ;
  END1:
    varstack.TmPop () ;
  END0:
    varstack.TmPop () ;
    namep = namep_save ;
    max_namelen = max_namelen_save ;
#if 0
    stringp = stringp_save ;
#endif
    max_strlen = max_strlen_save ;
}

int CmmInterp::ExecJIT (char *buf)
{
    fprintf (stderr, "No Compiler\n") ;
    return -1 ;
}

int CmmInterp::ExecCompiler (char *buf)
{
    fprintf (stderr, "No Compiler\n") ;
    return -1 ;
}

/*
 * Local variables:
 * c-indent-level: 4
 * c-continued-statement-offset: 4
 * c-brace-offset: -4
 * c-argdecl-indent: 2
 * c-label-offset:  -2
 * c-auto-newline:   nil
 * end:
 */
